score = {blue = 0, red = 0}
local numberOfAAA = 10
AAAList = {blue = {}, red = {}}
local groupCounter = 2000
local unitCounter = 2000
local pilotDownCounter = {blue = 0,red = 0}
local gruntsCounter = {blue = 0,red = 0}
local pilotCounter = {blue = 0,red = 0}
local A2ACounter = {blue = 0,red = 0}
local HS_opponent = {blue = 'red',red = 'blue'}
local headingTexts = {'north','north-east','east','south-east','south','south-west','west','north-west'}
local factor = 1
local currentSpot = {['JTAC group 1 Unit 1'] = nil,['JTAC group 2 Unit 1'] = nil,['JTAC group 3 Unit 1'] = nil}
chopperInactive = {
							['Pontiac 1-1'] = true,
							['Pontiac 2-1'] = true,
							['Pontiac 3-1'] = true,
							['501'] = true,
							['551'] = true,
							['601'] = true,
						}
slingLoadTasks = {
					blue = 	{
								['Resupply blue Armor Group #3, use 43 MHz FM-homing.\n'] = true,
								['Resupply blue Armor Group #5, use 44 MHz FM-homing.\n'] = true,
								['Resupply blue Armor Group #9, use 45 MHz FM-homing.\n'] = true,
								['Activate FARP Paris, use ATC for navigation.\n'] = true,
								['Activate FARP Dallas, use ATC for navigation.\n'] = true,
								['Activate FARP London, use ATC for navigation.\n'] = true
							},
					red = 	{
								['Resupply red Armor Group #3, use ARC-9 ADF 400 kHz.\n'] = true,
								['Resupply red Armor Group #5, use ARC-9 ADF 450 kHz.\n'] = true,
								['Resupply red Armor Group #9, use ARC-9 ADF 500 kHz.\n'] = true,
								['Activate FARP Otrytka, use ATC for navigation.\n'] = true,
								['Activate FARP Vetka, use ATC for navigation.\n'] = true,
								['Activate FARP Yunga, use ATC for navigation.\n'] = true
							}
				}
local greetingTexts = {
	['A-10C'] = ', eliminate Russian armored divisions. CAS flights are supported by JTAC and AFAC.\nNorth eastern AO: JTAC Axeman, 31 MHz FM, AFAC Enfield 126 MHz AM\nNorth western AO: JTAC Darknight, 32 MHz FM, AFAC Springfield 127 MHz AM\nWestern AO: JTAC Warrier, 33 MHz FM, AFAC Uzi 128 MHz AM.\nUse F-10 menu for JTAC auto-lase.',
	['AV8BNA'] = ', Nellis is on comm 2, channel 1, blue flights are on comm 1, channel 18, AWACs is on comm 1, channel 22',
	['Su-25'] = ', eliminate US armored divisions at your waypoints 1-3.',
	['SA342M'] = ', eliminate Russian armored divisions. CAS flights are supported by JTAC and AFAC.\nNorth eastern AO: JTAC Axeman, 31 MHz FM, AFAC Enfield 126 MHz AM\nNorth western AO: JTAC Darknight, 32 MHz FM, AFAC Springfield 127 MHz AM\nWestern AO: JTAC Warrier, 33 MHz FM, AFAC Uzi 128 MHz AM.',
	['F-15C'] = ', provide air cover for the CAS flights, and eliminate all enemy fighters in the area.\nAWACS Overlord is on 124 MHz AM, blue flights on 125 MHz AM',
	['MiG-29A'] = ', provide air cover for the CAS flights, and eliminate all enemy fighters in the area.\nAWACS 999 is on 127.5 MHz AM, red flights on 128.5 MHz AM',
	['Su-27'] = ', provide air cover for the CAS flights, and eliminate all enemy fighters in the area.\nAWACS 999 is on 127.5 MHz AM, red flights on 128.5 MHz AM',
	['M-2000C'] = ', provide air cover for the CAS flights, and eliminate all enemy fighters in the area.\nAWACS Overlord is on 124 MHz AM (V/U channel 1), blue flights on 125 MHz AM (V/U channel 1), Nellis on U channel 1.',
	['UH-1H'] = ', three FARPs are almost operational near the AOs to add helicopter CAS capability to the battle field. Make a FARP operational by sling-loading in supplies from Nellis.\nOne friendly armoured group per AO has run out of materiel and needs to be resupplied by helicopter sling load.\nYou are also tasked with CSAR [use F10 menu to see CSAR list]. Rescue a pilot by flying to its location and land within 100 m.',
	['Mi-8MT'] = ', three FARPs are almost operational near the AOs to add helicopter CAS capability to the battle field. Make a FARP operational by sling-loading in supplies from Creech.\nOne friendly armoured group per AO has run out of materiel and needs to be resupplied by helicopter sling load.\nYou are also tasked with CSAR [use F10 menu to see CSAR list]. Rescue a pilot by flying to its location and land within 100 m.',
	['Su-25T'] = ', you are tasked with providing SEAD. Coordinate with CAS flights for highest priority SAMs.',
	}
MASHzones = {
			blue = 	{
						{ name = 'MASH London Zone', active = true, frequency = '40 Mhz FM'},
						{ name = 'MASH Potato Zone', active = false, frequency = '41 Mhz FM'},
						{ name = 'MASH Gravy Zone', active = false, frequency = '42 Mhz FM'},
					},
			red = 	{
						{ name = 'MASH Otkrytka Zone', active = true, frequency = 'ADF-9 ADF 300 kHz'},
						{ name = 'MASH Potatski Zone', active = false, frequency = 'ADF-9 ADF 350 kHz'},
						{ name = 'MASH Gravitski Zone', active = false, frequency = 'ADF-9 ADF 400 kHz'},
					}
			}
local radioMASH = { 
				['MASH London Truck'] = {frequency = 40E6, modulation = 1},
				['MASH Potato Truck'] = {frequency = 41E6, modulation = 1},
				['MASH Gravy Truck'] = {frequency = 42E6, modulation = 1},
				['MASH Otkrytka Truck'] = {frequency = 3E5, modulation = 1},
				['MASH Potatski Truck'] = {frequency = 3.5E5, modulation = 1},
				['MASH Gravitski Truck'] = {frequency = 4E5, modulation = 1},
				}
local radioBeacon = { 
				['blue beacon #1'] = {frequency = 43E6, modulation = 1},
				['blue beacon #2'] = {frequency = 44E6, modulation = 1},
				['blue beacon #3'] = {frequency = 45E6, modulation = 1},
				['red beacon #1'] = {frequency = 4E5, modulation = 1},
				['red beacon #1'] = {frequency = 4.5E5, modulation = 1},
				['red beacon #1'] = {frequency = 5E5, modulation = 1},
				}

local shipInDistress = {['Oliver Hazzard Perry'] = false, ['Neustrashimy'] = false,}
local radio = {}
local onGround = {}
local rescuedPilots = {
				}
local troopsOnBoard = {
				}
local tally = {
				}
local rescuedSailors = {
				}
local escort = {
				}
local menu = {
				}				
local menu2 = {
				}				
local latestTruckSightings = {'','',''}
local enemyFlights = {}

clientNames = {
	'Hawg 1-1',
	'Hawg 2-1',
	'Hawg 3-1',
	'Hawg 4-1',
	'Dodge 1-1',
	'Dodge 1-2',
	'Dodge 1-3',
	'Dodge 1-4',
	'Colt 1-1',
	'Colt 1-2',
	'Colt 1-3',
	'Colt 1-4',
	'Springfield 1-1',
	'Springfield 2-1',
	'Springfield 3-1',
	'Springfield 4-1',
	'Enfield 1-1',
	'Enfield 2-1',
	'Enfield 3-1',
	'Enfield 4-1',
	'Pontiac 1-1',
	'Pontiac 2-1',
	'Pontiac 3-1',
	'Pontiac 5-1',
	'Pontiac 5-2',
	'Pontiac 5-3',
	'Pontiac 5-4',
	'101',
	'102',
	'103',
	'104',
	'201',
	'202',
	'203',
	'204',
	'301',
	'302',
	'303',
	'304',
	'401',
	'402',
	'403',
	'404',
	'501',
	'551',
	'601',
	'701',
	'702',
	'703',
	'704',
	'801',
	'811',
	'821',
	'831',
}

clientHeloNames = {
	'Springfield 1-1',
	'Springfield 2-1',
	'Springfield 3-1',
	'Springfield 4-1',
	'Pontiac 1-1',
	'Pontiac 2-1',
	'Pontiac 3-1',
	'501',
	'551',
	'601',
	'801',
	'811',
	'821',
	'831',
}

fighterClients = { blue = {}, red = {} }
detectionZoneList =	{
						'the eastern outskirts of Vegas',
						'Alamo Charlie',
						'Pahrump',
						'the prominent mountain ridge west of Vegas',
						'The Strip',
						'bulls eye',
						'5 nm south-east of Creech AFB',
						'the western outskirts of Vegas',
						'Primm',
						'the south-western outskirts of Vegas',
						'5 nm east of Creech AFB',
						'5 nm north of Nellis AFB',
						'the southern outskirts of Vegas',
						'5 nm south of Creech AFB',
						'the prominent mountain ridge west of Vegas',
						'Henderson',
						'Sally Corridor',
					}

clientFighters = 0

HS_ADFlist = {
	blue = {},
	red = {		
		{name = 'ARK-UD ch. 1', frequency = 114166000, modulation = 0, group = nil},
		{name = 'ARK-UD ch. 2', frequency = 114333000, modulation = 0, group = nil},
		{name = 'ARK-UD ch. 3', frequency = 114583000, modulation = 0, group = nil},
		{name = 'ARK-UD ch. 4', frequency = 121500000, modulation = 0, group = nil},
		{name = 'ARK-UD ch. 5', frequency = 123100000, modulation = 0, group = nil},
		{name = 'ARK-UD ch. 6', frequency = 124100000, modulation = 0, group = nil},
		{name = 'R-828 ch. 1', frequency = 21.5E6, modulation = 0, group = nil},
		{name = 'R-828 ch. 2', frequency = 25.7E6, modulation = 0, group = nil},
		{name = 'R-828 ch. 3', frequency = 27E6, modulation = 0, group = nil},
		{name = 'R-828 ch. 4', frequency = 28E6, modulation = 0, group = nil},
		{name = 'R-828 ch. 5', frequency = 30E6, modulation = 0, group = nil},
		{name = 'R-828 ch. 6', frequency = 32E6, modulation = 0, group = nil},
		{name = 'R-828 ch. 7', frequency = 40E6, modulation = 0, group = nil},
		{name = 'R-828 ch. 8', frequency = 50E6, modulation = 0, group = nil},
		{name = 'R-828 ch. 9', frequency = 55.5E6, modulation = 0, group = nil},
		{name = 'R-828 ch. 10', frequency = 59.9E6, modulation = 0, group = nil},
	}
}

local count

for count = 1,100 do
	table.insert(HS_ADFlist.blue,{name = 'FM '.. 30.25+(count-1) .. ' MHz', frequency = (30.25+(count-1))*1000000, modulation = 1, group = nil})
	table.insert(HS_ADFlist.red,{name = 'ARC-9 ADF '.. 502+(count-1)*40 .. ' kHz', frequency = (502+(count-1)*40)*1E3, modulation = 0, group = nil})
end

-- emitRadio = function()
	-- local zone = Unit.getByName('MASH London Truck Unit #1')
	-- if zone then
		-- local zonePosition = Unit.getPosition(zone).p
		-- trigger.action.radioTransmission('l10n/DEFAULT/beacon.ogg', zonePosition, 1, false, 30E6, 100)
		-- timer.scheduleFunction(emitRadio,{},timer.getTime()+1)
	-- end
-- end

-- timer.scheduleFunction(emitRadio,{},timer.getTime()+1)

emitBeacon = function(args)
	local groupName = args[1]
	local frequency = args[2]
	local modulation = args[3]
	local unitPosition = getLeadPosition(groupName)
	if unitPosition then
		trigger.action.radioTransmission('l10n/DEFAULT/beacon.ogg', unitPosition, modulation, false, frequency, 1000)
		timer.scheduleFunction(emitBeacon,{groupName,frequency,modulation},timer.getTime()+31)
	else
		local coa,index = findADFbyFrequency(frequency)
		HS_ADFlist[coa][index].group = nil
	end
end

local groupName,value

for groupName,value in pairs(radioMASH) do
	timer.scheduleFunction(emitBeacon,{groupName,value.frequency,value.modulation},timer.getTime()+1)
end

for groupName,value in pairs(radioBeacon) do
	timer.scheduleFunction(emitBeacon,{groupName,value.frequency,value.modulation},timer.getTime()+1)
end

checkForFlag = function(arg)
	local flagName = arg[1]
	local code = arg[2]
	local arguments = arg[3]
	if trigger.misc.getUserFlag(flagName) == 1 then
		trigger.action.setUserFlag(flagName,0)
		timer.scheduleFunction(code,arguments,timer.getTime()+0.1)
	end
	timer.scheduleFunction(checkForFlag,{flagName,code,arguments},timer.getTime()+1)
end

findClosestAAA = function(coa,position3)
local i,j

	local minimumDistance = 1E6
	local miminumUnitName = nil
	for i = 1,#AAAList[coa] do
		local unitName = AAAList[coa][i]
		local unit = Unit.getByName(unitName)
		if unit then
			local unitPosition = Unit.getPosition(unit).p
			local distance = math.sqrt((unitPosition.x-position3.x)*(unitPosition.x-position3.x)+(unitPosition.z-position3.z)*(unitPosition.z-position3.z))
			if distance < minimumDistance then
				minimumDistance = distance
				miminumUnitName = unitName
			end
		end
	end
	return miminumUnitName,minimumDistance
end

findClosestGrunts = function(coa,position3)
local i,j

	local minimumDistance = 1E6
	local miminumGroupName = nil
	for i = 1, gruntsCounter[coa] do
		local groupName = coa .. ' grunts Group #' .. i
		local group = Group.getByName(groupName)
		if group then
			for j = 1,#Group.getUnits(group) do
				unit = Group.getUnits(group)[j]
				if unit then
					if unit:getTypeName() == 'Soldier M4' or unit:getTypeName() == 'Infantry AK' then
						local unitPosition = Unit.getPosition(unit).p
						local distance = math.sqrt((unitPosition.x-position3.x)*(unitPosition.x-position3.x)+(unitPosition.z-position3.z)*(unitPosition.z-position3.z))
						if distance < minimumDistance then
							minimumDistance = distance
							miminumGroupName = groupName
						end
					end
				end
			end
		end
	end
	return miminumGroupName,minimumDistance
end

findClosestMANPADS = function(coa,position3)
local i,j

	local minimumDistance = 1E6
	local miminumGroupName = nil
	for i = 1, gruntsCounter[coa] do
		local groupName = coa .. ' grunts Group #' .. i
		local group = Group.getByName(groupName)
		if group then
			for j = 1,#Group.getUnits(group) do
				unit = Group.getUnits(group)[j]
				if unit then
					if unit:getTypeName() == 'Stinger manpad' or unit:getTypeName() == 'SA-18 Igla-S manpad' then
						local unitPosition = Unit.getPosition(unit).p
						local distance = math.sqrt((unitPosition.x-position3.x)*(unitPosition.x-position3.x)+(unitPosition.z-position3.z)*(unitPosition.z-position3.z))
						if distance < minimumDistance then
							minimumDistance = distance
							miminumGroupName = groupName
						end
					end
				end
			end
		end
	end
	return miminumGroupName,minimumDistance
end

groupSize = function(groupName)
	local size = 0
	local group=Group.getByName(groupName)
	if group then
		local units = Group.getUnits(group)
		if units then
			local i
			for i = 1,#units do
				if units[i] then
					if Unit.isExist(units[i]) then
						size = size + 1
					end
				end
			end
		end
	end
	return size
end

getTypeTable = function(groupName)
	local typeTable = {}
	local group=Group.getByName(groupName)
	if group then
		local units = Group.getUnits(group)
		if units then
			local i
			for i = 1,#units do
				if units[i] then
					if Unit.isExist(units[i]) then
						typeTable[#typeTable+1] = units[i]:getTypeName()
					end
				end
			end
		end
	end
	return typeTable
end

getLeadPosition = function(groupName)
	local group = Group.getByName(groupName)
	if group then
		local units = Group.getUnits(group)
		local i
		for i = 1,#units do
			if units[i] then
				return Unit.getPosition(units[i]).p
			end
		end
		return false
	else
		return false
	end
end

findInFront = function(pilotName)
	local returnValue = nil
	local pilotUnit = Unit.getByName(pilotName)
	if pilotUnit then
		local unitpos = Unit.getPosition(pilotUnit)
		local length = math.sqrt(unitpos.x.x*unitpos.x.x+unitpos.x.z*unitpos.x.z)/15
		local unitVector = {x = unitpos.p.x + unitpos.x.x/length, y = 0, z = unitpos.p.z + unitpos.x.z/length}
		returnValue = unitVector
	end
	return returnValue
end

findBehind = function(pilotName)
	local returnValue = nil
	local pilotUnit = Unit.getByName(pilotName)
	if pilotUnit then
		local unitpos = Unit.getPosition(pilotUnit)
		local length = math.sqrt(unitpos.x.x*unitpos.x.x+unitpos.x.z*unitpos.x.z)/1000
		local unitVector = {x = unitpos.p.x - unitpos.x.x/length, y = 0, z = unitpos.p.z - unitpos.x.z/length}
		returnValue = unitVector
	end
	return returnValue
end

moveGroup2 = function(arg)
	moveGroup(arg[1],arg[2],arg[3])
end

moveGroup = function(groupName, start, stop)
	local misTask = { 
		id = 'Mission', 
		params = { 
			route = { 
				["points"] = 
				{
					[1] = 
					{
						["alt"] = 0,
						["type"] = "Turning Point",
						["ETA"] = 0,
						["alt_type"] = "RADAR",
						["formation_template"] = "",
						["y"] = start.z,
						["x"] = start.x,
						["name"] = "",
						["ETA_locked"] = true,
						["speed"] = 5,
						["action"] = "Off Road",
						["task"] = 
						{
							["id"] = "ComboTask",
							["params"] = 
							{
								["tasks"] = 
								{
								}, -- end of ["tasks"]
							}, -- end of ["params"]
						}, -- end of ["task"]
						["speed_locked"] = true,
					}, -- end of [1]
					[2] = 
					{
						["alt"] = 0,
						["type"] = "Turning Point",
						["ETA"] = 0,
						["alt_type"] = "RADAR",
						["formation_template"] = "",
						["y"] = stop.z,
						["x"] = stop.x,
						["name"] = "",
						["ETA_locked"] = true,
						["speed"] = 5,
						["action"] = "Off Road",
						["task"] = 
						{
							["id"] = "ComboTask",
							["params"] = 
							{
								["tasks"] = 
								{
								}, -- end of ["tasks"]
							}, -- end of ["params"]
						}, -- end of ["task"]
						["speed_locked"] = true,
					}, -- end of [1]
				}, -- end of ["points"]
			},
		},
	}	
	local group = Group.getByName(groupName)
	if group then
		local groupCon = group:getController()
		if groupCon then
			groupCon:setTask(misTask)
			return true
		end
	end
	--Controller.setTask(groupCon, misTask)
	return false
end

loadTroops = function(pilotName)
local groupName,minimumDistance,groupName2,minimumDistance2,coa,i

	local pilotUnit = Unit.getByName(pilotName)
	if pilotUnit then
		if not Unit.inAir(pilotUnit) and #troopsOnBoard[pilotName] < 8 then
			local pilotSide = Unit.getCoalition(pilotUnit)
			if pilotSide == coalition.side.BLUE then
				coa = 'blue'
			elseif pilotSide == coalition.side.RED then
				coa = 'red'
			end
			local pilotPosition = Unit.getPosition(pilotUnit).p
			groupName,minimumDistance = findClosestGrunts(coa,pilotPosition)
			groupName2,minimumDistance2 = findClosestMANPADS(coa,pilotPosition)
			if minimumDistance2 < minimumDistance then
				groupName = groupName2
				minimumDistance = minimumDistance2
			end
			if minimumDistance < 1000 then
				local typeTable = getTypeTable(groupName)
				local leftOver = #typeTable + #troopsOnBoard[pilotName] - 8
				local leftoverTable = {}
				local gruntPosition = getLeadPosition(groupName)
				local inFrontPos = findInFront(pilotName)
				local group = Group.getByName(groupName)
				if group then
					Group.destroy(group)
					if gruntPosition then
						if leftOver > 0 then
							for i = #typeTable + 1 - leftOver,#typeTable do
								leftoverTable[#leftoverTable+1] = typeTable[i]
							end
							local groupName = spawnGrunts(coa,gruntPosition,leftOver,nil,leftoverTable)
							assignADF(coa,groupName)
						end
						local tempTable = {}
						for i = 1, #typeTable - leftOver do
							tempTable[#tempTable+1] = typeTable[i]
						end
						groupName = spawnGrunts(coa,{x = gruntPosition.x+1,y = gruntPosition.y, z = gruntPosition.z},#tempTable,'temporary',tempTable)
						if inFrontPos then
							timer.scheduleFunction(moveGroup2,{groupName, gruntPosition, inFrontPos},timer.getTime()+1)
							timer.scheduleFunction(Group.destroy,Group.getByName(groupName),timer.getTime()+math.sqrt((gruntPosition.x-inFrontPos.x)*(gruntPosition.x-inFrontPos.x)+(gruntPosition.z-inFrontPos.z)*(gruntPosition.z-inFrontPos.z))/3)
							trigger.action.outTextForGroup(Group.getID(Unit.getGroup(pilotUnit)),pilotName .. ' loaded troops.',20)
						end
						for i = 1, #tempTable do
							troopsOnBoard[pilotName][#troopsOnBoard[pilotName]+1] = tempTable[i]
						end
					end
				end
				-- trigger.action.outTextForGroup(Group.getID(Unit.getGroup(pilotUnit)),pilotName .. ' loaded troops.',20)			
			else
				trigger.action.outTextForGroup(Group.getID(Unit.getGroup(pilotUnit)),'There are no extractable troops nearby. Consult F-10 other menu option F1 for locations of troops.',20)			
			end
		else
			trigger.action.outTextForGroup(Group.getID(Unit.getGroup(pilotUnit)),'Only empty choppers on the ground can extract troops.',20)			
		end
	end
end

makeAttack = function(groupName)
local minimumGroupName,minimumDistance,coa,i,minimumUnitName,minimumDistance2,endPosition

	local group = Group.getByName(groupName)
	if group then
		local groupSide = Group.getCoalition(group)
		if groupSide == coalition.side.BLUE then
			coa = 'red'
		else
			coa = 'blue'
		end
		local leadPosition = getLeadPosition(groupName)
		if leadPosition then
			minimumGroupName,minimumDistance = findClosestGrunts(coa,leadPosition)
			minimumUnitName,minimumDistance2 = findClosestAAA(coa,leadPosition)
			if minimumDistance2 < minimumDistance then
				minimumDistance = minimumDistance2
				local unit = Unit.getByName(minimumUnitName)
				if unit then
					endPosition = Unit.getPosition(unit).p
				end
			else
				endPosition = getLeadPosition(minimumGroupName)
			end
			airbaseList = world.getAirbases()
			for i = 1,#airbaseList do
				local airbase = airbaseList[i]
				if Airbase.isExist(airbase) then
					local airbaseName = Airbase.getName(airbase)
					local airbasePosition = Airbase.getPosition(airbase).p
					local distance = math.sqrt((airbasePosition.x-leadPosition.x)*(airbasePosition.x-leadPosition.x)+(airbasePosition.z-leadPosition.z)*(airbasePosition.z-leadPosition.z))
					-- trigger.action.outTextForCoalition(pilotSide,pilotName .. ' is ' .. math.floor(distance) .. ' m from ' .. airbaseName,10)
					if distance < minimumDistance then
						minimumDistance = distance
						minimumGroupName = airbaseName
						endPosition = airbasePosition
					end
				end
			end
			if (minimumGroupName or minimumUnitName) and endPosition and minimumDistance < 5000 then
				timer.scheduleFunction(moveGroup2,{groupName, leadPosition, endPosition},timer.getTime()+1)
			end
		end
	end
end

offloadTroops = function(pilotName)
local i,j,coa

	local pilotUnit = Unit.getByName(pilotName)
	if pilotUnit then
		if not Unit.inAir(pilotUnit) and #troopsOnBoard[pilotName] > 0 then
			local pilotSide = Unit.getCoalition(pilotUnit)
			if pilotSide == coalition.side.BLUE then
				coa = 'blue'
			elseif pilotSide == coalition.side.RED then
				coa = 'red'
			end
			local inFrontPos = findInFront(pilotName)
			local i
			local j = 1
			local count = 0
			for i = 1,#troopsOnBoard[pilotName] do
				if troopsOnBoard[pilotName][j] == 'Soldier M4' or troopsOnBoard[pilotName][j] == 'Infantry AK' then
					table.remove(troopsOnBoard[pilotName],j)
					count = count + 1
				else
					j = j+1
				end
			end
			if count > 0 then
				local groupName = spawnGrunts(coa, inFrontPos,count)
				assignADF(coa,groupName)
				trigger.action.outTextForGroup(Group.getID(Unit.getGroup(pilotUnit)),pilotName .. ' offloaded troops.',20)
				makeAttack(groupName)
			end
		else
			trigger.action.outTextForGroup(Group.getID(Unit.getGroup(pilotUnit)),'Only loaded choppers on the ground can offload troops.',20)			
		end
	end
end

offloadMANPADS = function(pilotName)
local i,j,coa

	local pilotUnit = Unit.getByName(pilotName)
	if pilotUnit then
		if not Unit.inAir(pilotUnit) and #troopsOnBoard[pilotName] > 0 then
			local pilotSide = Unit.getCoalition(pilotUnit)
			if pilotSide == coalition.side.BLUE then
				coa = 'blue'
			elseif pilotSide == coalition.side.RED then
				coa = 'red'
			end
			local inFrontPos = findInFront(pilotName)
			local i
			local count = 0
			for i = 1,#troopsOnBoard[pilotName] do
				if troopsOnBoard[pilotName][i] == 'Stinger manpad' or troopsOnBoard[pilotName][i] == 'SA-18 Igla-S manpad' then
					table.remove(troopsOnBoard[pilotName],i)
					if coa == 'blue' then
						local groupName = spawnGrunts(coa, { x = inFrontPos.x - 5 + myRandom(10), y = inFrontPos.y, z = inFrontPos.z - 5 + myRandom(10)} ,1,nil,{'Stinger manpad'})
						assignADF(coa,groupName)
					else
						local groupName = spawnGrunts(coa, { x = inFrontPos.x - 5 + myRandom(10), y = inFrontPos.y, z = inFrontPos.z - 5 + myRandom(10)} ,1,nil,{'SA-18 Igla-S manpad'})
						assignADF(coa,groupName)
					end
					trigger.action.outTextForGroup(Group.getID(Unit.getGroup(pilotUnit)),pilotName .. ' offloaded troops.',20)
					break
				end
			end
		else
			trigger.action.outTextForGroup(Group.getID(Unit.getGroup(pilotUnit)),'Only loaded choppers on the ground can offload troops.',20)			
		end
	end
end

clientBecomesActive = function(pilotName)
local coa

	local pilotUnit = Unit.getByName(pilotName)
	if pilotUnit then
		local pilotDownSide,pilotSide
		pilotSide = Unit.getCoalition(pilotUnit)
		if pilotSide == coalition.side.BLUE then
			coa = 'blue'
		elseif pilotSide == coalition.side.RED then
			coa = 'red'
		end
		if chopperInactive[pilotName] then
			trigger.action.outTextForCoalition(pilotSide,'DO NOT TAKE THIS CHOPPER. IT HAS NOT YET BEEN ACTIVATED!',30)
			timer.scheduleFunction(Unit.destroy,pilotUnit,timer.getTime()+10)
			return
		end
		trigger.action.outTextForCoalition(pilotSide,'To all units. We have a new ' .. pilotUnit:getTypeName() .. ' pilot: ' .. Unit.getName(pilotUnit),30)
		if pilotUnit:getTypeName() == 'UH-1H' or pilotUnit:getTypeName() == 'Mi-8MT' then
			if not tally[pilotName] then
				timer.scheduleFunction(tallyAAA,pilotName,timer.getTime()+10)
			end
			rescuedPilots[pilotName] = 0
			rescuedSailors[pilotName] = 0
			troopsOnBoard[pilotName] = {}
			onGround[pilotName] = true
			local count
			for count = 1,pilotDownCounter[coa] do
				local pilotDownName = coa .. ' Pilot Down Group #' .. count
				local pilotDownPosition = getLeadPosition(pilotDownName)
				if pilotDownPosition then
					local pilotPosition = Unit.getPosition(pilotUnit).p
					local distance = math.sqrt((pilotDownPosition.x-pilotPosition.x)*(pilotDownPosition.x-pilotPosition.x)+(pilotDownPosition.z-pilotPosition.z)*(pilotDownPosition.z-pilotPosition.z))
					-- trigger.action.outTextForCoalition(pilotSide,pilotName .. ' is ' .. math.floor(distance) .. ' m from ' .. pilotDownName,10)
					timer.scheduleFunction(hoverCheck2,{pilotDownName,pilotName,10},timer.getTime()+1+distance/100)
				end
			end
			for count = 1,gruntsCounter[coa] do
				local pilotDownName = coa .. ' grunts Group #' .. gruntsCounter[coa]
				local pilotDownPosition = getLeadPosition(pilotDownName)
				if pilotDownPosition then
					local pilotPosition = Unit.getPosition(pilotUnit).p
					local distance = math.sqrt((pilotDownPosition.x-pilotPosition.x)*(pilotDownPosition.x-pilotPosition.x)+(pilotDownPosition.z-pilotPosition.z)*(pilotDownPosition.z-pilotPosition.z))
					-- trigger.action.outTextForCoalition(pilotSide,pilotName .. ' is ' .. math.floor(distance) .. ' m from ' .. pilotDownName,10)
					timer.scheduleFunction(hoverCheck2,{pilotDownName,pilotName,10},timer.getTime()+1+distance/100)
				end
			end
			local pilotGroup = Unit.getGroup(pilotUnit)
			if pilotGroup then
				local groupID = Group.getID(pilotGroup)
				if groupID then
					menu[pilotName] = groupID
					trigger.action.addOtherCommandForGroup(groupID, 'CSAR/air mobility tasks [' .. pilotName .. ']', 'CSAR/air mobility tasks [' .. pilotName .. ']') -- add radio item to "F10" menu
					trigger.action.setUserFlag('CSAR/air mobility tasks [' .. pilotName .. ']',0)
					timer.scheduleFunction(checkForFlag,{'CSAR/air mobility tasks [' .. pilotName .. ']',CSARtasks,{coa,pilotName}},timer.getTime()+1)
					trigger.action.addOtherCommandForGroup(groupID, 'troops onboard [' .. pilotName .. ']', 'troops onboard [' .. pilotName .. ']') -- add radio item to "F10" menu
					trigger.action.setUserFlag('troops onboard [' .. pilotName .. ']',0)
					timer.scheduleFunction(checkForFlag,{'troops onboard [' .. pilotName .. ']',troopCountRequested,pilotName},timer.getTime()+1)
					trigger.action.addOtherCommandForGroup(groupID, 'request escort helo [' .. pilotName .. ']', 'request escort helo [' .. pilotName .. ']') -- add radio item to "F10" menu
					trigger.action.setUserFlag('request escort helo [' .. pilotName .. ']',0)
					timer.scheduleFunction(checkForFlag,{'request escort helo [' .. pilotName .. ']',escortRequested,pilotName},timer.getTime()+1)
					trigger.action.addOtherCommandForGroup(groupID, 'Bases and MASHs list [' .. pilotName .. ']', 'Bases and MASHs list [' .. pilotName .. ']') -- add radio item to "F10" menu
					trigger.action.setUserFlag('Bases and MASHs list [' .. pilotName .. ']',0)
					timer.scheduleFunction(checkForFlag,{'Bases and MASHs list [' .. pilotName .. ']',MASHinfo,pilotName},timer.getTime()+1)
					trigger.action.addOtherCommandForGroup(groupID, 'load troops [' .. pilotName .. ']', 'load troops [' .. pilotName .. ']') -- add radio item to "F10" menu
					trigger.action.setUserFlag('load troops [' .. pilotName .. ']',0)
					timer.scheduleFunction(checkForFlag,{'load troops [' .. pilotName .. ']',loadTroops,pilotName},timer.getTime()+1)
					trigger.action.addOtherCommandForGroup(groupID, 'offload infantry [' .. pilotName .. ']', 'offload infantry [' .. pilotName .. ']') -- add radio item to "F10" menu
					trigger.action.setUserFlag('offload infantry [' .. pilotName .. ']',0)
					timer.scheduleFunction(checkForFlag,{'offload infantry [' .. pilotName .. ']',offloadTroops,pilotName},timer.getTime()+1)
					trigger.action.addOtherCommandForGroup(groupID, 'offload MANPADS [' .. pilotName .. ']', 'offload MANPADS [' .. pilotName .. ']') -- add radio item to "F10" menu
					trigger.action.setUserFlag('offload MANPADS [' .. pilotName .. ']',0)
					timer.scheduleFunction(checkForFlag,{'offload MANPADS [' .. pilotName .. ']',offloadMANPADS,pilotName},timer.getTime()+1)
				end
			end
		end
		if pilotUnit:getTypeName() == 'AV8BNA' or pilotUnit:getTypeName() == 'A-10C' then
			local pilotGroup = Unit.getGroup(pilotUnit)
			if pilotGroup then
				local groupID = Group.getID(pilotGroup)
				if groupID then
					menu2[pilotName] = groupID
					trigger.action.addOtherCommandForGroup(groupID, 'JTAC auto lase [' .. pilotName .. ']', 'JTAC auto lase [' .. pilotName .. ']') -- add radio item to "F10" menu
					trigger.action.setUserFlag('JTAC auto lase [' .. pilotName .. ']',0)
					timer.scheduleFunction(checkForFlag,{'JTAC auto lase [' .. pilotName .. ']',Lase,pilotName},timer.getTime()+1)
				end
			end
		end
		if pilotUnit:getTypeName() == 'SA342M' then
			if not tally[pilotName] then
				timer.scheduleFunction(tallyAAA,pilotName,timer.getTime()+10)
			end
		end
		if pilotUnit:getTypeName() == 'F-5E-3' then
			local pilotGroup = Unit.getGroup(pilotUnit)
			if pilotGroup then
				local groupID = Group.getID(pilotGroup)
				if groupID then
					menu[pilotName] = groupID
					trigger.action.addOtherCommandForGroup(groupID, 'Flares for VID for ' .. pilotName, 'Flares for VID for ' .. pilotName) -- add radio item to "F10" menu
					trigger.action.setUserFlag('Flares for VID for ' .. pilotName,0)
					timer.scheduleFunction(checkForFlag,{'Flares for VID for ' .. pilotName,flare,pilotName},timer.getTime()+1)
				end
			end
		end
		if pilotUnit:getTypeName() == 'M-2000C' or pilotUnit:getTypeName() == 'F-15C' or pilotUnit:getTypeName() == 'MiG-29A' or pilotUnit:getTypeName() == 'Su-27' then
			fighterClients[coa][pilotName] = true
			A2ACounter[coa] = A2ACounter[coa]+1
			trigger.action.outText('There are now ' .. A2ACounter[coa] .. ' ' .. coa .. ' client A2A fighters active.',30)
		end
		if pilotUnit:getTypeName() == 'AV8BNA' then
			if string.find(pilotName, "Enfield") then
				trigger.action.outTextForCoalition(pilotSide,pilotName .. ', eliminate Russian armored divisions. CAS flights are supported by JTAC and AFAC.\nNorth eastern AO: JTAC Axeman, 31 MHz FM, AFAC Enfield 126 MHz AM\nNorth western AO: JTAC Darknight, 32 MHz FM, AFAC Springfield 127 MHz AM\nWestern AO: JTAC Warrier, 33 MHz FM, AFAC Uzi 128 MHz AM.\nUse F-10 menu for JTAC auto-lase.',60)
			elseif string.find(pilotName, "Dodge") then
				trigger.action.outTextForCoalition(pilotSide,pilotName .. ', you are tasked with providing SEAD. Coordinate with CAS flights for highest priority SAMs.',60)
			end
		end
		trigger.action.outSound('RadioClickAfter.ogg')
		if greetingTexts[pilotUnit:getTypeName()] then
			trigger.action.outTextForCoalition(pilotSide,pilotName .. greetingTexts[pilotUnit:getTypeName()],60)
		end
		local group = Unit.getGroup(pilotUnit)
		if group then
			local groupName = Group.getName(group)
			doSpot(groupName)
		end
	end
end

clientBecomesInactive = function(pilotName)
	trigger.action.outSound('RadioClickAfter.ogg')
	trigger.action.outText('To all units. Pilot ' .. pilotName .. ' has left us.',20)
	if menu[pilotName] then
		trigger.action.removeOtherCommandForGroup(menu[pilotName], 'CSAR/air mobility tasks [' .. pilotName .. ']', 'CSAR/air mobility tasks [' .. pilotName .. ']') -- add radio item to "F10" menu
		trigger.action.removeOtherCommandForGroup(menu[pilotName], 'troops onboard [' .. pilotName .. ']', 'troops onboard [' .. pilotName .. ']') -- add radio item to "F10" menu
		trigger.action.removeOtherCommandForGroup(menu[pilotName], 'request escort helo [' .. pilotName .. ']', 'request escort helo [' .. pilotName .. ']') -- add radio item to "F10" menu
		trigger.action.removeOtherCommandForGroup(menu[pilotName], 'Bases and MASHs list [' .. pilotName .. ']', 'Bases and MASHs list [' .. pilotName .. ']') -- add radio item to "F10" menu
		trigger.action.removeOtherCommandForGroup(menu[pilotName], 'load troops [' .. pilotName .. ']', 'load troops [' .. pilotName .. ']') -- add radio item to "F10" menu
		trigger.action.removeOtherCommandForGroup(menu[pilotName], 'offload infantry [' .. pilotName .. ']', 'offload infantry [' .. pilotName .. ']') -- add radio item to "F10" menu
		trigger.action.removeOtherCommandForGroup(menu[pilotName], 'offload MANPADS [' .. pilotName .. ']', 'offload MANPADS [' .. pilotName .. ']') -- add radio item to "F10" menu
		trigger.action.removeOtherCommandForGroup(menu[pilotName], 'Flares for VID for ' .. pilotName, 'Flares for VID for ' .. pilotName) -- add radio item to "F10" menu
	end
	if menu2[pilotName] then
		trigger.action.removeOtherCommandForGroup(menu[pilotName], 'JTAC auto lase ['  .. pilotName .. ']', 'JTAC auto lase ['  .. pilotName .. ']') -- add radio item to "F10" menu
	end
	if fighterClients.blue[pilotName] then
		A2ACounter.blue = A2ACounter.blue-1
		trigger.action.outText('There are now ' .. A2ACounter.blue .. ' blue client A2A fighters active.',30)
	end
	if fighterClients.red[pilotName] then
		A2ACounter.red = A2ACounter.red-1
		trigger.action.outText('There are now ' .. A2ACounter.red .. ' red client A2A fighters active.',30)
	end
end

HS_onBecomesActiveDo_sub1 = function(arguments)
	local unitName = arguments[2]
	if Unit.getByName(unitName) and not arguments[1] then
		timer.scheduleFunction(clientBecomesActive,unitName,timer.getTime()+0.1)
		timer.scheduleFunction(HS_onBecomesInactiveDo_sub1,{true,unitName},timer.getTime()+1)
	elseif not arguments[1] then
		timer.scheduleFunction(HS_onBecomesActiveDo_sub1,{false,unitName},timer.getTime()+0.1)
	end
end

HS_onBecomesInactiveDo_sub1 = function(arguments)
	local unitName = arguments[2]
	if Unit.getByName(unitName) then
		timer.scheduleFunction(HS_onBecomesInactiveDo_sub1,{true,unitName},timer.getTime()+0.1)
	elseif arguments[1] then
		if string.find(unitName, "convoy") or string.find(unitName, "Armor") then
			if string.find(unitName, "blue") then
				trigger.action.outText('A blue vehicle has been destroyed, red side gains 10 points.',20)
				score.red = score.red + 10
			else
				trigger.action.outText('A red vehicle has been destroyed, blue side gains 10 points.',20)
				score.blue = score.blue + 10
			end
		else
			timer.scheduleFunction(clientBecomesInactive,unitName,timer.getTime()+0.1)
			timer.scheduleFunction(HS_onBecomesActiveDo_sub1,{false,unitName},timer.getTime()+0.1)
		end
	end
end

local count

for count = 1,#clientNames do
	timer.scheduleFunction(HS_onBecomesActiveDo_sub1,{false,clientNames[count]},timer.getTime()+1)
end

LaseTarget = function(args)
local targetName,targetUnit

	local pilotName = args[1]
	local JTACname = args[2]
	local targetUnitName = args[3]
	local count = args[4]
	local targetUnit = Unit.getByName(targetUnitName)
	if targetUnit then
		local position = Unit.getPosition(targetUnit).p
		if position then
			local JTACunit,laserSpot,JTACposition
			JTACunit = Unit.getByName(JTACname)
			if JTACunit then
				JTACposition = Unit.getPosition(JTACunit).p
				if land.isVisible({x = JTACposition.x, y = JTACposition.y+2.0, z= JTACposition.z}, {x = position.x, y = position.y+2.0, z= position.z}) then
					if currentSpot[JTACname] then
						Spot.destroy(currentSpot[JTACname])
					end
					currentSpot[JTACname] = nil
					if count >= 0 then
						laserSpot = Spot.createLaser(JTACunit, {x = 0, y = 2.0, z = 0}, {x = position.x, y = position.y+2.0, z= position.z},1688)
						-- trigger.action.smoke(position, trigger.smokeColor.Orange)
						trigger.action.outTextForCoalition(Unit.getCoalition(JTACunit),JTACname .. ' lasing ' .. targetUnitName .. ' using laser code 1688 for ' .. count .. ' seconds.',5)
						local pilotUnit = Unit.getByName(pilotName)
						if pilotUnit then
							local playerPosition = Unit.getPosition(pilotUnit).p
							local relativePosition = {x=position.x-playerPosition.x, y=position.y-playerPosition.y, z=position.z-playerPosition.z}
							local playerHeading = getHeading(pilotUnit) -- the rest of the code determines the 'o'clock' bearing of the missile relative to the helicopter
							local headingVector = {x = math.cos(playerHeading),y=0,z=math.sin(playerHeading)}
							local headingVectorPerpendicular = {x = math.cos(playerHeading+math.pi/2),y=0,z=math.sin(playerHeading+math.pi/2)}
							local forwardDistance = relativePosition.x*headingVector.x+relativePosition.y*headingVector.y+relativePosition.z*headingVector.z
							local rightDistance = relativePosition.x*headingVectorPerpendicular.x+relativePosition.y*headingVectorPerpendicular.y+relativePosition.z*headingVectorPerpendicular.z
							local angle = math.atan2(rightDistance,forwardDistance)*180/math.pi
							if angle < 0 then
								angle = 360+angle
							end
							angle = math.floor(angle*12/360+0.5)
							if angle == 0 then
								angle = 12
							end
							local text =  pilotName .. ', ' .. targetUnitName .. ' is at your ' .. angle .. ' oclock for ' .. math.floor(math.sqrt(forwardDistance*forwardDistance+rightDistance*rightDistance)/1852)
							if rightDistance > 100 then
								text = text .. '. Come right!'
							elseif rightDistance < -100 then
								text = text .. '. Come left!'
							end
							trigger.action.outSoundForGroup(Group.getID(Unit.getGroup(pilotUnit)),'RadioClickAfter.ogg') -- output warning text and audio
							trigger.action.outTextForGroup(Group.getID(Unit.getGroup(pilotUnit)),text,5) -- output warning text and audio
						end
						currentSpot[JTACname] = laserSpot
						timer.scheduleFunction(LaseTarget,{pilotName,JTACname,targetUnitName,count-5},timer.getTime()+5)
					end
				else
					trigger.action.outTextForCoalition(Unit.getCoalition(JTACunit),'[JTAC] We do not have line of sight.',8)					
				end
			end
		end
	end
end

findClosestJTAC = function(position3)
local i,j

	local minimumDistance = 1E6
	local miminumUnitName = nil
	local unitNameList = {'JTAC group 1 Unit 1','JTAC group 2 Unit 1','JTAC group 3 Unit 1'}
	for i = 1,#unitNameList do
		local unitName = unitNameList[i]
		local unit = Unit.getByName(unitName)
		if unit then
			local unitPosition = Unit.getPosition(unit).p
			local distance = math.sqrt((unitPosition.x-position3.x)*(unitPosition.x-position3.x)+(unitPosition.z-position3.z)*(unitPosition.z-position3.z))
			if distance < minimumDistance then
				minimumDistance = distance
				miminumUnitName = unitName
			end
		end
	end
	return miminumUnitName,minimumDistance
end

findClosestVehicle = function(position3,offset)
local i,j,distance

	local minimumDistance = 1E6
	local miminumUnitName = nil
	local groupList = coalition.getGroups(coalition.side.RED,Group.Category.GROUND)
	local vehicleList = {}
	for i = 1, #groupList do
		local group = groupList[i]
		if Group.isExist(group) then
			local units = Group.getUnits(group)
			local j
			for j = 1,#units do
				local unit = Group.getUnits(group)[j]
				if Unit.isExist(unit) then
					if Unit.isActive(unit) then
						if Unit.getDesc(unit).attributes["Ground vehicles"] then
							local unitName = Unit.getName(unit)
							-- trigger.action.outText('Found .. ' .. unitName .. Unit.getDesc(unit).typeName,10)
							vehicleList[#vehicleList+1] = unitName
						end
					end
				end
			end
		end
	end
	for i = 1,#vehicleList do
		local unitName = vehicleList[i]
		local unit = Unit.getByName(unitName)
		if unit then
			local unitPosition = Unit.getPosition(unit).p
			if offset then
				distance = math.abs(math.sqrt((unitPosition.x-position3.x)*(unitPosition.x-position3.x)+(unitPosition.z-position3.z)*(unitPosition.z-position3.z))-offset)
			else
				distance = math.sqrt((unitPosition.x-position3.x)*(unitPosition.x-position3.x)+(unitPosition.z-position3.z)*(unitPosition.z-position3.z))
			end
			if distance < minimumDistance then
				minimumDistance = distance
				miminumUnitName = unitName
			end
		end
	end
	return miminumUnitName,minimumDistance
end

Lase = function(pilotName)
local JTACname,vehicleName
	local pilotUnit = Unit.getByName(pilotName)
	if pilotUnit then
		JTACname = findClosestJTAC(Unit.getPosition(pilotUnit).p)
		vehicleName = findClosestVehicle(Unit.getPosition(pilotUnit).p,10000)
		LaseTarget({pilotName,JTACname,vehicleName,60})
	end
end

flare = function(pilotName)
	local pilotUnit = Unit.getByName(pilotName)
	if pilotUnit then
		local pilotSide = Unit.getCoalition(pilotUnit)
		trigger.action.outTextForCoalition(pilotSide,'[all friendly aircraft and helos are releasing a flare.]',10)
		local aircraftList = coalition.getGroups(pilotSide , Group.Category.AIRPLANE)
		local i
		for i = 1,#aircraftList do
			local group = aircraftList[i]
			if group then
				local units = Group.getUnits(group)
				local j
				for j = 1,#units do
					local unit = units[j]
					if unit then
						trigger.action.signalFlare(Unit.getPosition(unit).p, trigger.flareColor.White, 0)
					end
				end
			end	
		end
		local aircraftList = coalition.getGroups(pilotSide , Group.Category.HELICOPTER)
		local i
		for i = 1,#aircraftList do
			local group = aircraftList[i]
			if group then
				local units = Group.getUnits(group)
				local j
				for j = 1,#units do
					local unit = units[j]
					if unit then
						trigger.action.signalFlare(Unit.getPosition(unit).p, trigger.flareColor.White, 0)
					end
				end
			end	
		end
	end
end

troopCountRequested = function(playerName) -- this function gets executed whenever the "troops on board" menu item has been selected

	local unit = Unit.getByName(playerName)
	if unit then
		local grunts = 0
		local MANPADS = 0
		local i
		for i=1,#troopsOnBoard[playerName] do
			if troopsOnBoard[playerName][i] == 'Soldier M4' or troopsOnBoard[playerName][i] == 'Infantry AK' then
				grunts = grunts + 1
			elseif troopsOnBoard[playerName][i] == 'Stinger manpad' or troopsOnBoard[playerName][i] == 'SA-18 Igla-S manpad' then
				MANPADS = MANPADS + 1
			end
		end
		trigger.action.outTextForGroup(Group.getID(Unit.getGroup(Unit.getByName(playerName))),'This is ' .. playerName .. '. There are ' .. rescuedPilots[playerName] .. ' rescued pilots ' .. ', ' .. rescuedSailors[playerName]*8 .. ' rescued sailors, ' .. grunts .. ' infantry troops and ' .. MANPADS .. ' MANPADS on board',10)
	end
end

clearEscort = function(playerName)
	escort[playerName] = nil
end

escortRequested = function(playerName) -- this function gets executed whenever the "troops on board" menu item has been selected
local coa

	local unit = Unit.getByName(playerName)
	if unit then
		local side = Unit.getCoalition(unit)
		if side == coalition.side.BLUE then
			coa = 'blue'
		elseif side == coalition.side.RED then
			coa = 'red'
		end
		if escort[playerName] then
			trigger.action.outTextForCoalition(side,playerName .. ' already has an escort. You can request one escort per 30 mins.',10)
		else
			spawnEscort(coa,playerName)
			timer.scheduleFunction(clearEscort,playerName,timer.getTime()+30*60)
			trigger.action.outTextForCoalition(side,'Escort helo for ' .. playerName .. ' is inbound.',10)
		end
	end
end

HS_stopTransmission = function(unitName)
local action = 	{
					["id"] = "StopTransmission",
					["params"] = 
					{
					}, -- end of ["params"]
				} -- end of ["action"]
	local unit = Unit.getByName(unitName)
	if unit then
		local group = Unit.getGroup(unit)
		if group then
			HS_groupSetCommand(group,action)
		end
	end
end

HS_startTransmission = function(unitName)
local action =	{
				["id"] = "TransmitMessage",
				["params"] = 
				{
					["file"] = "ResKey_Action_18",
					["subtitle"] = "",
					["loop"] = true,
					["duration"] = 5,
				}, -- end of ["params"]
			} -- end of ["action"]
	local unit = Unit.getByName(unitName)
	if unit then
		local group = Unit.getGroup(unit)
		if group then
			HS_groupSetCommand(group,action)
		end
	end
end

HS_groupSetADF2 = function(arg)
	HS_groupSetADF(arg[1],arg[2],arg[3])
end

HS_groupSetADF = function(unitName,ADF,modulation)
local action =	{
				["id"] = "SetFrequency",
				["params"] = 
				{
					["modulation"] = modulation,
					["frequency"] = ADF,
				}, -- end of ["params"]
			} -- end of ["action"]
	local unit = Unit.getByName(unitName)
	if unit then
		local group = Unit.getGroup(unit)
		if group then
			HS_groupSetCommand(group,action)
		end
	end
end

HS_groupSetCommand = function(group,action)
local groupController

	if group then
		groupController = Group.getController(group)
		Controller.setCommand(groupController,action)
	end
end

findADF = function(coa,groupName)
local i

	for i = 1,#HS_ADFlist[coa] do
		if HS_ADFlist[coa][i].group == groupName then
			return i
		end
	end
	return nil
end

findADFbyFrequency = function(frequency)
local i

	local coa = 'blue'
	for i = 1,#HS_ADFlist[coa] do
		if HS_ADFlist[coa][i].frequency == frequency then
			return coa,i
		end
	end
	local coa = 'red'
	for i = 1,#HS_ADFlist[coa] do
		if HS_ADFlist[coa][i].frequency == frequency then
			return coa,i
		end
	end
	return nil
end

assignADF = function(coa,groupName)
local i

	for i = 1,#HS_ADFlist[coa] do
		if not HS_ADFlist[coa][i].group then
			HS_ADFlist[coa][i].group = groupName
			timer.scheduleFunction(emitBeacon,{groupName,HS_ADFlist[coa][i].frequency,HS_ADFlist[coa][i].modulation},timer.getTime()+1)
			return i
		end
	end
	return nil
end

CSARtasks = function(args)
local i,j,groupList,distance,grunts,MANPADS,units

	local coa = args[1]
	local pilotName = args[2]
	local pilotUnit = Unit.getByName(pilotName)
	if pilotUnit then
		local pilotPosition = Unit.getPosition(pilotUnit).p
		if coa == 'blue' then
			trigger.action.outSoundForCoalition(coalition.side.BLUE,'RadioClickAfter.ogg')
			trigger.action.outTextForCoalition(coalition.side.BLUE,'[You may not hear the beacon audio, but you can still home in on it]',20)
		else
			trigger.action.outSoundForCoalition(coalition.side.RED,'RadioClickAfter.ogg')
			trigger.action.outTextForCoalition(coalition.side.RED,'[You may not hear the beacon audio, but you can still home in on it]',20)
		end
		local count = 0
		groupList = {}
		for i = 1,#HS_ADFlist[coa] do
			if HS_ADFlist[coa][i].group then
				local groupName = HS_ADFlist[coa][i].group
				local group = Group.getByName(groupName)
				if group then
					local position = getLeadPosition(groupName)
					if position then
						if position.y < 0 then
							position.y = 0
						end
						trigger.action.signalFlare(position, trigger.flareColor.White, 0)
						distance = (pilotPosition.x-position.x)*(pilotPosition.x-position.x)+(pilotPosition.z-position.z)*(pilotPosition.z-position.z)
						local k
						grunts = 0
						MANPADS = 0
						units = Group.getUnits(group)
						for k=1,#units do
							if Unit.getTypeName(units[k]) == 'Soldier M4' or Unit.getTypeName(units[k]) == 'Infantry AK' then
								grunts = grunts + 1
							elseif Unit.getTypeName(units[k]) == 'Stinger manpad' or Unit.getTypeName(units[k]) == 'SA-18 Igla-S manpad' then
								MANPADS = MANPADS + 1
							end
						end
						if #groupList == 0 then
							if string.find(groupName, "grunts") then
								groupList[1] = {distance = distance, text = grunts .. ' inf. & ' .. MANPADS .. ' MPADS at ' .. printLatLong(position) .. ' on ' .. HS_ADFlist[coa][i].name}
							else
								groupList[1] = {distance = distance, text = 'Pilot down at ' .. printLatLong(position) .. ' on ' .. HS_ADFlist[coa][i].name}
							end
						else
							local inserted = false
							for j = 1,#groupList do
								if distance < groupList[j].distance then
									inserted = true
									if string.find(groupName, "grunts") then
										table.insert(groupList, j, {distance = distance, text = grunts .. ' inf. & ' .. MANPADS .. ' MPADS at ' .. printLatLong(position) .. ' on ' .. HS_ADFlist[coa][i].name})
									else
										table.insert(groupList, j, {distance = distance, text = 'Pilot down at ' .. printLatLong(position) .. ' on ' .. HS_ADFlist[coa][i].name})
									end
									break
								end
							end
							if not inserted then
								if string.find(groupName, "grunts") then
									groupList[#groupList+1] = {distance = distance, text = grunts .. ' inf. & ' .. MANPADS .. ' MPADS at ' .. printLatLong(position) .. ' on ' .. HS_ADFlist[coa][i].name}
								else
									groupList[#groupList+1] = {distance = distance, text = 'Pilot down at ' .. printLatLong(position) .. ' on ' .. HS_ADFlist[coa][i].name}
								end
							end
						end
						count = count + 1
					end
				end
			end
		end
		if count == 0 then
			if coa == 'blue' then
				trigger.action.outTextForCoalition(coalition.side.BLUE,'There are no active CSAR/air mobility tasks',20)
			else
				trigger.action.outTextForCoalition(coalition.side.RED,'There are no active CSAR/air mobility tasks',20)
			end
		else
			local longString = ''
			for i = 1,#groupList do
				longString = longString .. '\n' .. groupList[i].text
			end
			-- if coa == 'blue' then
				-- longString = longString .. '\n' .. 'For reference, FARP London is at 49 N 16 47, 00 E 24 11.'
			-- else
				-- longString = longString .. '\n' .. 'For reference, FARP Otkrytka is at 49 N 20 06, 01 W 06 15.'
			-- end
			if coa == 'blue' then
				trigger.action.outTextForCoalition(coalition.side.BLUE,longString,20)
			else
				trigger.action.outTextForCoalition(coalition.side.RED,longString,20)
			end
		end
	end
end

function myRandom(firstNum, secondNum) -- no support for decimals
	local lowNum, highNum
	if not secondNum then
		highNum = firstNum
		lowNum = 1
	else
		lowNum = firstNum
		highNum = secondNum
	end
	local total = 1
	if math.abs(highNum - lowNum + 1) < 50 then -- if total values is less than 50
		total = math.modf(50/math.abs(highNum - lowNum + 1)) -- make x copies required to be above 50
	end
	local choices = {}
	for i = 1, total do -- iterate required number of times
		for x = lowNum, highNum do -- iterate between the range
			choices[#choices +1] = x -- add each entry to a table
		end
	end
	local rtnVal = math.random(#choices) -- will now do a math.random of at least 50 choices
	for i = 1, 10 do
		rtnVal = math.random(#choices) -- iterate a few times for giggles
	end
	return choices[rtnVal]
end
				
printLatLong = function(position)
	local lat, lon = coord.LOtoLL(position)
	if math.floor((lat-math.floor(lat))*60) < 10 then
		lat = math.floor(lat) .. ' 0' .. math.floor((lat-math.floor(lat))*60)
	else
		lat = math.floor(lat) .. ' ' .. math.floor((lat-math.floor(lat))*60)
	end
	if math.floor((-lon-math.floor(-lon))*60) < 10 then
		lon = math.floor(-lon) .. ' 0' .. math.floor((-lon-math.floor(-lon))*60)
	else
		lon = math.floor(-lon) .. ' ' .. math.floor((-lon-math.floor(-lon))*60)
	end
	return lat.. 'N , ' .. lon .. 'W'
end

truckSighted = function(groupName)
local i,truckUnit,coa

	local group = Group.getByName(groupName)
	if group then
		for i = 1,5 do
			truckUnit = Group.getUnits(group)[i]
			if truckUnit then
				break
			end
		end
		if truckUnit then
			local side = Unit.getCoalition(truckUnit)			
			local truckPosition = Unit.getPosition(truckUnit).p
			if side == coalition.side.RED then
				trigger.action.outSoundForCoalition(coalition.side.BLUE,'RadioClickAfter.ogg')
				trigger.action.outTextForCoalition(coalition.side.BLUE,groupName .. ' has been spotted at ' .. printLatLong(truckPosition) .. ', marked by red smoke.',20)
				trigger.action.smoke(truckPosition, trigger.smokeColor.Red)
			else
				trigger.action.outSoundForCoalition(coalition.side.RED,'RadioClickAfter.ogg')
				trigger.action.outTextForCoalition(coalition.side.RED,groupName .. ' has been spotted at ' .. printLatLong(truckPosition) .. ', marked by blue smoke.',20)
				trigger.action.smoke(truckPosition, trigger.smokeColor.Blue)
			end
			-- trigger.action.smoke({x = truckPosition.x+10,y = truckPosition.y,z = truckPosition.z+10}, trigger.smokeColor.Green)
			timer.scheduleFunction(truckSighted,groupName,timer.getTime()+myRandom(10*60))
		end
	end
end

generateAAA = function(coa)
local count,maincount,countryName,unitType,centralPointx,centralPointx,position2

	for maincount = 1,3 do
		centerPointx = trigger.misc.getZone(coa .. ' AAA Zone #' .. maincount).point.x
		centerPointy = trigger.misc.getZone(coa .. ' AAA Zone #' .. maincount).point.z
		radius = trigger.misc.getZone(coa .. ' AAA Zone #' .. maincount).radius
		if coa == 'blue' then
			countryName = 'USA'		
		else
			countryName = 'RUSSIA'
		end
		position2 = { x = 0, y = 0 }
		for count = 1,10 do
			if coa == 'blue' then
				if count < 6 then
					unitType = 'Stinger manpad'
				else
					unitType = 'Vulcan'
				end
			else
				if count < 6 then
					unitType = 'SA-18 Igla-S manpad'
				else
					unitType = 'Ural-375 ZU-23'
				end
			end
			repeat
				position2.x = centerPointx-radius+myRandom(2*radius)
				position2.y = centerPointy-radius+myRandom(2*radius)
			until land.getSurfaceType(position2) ~= land.SurfaceType.SHALLOW_WATER and land.getSurfaceType(position2) ~= land.SurfaceType.WATER
			groupCounter = groupCounter+1
			unitCounter = unitCounter+1
			coalition.addGroup(country.id[countryName], Unit.Category["GROUND_UNIT"], {
				["visible"] = false,
				["route"] = 
				{
					["spans"] = 
					{
					}, -- end of ["spans"]
					["points"] = 
					{
						[1] = 
						{
							["alt"] = 0,
							["type"] = "Turning Point",
							["ETA"] = 0,
							["alt_type"] = "RADAR",
							["formation_template"] = "",
							["y"] = position2.y,
							["x"] = position2.x,
							["name"] = "",
							["ETA_locked"] = true,
							["speed"] = 0,
							["action"] = "Off Road",
							["task"] = 
							{
								["id"] = "ComboTask",
								["params"] = 
								{
									["tasks"] = 
									{
									}, -- end of ["tasks"]
								}, -- end of ["params"]
							}, -- end of ["task"]
							["speed_locked"] = true,
						}, -- end of [1]
					}, -- end of ["points"]
				}, -- end of ["route"]
				["groupId"] = groupCounter,
				["tasks"] = 
				{
				}, -- end of ["tasks"]
				["hidden"] = false,
				["units"] = 
				{
					[1] = 
					{
						["type"] = unitType,
						["transportable"] = 
						{
							["randomTransportable"] = false,
						}, -- end of ["transportable"]
						["unitId"] = unitCounter,
						["skill"] = "Random",
						["y"] = position2.y,
						["x"] = position2.x,
						["name"] = coa .. ' AAA Unit #' .. (maincount-1)*3+count,
						["playerCanDrive"] = true,
						["heading"] = 0,
					}, -- end of [1]
				}, -- end of ["units"]
				["y"] = position2.y,
				["x"] = position2.x,
				["name"] = coa .. ' AAA Group #' .. (maincount-1)*3+count,
				["start_time"] = 0,
				["task"] = "Ground Nothing",
			})
		end
	end
end

generateSpeedBoats = function(coa)
local count,countryName,unitType,centralPointx,centralPointx,position2

	if coa == 'blue' then
		countryName = 'USA'
		unitType = 'speedboat'
		centralPointx = -10000
		centralPointy = -25000
	else
		countryName = 'RUSSIA'
		unitType = 'speedboat'
		centralPointx = -10000
		centralPointy = -25000
	end
	position2 = { x = 0, y = 0 }
	for count = 1,4 do
		local waypoints = {}
		local points = {}
		for count = 1,6 do
			repeat
				position2.x = centralPointx-5000+myRandom(2*5000)
				position2.y = centralPointy-20000+myRandom(2*20000)
			until land.getSurfaceType(position2) == land.SurfaceType.WATER
			waypoints[count] ={}
			waypoints[count].y = position2.y
			waypoints[count].x = position2.x
			table.insert(points,{
								["alt"] = 0,
								["type"] = "Turning Point",
								["action"] = "Turning Point",
								["alt_type"] = "RADAR",
								["formation_template"] = "",
								["properties"] = 
								{
									["vnav"] = 1,
									["scale"] = 0,
									["angle"] = 0,
									["vangle"] = 0,
									["steer"] = 2,
								}, -- end of ["properties"]
								["ETA"] = 0,
								["y"] = waypoints[count].y,
								["x"] = waypoints[count].x,
								["name"] = "",
								["speed"] = 5,
								["ETA_locked"] = false,
								["task"] = 
								{
									["id"] = "ComboTask",
									["params"] = 
									{
										["tasks"] = 
										{
										}, -- end of ["tasks"]
									}, -- end of ["params"]
								}, -- end of ["task"]
								["speed_locked"] = true,
							})
		end
		points[1].ETA_locked = true
		groupCounter = groupCounter+1
		unitCounter = unitCounter+1
		coalition.addGroup(country.id[countryName], Unit.Category["SHIP"], {
			["visible"] = false,
			["route"] = 
			{
				["points"] = points,
			}, -- end of ["route"]
			["groupId"] = groupCounter,
			["tasks"] = 
			{
			}, -- end of ["tasks"]
			["hidden"] = false,
			["units"] = 
			{
				[1] = 
				{
					["type"] = "speedboat",
					["transportable"] = 
					{
						["randomTransportable"] = false,
					}, -- end of ["transportable"]
					["unitId"] = unitCounter,
					["skill"] = "Random",
					["y"] = points[1].y,
					["x"] = points[1].x,
					["name"] = coa .. " speedboat Unit # " .. unitCounter,
					["heading"] = 4.6288004213062,
				}, -- end of [1]
			}, -- end of ["units"]
			["y"] = points[1].y,
			["x"] = points[1].x,
			["name"] = coa .. " speedboat Group # " .. groupCounter,
			["start_time"] = 0,
		})
	end
end

countFighters = function(coa)
local count,aircraftList

	count = 0
	if coa == 'blue' then
		aircraftList = coalition.getGroups(coalition.side.BLUE , Group.Category.AIRPLANE)
	else
		aircraftList = coalition.getGroups(coalition.side.RED , Group.Category.AIRPLANE)
	end
	local i
	for i = 1,#aircraftList do
		local group = aircraftList[i]
		if group then
			local units = Group.getUnits(group)
			local j
			for j=1,#units do
				local unit = units[j]
				if unit then
					if Unit.isExist(unit) and Unit.inAir(unit) then
						if Unit.getTypeName(unit) == 'Su-27' or Unit.getTypeName(unit) == 'MiG-29A' or Unit.getTypeName(unit) == 'F-16C bl.52d' or Unit.getTypeName(unit) == 'F-15C' or Unit.getTypeName(unit) == 'M-2000C' then
							count = count + 1
						end
					end
				end
			end
		end
	end
	return(count)
end

activateFighter = function()
	local i
	local blueFighters = countFighters('blue')
	local redFighters = countFighters('red')
	-- trigger.action.outText('There are ' .. blueFighters .. ' blue fighters and ' .. redFighters .. ' red fighters.',30)
	if blueFighters == redFighters and A2ACounter.blue+A2ACounter.red > 0 then
		if redFighters < 10 then
			-- trigger.action.outText('spawning red fighter',10)
			timer.scheduleFunction(spawnFighter,'red',timer.getTime()+1)
		end
		if blueFighters < 10 then
			-- trigger.action.outText('spawning blue fighter',10)
			timer.scheduleFunction(spawnFighter,'blue',timer.getTime()+2)
		end
	elseif blueFighters > redFighters then 
		for i = 1,blueFighters-redFighters do
			-- trigger.action.outText('spawning red fighter',10)
			if redFighters < 10 then
				timer.scheduleFunction(spawnFighter,'red',timer.getTime()+i)
			end
		end
	elseif blueFighters < redFighters then 
		for i = 1,redFighters-blueFighters do
			-- trigger.action.outText('spawning blue fighter',10)
			if blueFighters < 10 then
				timer.scheduleFunction(spawnFighter,'blue',timer.getTime()+i)
			end
		end
	end
	timer.scheduleFunction(activateFighter,nil,timer.getTime()+myRandom(15*60))
end

activateCAS = function()
	spawnCAS('blue')
	spawnCAS('red')
	timer.scheduleFunction(activateCAS,nil,timer.getTime()+factor*myRandom(30*60))
end

printLatestTruckSightings = function()
local i
	for i =1,3 do
		trigger.action.outText(latestTruckSightings[i],20)
	end
end

function swap(a, b, table, pilotPosition)
local position,aDistance,bDistance

    if table[a] == nil or table[b] == nil then
		return false
    end
	position = Object.getPosition(table[a]).p
	aDistance = math.sqrt((pilotPosition.x-position.x)*(pilotPosition.x-position.x)+(pilotPosition.z-position.z)*(pilotPosition.z-position.z))
	position = Object.getPosition(table[b]).p
	bDistance = math.sqrt((pilotPosition.x-position.x)*(pilotPosition.x-position.x)+(pilotPosition.z-position.z)*(pilotPosition.z-position.z))
    if aDistance > bDistance then
        table[a], table[b] = table[b], table[a]
        return true
    end
    return false
end

function bubblesort(pilotPosition,array)
local redo

    for i=1,table.maxn(array) do
        local ci = i
		repeat
			redo = false
			if swap(ci, ci+1, array,pilotPosition) then
				ci = ci - 1
				redo = true
			end
		until not redo
    end
end

MASHinfo = function(pilotName)
local i,coa,unitName,value

	local longstring = ''
	local pilotUnit = Unit.getByName(pilotName)
	if pilotUnit then
		if Unit.getCoalition(pilotUnit) == coalition.side.BLUE then
			coa = 'blue'
			trigger.action.outTextForCoalition(coalition.side.BLUE,'[You may not hear the beacon audio, but you can still home in on it]',20)
		else
			coa = 'red'
				trigger.action.outTextForCoalition(coalition.side.RED,'[You may not hear the beacon audio, but you can still home in on it]',20)
		end
		local pilotGroup = Unit.getGroup(pilotUnit)
		local objectList = coalition.getAirbases(Unit.getCoalition(pilotUnit))
		if pilotGroup then
			for i = 1,#MASHzones[coa] do
				local sBegin,sEnd = string.find(MASHzones[coa][i].name, "Zone")
				if sBegin then
					local objectName = string.sub(MASHzones[coa][i].name, 1, sBegin-1) .. "Truck Unit #001"
					objectList[#objectList+1] = Unit.getByName(objectName)
				end
			end
			bubblesort(Unit.getPosition(pilotUnit).p,objectList)
			for i = 1,#objectList do
				local object = objectList[i]
				if Object.isExist(object) then
					local beaconPosition = Object.getPosition(object).p
					if Object.getCategory(object) == Object.Category.BASE then
						-- trigger.action.outTextForGroup(Group.getID(pilotGroup),'Airbase ' .. Airbase.getName(object),20)
						longstring = longstring .. Airbase.getName(object) .. ' at ' .. printLatLong(beaconPosition) .. ', use ATC for navigation, marked by flare.\n'
					elseif Object.getCategory(object) == Object.Category.UNIT then
						-- trigger.action.outTextForGroup(Group.getID(pilotGroup),'Unit ' .. Unit.getName(object),20)
						local sBegin,sEnd = string.find(Unit.getName(object), "Truck Unit #001")
						if sBegin then
							local objectName = string.sub(Unit.getName(object), 1, sBegin-1) .. "Zone"
							local j
							for j = 1,#MASHzones[coa] do
								if MASHzones[coa][j].name == objectName then
									local insertText
									if MASHzones[coa][j].active then
										insertText = ' (ACTIVE)'
									else
										insertText = ' (INACTIVE)'
									end
									longstring = longstring .. MASHzones[coa][j].name .. insertText.. ' at ' .. printLatLong(beaconPosition) .. ', broadcasting on ' .. MASHzones[coa][j].frequency .. ', marked by flare.\n'
								end
							end
						end
					end
					trigger.action.signalFlare(beaconPosition, trigger.flareColor.White, 0)
				end
			end
			trigger.action.outTextForGroup(Group.getID(pilotGroup),longstring,20)
		end
		-- for unitName,value in pairs(radioMASH) do
			-- HS_stopTransmission(unitName)
			-- timer.scheduleFunction(HS_groupSetADF2,{unitName,value.frequency,value.modulation},timer.getTime()+0.5)
			-- timer.scheduleFunction(HS_startTransmission,unitName,timer.getTime()+1)
		-- end
	end
end

spawnEscort = function(coa,pilotName)

	local pilotUnit = Unit.getByName(pilotName)
	if pilotUnit then
		local pilotGroup = Unit.getGroup(pilotUnit) 
		if pilotGroup then
			local pilotID = Group.getID(pilotGroup)
			if pilotID then
				local pilotPosition = Unit.getPosition(pilotUnit).p
				groupCounter = groupCounter+1
				unitCounter = unitCounter +1
				pilotCounter[coa] = pilotCounter[coa] +1
				local groupName = coa .. ' helo escort Group #' .. pilotCounter[coa]
				local unitName = coa .. ' helo escort Unit #' .. pilotCounter[coa]
				if coa == 'blue' then
					coalition.addGroup(country.id.USA, Unit.Category["HELICOPTER"], {
						["modulation"] = 0,
						["tasks"] = 
						{
						}, -- end of ["tasks"]
						["radioSet"] = false,
						["task"] = "Escort",
						["uncontrolled"] = false,
						["taskSelected"] = true,
						["route"] = 
						{
							["points"] = 
							{
								[1] = 
								{
									["alt"] = 100,
									["action"] = "Turning Point",
									["alt_type"] = "RADAR",
									["properties"] = 
									{
										["vnav"] = 1,
										["scale"] = 0,
										["angle"] = 0,
										["vangle"] = 0,
										["steer"] = 2,
									}, -- end of ["properties"]
									["speed"] = 55.555555555556,
									["task"] = 
									{
										["id"] = "ComboTask",
										["params"] = 
										{
											["tasks"] = 
											{
												[1] = 
												{
													["number"] = 1,
													["auto"] = false,
													["id"] = "Escort",
													["enabled"] = true,
													["params"] = 
													{
														["lastWptIndexFlagChangedManually"] = true,
														["groupId"] = pilotID,
														["engagementDistMax"] = 9250,
														["lastWptIndexFlag"] = false,
														["targetTypes"] = 
														{
															[1] = "Helicopters",
															[2] = "Ground Units",
														}, -- end of ["targetTypes"]
														["pos"] = 
														{
															["y"] = 30,
															["x"] = -30.48,
															["z"] = 30.48,
														}, -- end of ["pos"]
													}, -- end of ["params"]
												}, -- end of [1]
											}, -- end of ["tasks"]
										}, -- end of ["params"]
									}, -- end of ["task"]
									["type"] = "Turning Point",
									["ETA"] = 0,
									["ETA_locked"] = true,
									["y"] = findBehind(pilotName).z,
									["x"] = findBehind(pilotName).x,
									["name"] = "",
									["formation_template"] = "",
									["speed_locked"] = true,
								}, -- end of [1]
							}, -- end of ["points"]
						}, -- end of ["route"]
						["groupId"] = groupCounter,
						["hidden"] = false,
						["units"] = 
						{
							[1] = 
							{
								["alt"] = 100,
								["hardpoint_racks"] = true,
								["alt_type"] = "RADAR",
								["livery_id"] = "standard",
								["skill"] = "Random",
								["ropeLength"] = 15,
								["speed"] = 55.555555555556,
								["AddPropAircraft"] = 
								{
									["GunnersAISkill"] = 90,
									["ExhaustScreen"] = true,
								}, -- end of ["AddPropAircraft"]
								["type"] = "AH-1W",
								["unitId"] = unitCounter,
								["psi"] = 0,
								["y"] = findBehind(pilotName).z,
								["x"] = findBehind(pilotName).x,
								["name"] = unitName,
								["payload"] = 
								{
									["pylons"] = 
									{
										[1] = 
										{
											["CLSID"] = "{3EA17AB0-A805-4D9E-8732-4CE00CB00F17}",
										}, -- end of [1]
										[2] = 
										{
											["CLSID"] = "M260_HYDRA",
										}, -- end of [2]
										[3] = 
										{
											["CLSID"] = "M260_HYDRA",
										}, -- end of [3]
										[4] = 
										{
											["CLSID"] = "{3EA17AB0-A805-4D9E-8732-4CE00CB00F17}",
										}, -- end of [4]
									}, -- end of ["pylons"]
									["fuel"] = 875,
									["flare"] = 30,
									["chaff"] = 30,
									["gun"] = 100,
								}, -- end of ["payload"]
								["heading"] = 0,
								["callsign"] = 
								{
									[1] = 3,
									[2] = 1,
									[3] = 1 + unitCounter%4,
									["name"] = "Uzi 1-" .. unitCounter,
								}, -- end of ["callsign"]
								["onboard_num"] = "054",
							}, -- end of [1]
						}, -- end of ["units"]
						["y"] = findBehind(pilotName).z,
						["x"] = findBehind(pilotName).x,
						["name"] = groupName,
						["communication"] = true,
						["start_time"] = 0,
						["frequency"] = 124,
					})
				else
					coalition.addGroup(country.id.RUSSIA, Unit.Category["HELICOPTER"], {
						["modulation"] = 0,
						["tasks"] = 
						{
						}, -- end of ["tasks"]
						["task"] = "Escort",
						["uncontrolled"] = false,
						["taskSelected"] = true,
						["route"] = 
						{
							["points"] = 
							{
								[1] = 
								{
									["alt"] = 100,
									["action"] = "Turning Point",
									["alt_type"] = "RADAR",
									["properties"] = 
									{
										["vnav"] = 1,
										["scale"] = 0,
										["angle"] = 0,
										["vangle"] = 0,
										["steer"] = 2,
									}, -- end of ["properties"]
									["speed"] = 55.555555555556,
									["task"] = 
									{
										["id"] = "ComboTask",
										["params"] = 
										{
											["tasks"] = 
											{
												[1] = 
												{
													["number"] = 1,
													["auto"] = false,
													["id"] = "Escort",
													["enabled"] = true,
													["params"] = 
													{
														["lastWptIndexFlagChangedManually"] = true,
														["groupId"] = pilotID,
														["engagementDistMax"] = 9250,
														["lastWptIndexFlag"] = false,
														["targetTypes"] = 
														{
															[1] = "Helicopters",
															[2] = "Ground Units",
														}, -- end of ["targetTypes"]
														["pos"] = 
														{
															["y"] = 30,
															["x"] = -30.48,
															["z"] = 30.48,
														}, -- end of ["pos"]
													}, -- end of ["params"]
												}, -- end of [1]
											}, -- end of ["tasks"]
										}, -- end of ["params"]
									}, -- end of ["task"]
									["type"] = "Turning Point",
									["ETA"] = 0,
									["ETA_locked"] = true,
									["y"] = findBehind(pilotName).z,
									["x"] = findBehind(pilotName).x,
									["name"] = "",
									["formation_template"] = "",
									["speed_locked"] = true,
								}, -- end of [1]
							}, -- end of ["points"]
						}, -- end of ["route"]
						["groupId"] = 22,
						["hidden"] = false,
						["units"] = 
						{
							[1] = 
							{
								["alt"] = 100,
								["hardpoint_racks"] = true,
								["alt_type"] = "RADAR",
								["livery_id"] = "night",
								["skill"] = "High",
								["ropeLength"] = 15,
								["speed"] = 55.555555555556,
								["type"] = "Mi-28N",
								["unitId"] = 34,
								["psi"] = 0,
								["y"] = findBehind(pilotName).z,
								["x"] = findBehind(pilotName).x,
								["name"] = unitName,
								["payload"] = 
								{
									["pylons"] = 
									{
										[1] = 
										{
											["CLSID"] = "{57232979-8B0F-4db7-8D9A-55197E06B0F5}",
										}, -- end of [1]
										[2] = 
										{
											["CLSID"] = "{FC56DF80-9B09-44C5-8976-DCFAFF219062}",
										}, -- end of [2]
										[3] = 
										{
											["CLSID"] = "{FC56DF80-9B09-44C5-8976-DCFAFF219062}",
										}, -- end of [3]
										[4] = 
										{
											["CLSID"] = "{57232979-8B0F-4db7-8D9A-55197E06B0F5}",
										}, -- end of [4]
									}, -- end of ["pylons"]
									["fuel"] = 735,
									["flare"] = 128,
									["chaff"] = 0,
									["gun"] = 100,
								}, -- end of ["payload"]
								["heading"] = 0,
								["callsign"] = 600+unitCounter,
								["onboard_num"] = "051",
							}, -- end of [1]
						}, -- end of ["units"]
						["y"] = findBehind(pilotName).z,
						["x"] = findBehind(pilotName).x,
						["name"] = groupName,
						["communication"] = true,
						["start_time"] = 0,
						["frequency"] = 127.5,
					})
				end
			escort[pilotName] = unitName
			local count
			for count = 1,#airbaseList do
				local airbase = airbaseList[count]
				if Airbase.isExist(airbase) then
					local airbaseName = Airbase.getName(airbase)
					timer.scheduleFunction(overflyCheck,{airbaseName,unitName,groupName},timer.getTime()+60)
				end
			end
			for count = 1,#detectionZoneList do
				local zoneName = detectionZoneList[count]
				local zone = trigger.misc.getZone(zoneName)
				if zone then
					timer.scheduleFunction(overflyCheck,{zoneName,unitName,groupName},timer.getTime()+60)
				end
			end
			end
		end
	end
end

spawnFighter = function(coa)
	local count
	local waypoints = {}
	local points = {}
	local centerPointx = trigger.misc.getZone('Fighter Zone').point.x
	local centerPointy = trigger.misc.getZone('Fighter Zone').point.z
	local radius = trigger.misc.getZone('Fighter Zone').radius
	for count = 1,6 do
		waypoints[count] ={}
		waypoints[count].y = centerPointy-radius+myRandom(2*radius)
		waypoints[count].x = centerPointx-radius+myRandom(2*radius)
		table.insert(points,{
							["alt"] = 6096,
							["type"] = "Turning Point",
							["action"] = "Turning Point",
							["alt_type"] = "BARO",
							["formation_template"] = "",
							["properties"] = 
							{
								["vnav"] = 1,
								["scale"] = 0,
								["angle"] = 0,
								["vangle"] = 0,
								["steer"] = 2,
							}, -- end of ["properties"]
							["ETA"] = 0,
							["y"] = waypoints[count].y,
							["x"] = waypoints[count].x,
							["name"] = "",
							["speed"] = 69.444444444444,
							["ETA_locked"] = false,
							["task"] = 
							{
								["id"] = "ComboTask",
								["params"] = 
								{
									["tasks"] = 
									{
									}, -- end of ["tasks"]
								}, -- end of ["params"]
							}, -- end of ["task"]
							["speed_locked"] = true,
						})
	end
	centerPointx = trigger.misc.getZone(coa .. ' Fighter Zone').point.x
	centerPointy = trigger.misc.getZone(coa .. ' Fighter Zone').point.z
	radius = trigger.misc.getZone(coa .. ' Fighter Zone').radius
	points[1].y = centerPointy-radius+myRandom(2*radius)
	points[1].x = centerPointx-radius+myRandom(2*radius)
	points[1].ETA_locked = true
	points[1].task = {
		["id"] = "ComboTask",
		["params"] = 
		{
			["tasks"] = 
			{
				[1] = 
				{
					["enabled"] = true,
					["key"] = "FighterSweep",
					["id"] = "EngageTargets",
					["number"] = 1,
					["auto"] = true,
					["params"] = 
					{
						["targetTypes"] = 
						{
							[1] = "Planes",
						}, -- end of ["targetTypes"]
						["priority"] = 0,
					}, -- end of ["params"]
				}, -- end of [1]
			}, -- end of ["tasks"]
		}, -- end of ["params"]
	}
	points[6].task = {
		["id"] = "ComboTask",
		["params"] = 
		{
			["tasks"] = 
			{
				[1] = 
				{
					["enabled"] = true,
					["auto"] = false,
					["id"] = "WrappedAction",
					["number"] = 1,
					["params"] = 
					{
						["action"] = 
						{
							["id"] = "SwitchWaypoint",
							["params"] = 
							{
								["goToWaypointIndex"] = 2,
								["fromWaypointIndex"] = 6,
							}, -- end of ["params"]
						}, -- end of ["action"]
					}, -- end of ["params"]
				}, -- end of [1]
			}, -- end of ["tasks"]
		}, -- end of ["params"]
	}
	groupCounter = groupCounter+1
	unitCounter = unitCounter +1
	pilotCounter[coa] = pilotCounter[coa] +1
	local groupName = coa .. ' fighter AI Group #' .. pilotCounter[coa]
	local unitName = coa .. ' fighter AI Unit #' .. pilotCounter[coa]
	if coa == 'blue' then
		coalition.addGroup(country.id.USA, Unit.Category["AIRPLANE"], {
			["modulation"] = 0,
			["radioSet"] = false,
			["task"] = "Fighter Sweep",
			["uncontrolled"] = false,
			["taskSelected"] = true,
			["route"] = 
			{
				["points"] = points
			}, -- end of ["route"]
			["hidden"] = false,
			["units"] = 
			{
				[1] = 
				{
					["alt"] = 6069,
					["hardpoint_racks"] = true,
					["alt_type"] = "RADAR",
					["livery_id"] = "usaf 77th fs (sw) shaw afb",
					["skill"] = "Random",
					["speed"] = 152.77777777778,
					["type"] = "F-16C bl.52d",
					["unitId"] = unitCounter,
					["psi"] = -0.1672834992885,
					["y"] = points[1].y,
					["x"] = points[1].x,
					["name"] = unitName,
					["payload"] = 
					{
						["pylons"] = 
						{
							[1] = 
							{
								["CLSID"] = "{C8E06185-7CD6-4C90-959F-044679E90751}",
							}, -- end of [1]
							[3] = 
							{
								["CLSID"] = "{444BA8AE-82A7-4345-842E-76154EFCCA46}",
							}, -- end of [3]
							[4] = 
							{
								["CLSID"] = "{F376DBEE-4CAE-41BA-ADD9-B2910AC95DEC}",
							}, -- end of [4]
							[5] = 
							{
								["CLSID"] = "{CAAC1CFD-6745-416B-AFA4-CB57414856D0}",
							}, -- end of [5]
							[6] = 
							{
								["CLSID"] = "{6D21ECEA-F85B-4E8D-9D51-31DC9B8AA4EF}",
							}, -- end of [6]
							[7] = 
							{
								["CLSID"] = "{F376DBEE-4CAE-41BA-ADD9-B2910AC95DEC}",
							}, -- end of [7]
							[8] = 
							{
								["CLSID"] = "{444BA8AE-82A7-4345-842E-76154EFCCA46}",
							}, -- end of [8]
							[10] = 
							{
								["CLSID"] = "{C8E06185-7CD6-4C90-959F-044679E90751}",
							}, -- end of [10]
						}, -- end of ["pylons"]
						["fuel"] = 2483,
						["flare"] = 45,
						["chaff"] = 90,
						["gun"] = 100,
					}, -- end of ["payload"]
					["heading"] = -1.4896291831607,
					["callsign"] = 
					{
						[1] = 4,
						[2] = 1+(pilotCounter.blue / 4)%4,
						[3] = 1+pilotCounter.blue%4,
						["name"] = unitName,
					}, -- end of ["callsign"]
					["onboard_num"] = '1' .. pilotCounter.blue,
				}, -- end of [1]
			}, -- end of ["units"]
			["y"] = points[1].y,
			["x"] = points[1].x,
			["name"] = groupName,
			["groupId"] = groupCounter,
			["communication"] = true,
			["frequency"] = 125,
		})
	else
		coalition.addGroup(country.id.RUSSIA, Unit.Category["AIRPLANE"], {
			["modulation"] = 0,
			["radioSet"] = false,
			["task"] = "CAP",
			["uncontrolled"] = false,
			["taskSelected"] = true,
			["route"] = 
			{
				["points"] = points
			}, -- end of ["route"]
			["hidden"] = false,
			["units"] = 
			{
				[1] = 
				{
					["alt"] = 6069,
					["hardpoint_racks"] = true,
					["alt_type"] = "RADAR",
					["livery_id"] = "Air Force Standard",
					["skill"] = "Random",
					["speed"] = 152.77777777778,
					["type"] = "MiG-29A",
					["unitId"] = unitCounter,
					["psi"] = -0.1672834992885,
					["y"] = points[1].y,
					["x"] = points[1].x,
					["name"] = unitName,
					["payload"] = 
					{
						["pylons"] = 
						{
							[1] = 
							{
								["CLSID"] = "{682A481F-0CB5-4693-A382-D00DD4A156D7}",
							}, -- end of [1]
							[2] = 
							{
								["CLSID"] = "{682A481F-0CB5-4693-A382-D00DD4A156D7}",
							}, -- end of [2]
							[3] = 
							{
								["CLSID"] = "{9B25D316-0434-4954-868F-D51DB1A38DF0}",
							}, -- end of [3]
							[4] = 
							{
								["CLSID"] = "{2BEC576B-CDF5-4B7F-961F-B0FA4312B841}",
							}, -- end of [4]
							[5] = 
							{
								["CLSID"] = "{9B25D316-0434-4954-868F-D51DB1A38DF0}",
							}, -- end of [5]
							[6] = 
							{
								["CLSID"] = "{682A481F-0CB5-4693-A382-D00DD4A156D7}",
							}, -- end of [6]
							[7] = 
							{
								["CLSID"] = "{682A481F-0CB5-4693-A382-D00DD4A156D7}",
							}, -- end of [7]
						}, -- end of ["pylons"]
						["fuel"] = "3380",
						["flare"] = 30,
						["chaff"] = 30,
						["gun"] = 100,
					}, -- end of ["payload"]
					["heading"] = -1.4896291831607,
					["callsign"] = 900+pilotCounter.red,
				}, -- end of [1]
			}, -- end of ["units"]
			["y"] = points[1].y,
			["x"] = points[1].x,
			["name"] = groupName,
			["groupId"] = groupCounter,
			["communication"] = true,
			["frequency"] = 128.5,
		})
	end
	local count
	for count = 1,#airbaseList do
		local airbase = airbaseList[count]
		if Airbase.isExist(airbase) then
			local airbaseName = Airbase.getName(airbase)
			timer.scheduleFunction(overflyCheck,{airbaseName,unitName,groupName},timer.getTime()+60)
		end
	end
	for count = 1,#detectionZoneList do
		local zoneName = detectionZoneList[count]
		local zone = trigger.misc.getZone(zoneName)
		if zone then
			timer.scheduleFunction(overflyCheck,{zoneName,unitName,groupName},timer.getTime()+60)
		end
	end
end

spawnCAS = function(coa)
	local count
	local waypoints = {}
	local points = {}
	local centerPointx = trigger.misc.getZone('Fighter Zone').point.x
	local centerPointy = trigger.misc.getZone('Fighter Zone').point.z
	local radius = trigger.misc.getZone('Fighter Zone').radius
	for count = 1,6 do
		waypoints[count] ={}
		waypoints[count].y = centerPointy-radius+myRandom(2*radius)
		waypoints[count].x = centerPointx-radius+myRandom(2*radius)
		table.insert(points,{
							["alt"] = 6096,
							["type"] = "Turning Point",
							["action"] = "Turning Point",
							["alt_type"] = "BARO",
							["formation_template"] = "",
							["properties"] = 
							{
								["vnav"] = 1,
								["scale"] = 0,
								["angle"] = 0,
								["vangle"] = 0,
								["steer"] = 2,
							}, -- end of ["properties"]
							["ETA"] = 0,
							["y"] = waypoints[count].y,
							["x"] = waypoints[count].x,
							["name"] = "",
							["speed"] = 69.444444444444,
							["ETA_locked"] = false,
							["task"] = 
							{
								["id"] = "ComboTask",
								["params"] = 
								{
									["tasks"] = 
									{
									}, -- end of ["tasks"]
								}, -- end of ["params"]
							}, -- end of ["task"]
							["speed_locked"] = true,
						})
	end
	centerPointx = trigger.misc.getZone(coa .. ' Fighter Zone').point.x
	centerPointy = trigger.misc.getZone(coa .. ' Fighter Zone').point.z
	radius = trigger.misc.getZone(coa .. ' Fighter Zone').radius
	points[1].y = centerPointy-radius+myRandom(2*radius)
	points[1].x = centerPointx-radius+myRandom(2*radius)
	points[1].ETA_locked = true
	points[1].task = {
		["id"] = "ComboTask",
		["params"] = 
		{
			["tasks"] = 
			{
				[1] = 
				{
					["number"] = 1,
					["key"] = "CAS",
					["id"] = "EngageTargets",
					["enabled"] = true,
					["auto"] = true,
					["params"] = 
					{
						["targetTypes"] = 
						{
							-- [1] = "Helicopters",
							[1] = "Ground Units",
							-- [3] = "Light armed ships",
						}, -- end of ["targetTypes"]
						["priority"] = 0,
					}, -- end of ["params"]
				}, -- end of [1]
			}, -- end of ["tasks"]
		}, -- end of ["params"]
	}
	points[6].task = {
		["id"] = "ComboTask",
		["params"] = 
		{
			["tasks"] = 
			{
				[1] = 
				{
					["enabled"] = true,
					["auto"] = false,
					["id"] = "WrappedAction",
					["number"] = 1,
					["params"] = 
					{
						["action"] = 
						{
							["id"] = "SwitchWaypoint",
							["params"] = 
							{
								["goToWaypointIndex"] = 2,
								["fromWaypointIndex"] = 6,
							}, -- end of ["params"]
						}, -- end of ["action"]
					}, -- end of ["params"]
				}, -- end of [1]
			}, -- end of ["tasks"]
		}, -- end of ["params"]
	}
	groupCounter = groupCounter+1
	unitCounter = unitCounter +1
	pilotCounter[coa] = pilotCounter[coa] +1
	local groupName = coa .. ' fighter AI Group #' .. pilotCounter[coa]
	local unitName = coa .. ' fighter AI Unit #' .. pilotCounter[coa]
	if coa == 'blue' then
		coalition.addGroup(country.id.USA, Unit.Category["AIRPLANE"], {
			["modulation"] = 0,
			["radioSet"] = false,
			["task"] = "Fighter Sweep",
			["uncontrolled"] = false,
			["taskSelected"] = true,
			["route"] = 
			{
				["points"] = points
			}, -- end of ["route"]
			["hidden"] = false,
			["units"] = 
			{
				[1] = 
				{
					["alt"] = 6069,
					["hardpoint_racks"] = true,
					["alt_type"] = "RADAR",
					["livery_id"] = "104th FS Maryland ANG, Baltimore (MD)",
					["skill"] = "Random",
					["speed"] = 152.77777777778,
					["type"] = "A-10A",
					["unitId"] = unitCounter,
					["psi"] = -0.1672834992885,
					["y"] = points[1].y,
					["x"] = points[1].x,
					["name"] = unitName,
					["payload"] = 
					{
						["pylons"] = 
						{
						}, -- end of ["pylons"]
						["fuel"] = 2046,
						["flare"] = 15,
						["ammo_type"] = 1,
						["chaff"] = 30,
						["gun"] = 100,
					}, -- end of ["payload"]
					["heading"] = -1.4896291831607,
					["callsign"] = 
					{
						[1] = 4,
						[2] = 1+(pilotCounter.blue / 4)%4,
						[3] = 1+pilotCounter.blue%4,
						["name"] = unitName,
					}, -- end of ["callsign"]
					["onboard_num"] = '1' .. pilotCounter.blue,
				}, -- end of [1]
			}, -- end of ["units"]
			["y"] = points[1].y,
			["x"] = points[1].x,
			["name"] = groupName,
			["groupId"] = groupCounter,
			["communication"] = true,
			["frequency"] = 125,
		})
	else
		coalition.addGroup(country.id.RUSSIA, Unit.Category["AIRPLANE"], {
			["modulation"] = 0,
			["radioSet"] = false,
			["task"] = "CAS",
			["uncontrolled"] = false,
			["taskSelected"] = true,
			["route"] = 
			{
				["points"] = points
			}, -- end of ["route"]
			["hidden"] = false,
			["units"] = 
			{
				[1] = 
				{
					["alt"] = 6069,
					["hardpoint_racks"] = true,
					["alt_type"] = "RADAR",
					["livery_id"] = "field camo scheme #1 (native)",
					["skill"] = "Random",
					["speed"] = 152.77777777778,
					["type"] = "Su-25",
					["unitId"] = unitCounter,
					["psi"] = -0.1672834992885,
					["y"] = points[1].y,
					["x"] = points[1].x,
					["name"] = unitName,
					["payload"] = 
					{
						["pylons"] = 
						{
						}, -- end of ["pylons"]
						["fuel"] = 2280,
						["flare"] = 40,
						["ammo_type"] = 1,
						["chaff"] = 18,
						["gun"] = 100,
					}, -- end of ["payload"]
					["heading"] = -1.4896291831607,
					["callsign"] = 900+pilotCounter.red,
				}, -- end of [1]
			}, -- end of ["units"]
			["y"] = points[1].y,
			["x"] = points[1].x,
			["name"] = groupName,
			["groupId"] = groupCounter,
			["communication"] = true,
			["frequency"] = 128.5,
		})
	end
	local count
	for count = 1,#airbaseList do
		local airbase = airbaseList[count]
		if Airbase.isExist(airbase) then
			local airbaseName = Airbase.getName(airbase)
			timer.scheduleFunction(overflyCheck,{airbaseName,unitName,groupName},timer.getTime()+60)
		end
	end
	for count = 1,#detectionZoneList do
		local zoneName = detectionZoneList[count]
		local zone = trigger.misc.getZone(zoneName)
		if zone then
			timer.scheduleFunction(overflyCheck,{zoneName,unitName,groupName},timer.getTime()+60)
		end
	end
end

SpringfieldHasLanded = function(pilotName,airbase)
local count,shipName

	local pilotUnit = Unit.getByName(pilotName)
	if pilotUnit then
		local side = Unit.getCoalition(pilotUnit)
		if side == coalition.side.BLUE then
			coa = 'blue'
		elseif side == coalition.side.RED then
			coa = 'red'
		else
			return
		end
		trigger.action.outSoundForCoalition(side,'RadioClickAfter.ogg')
		trigger.action.outTextForCoalition(side,pilotName .. ' has landed.',20)
		local pilotPosition = Unit.getPosition(pilotUnit).p
		local i
		for i = 1,pilotDownCounter[coa] do
			local pilotDownUnit = Unit.getByName(coa .. ' Pilot Down Unit #' .. i)
			if pilotDownUnit then
				local pilotDownPosition = Unit.getPosition(pilotDownUnit).p
				local distance = (pilotDownPosition.x-pilotPosition.x)*(pilotDownPosition.x-pilotPosition.x)+(pilotDownPosition.z-pilotPosition.z)*(pilotDownPosition.z-pilotPosition.z)
				if distance < 10000 then
					trigger.action.outTextForCoalition(side,coa .. ' Pilot Down Unit #' .. i .. ' has been rescued.',20)
					trigger.action.outTextForCoalition(side,'Take him to a friendly airbase or MASH [see F-10 other menu for list]',20)
					local pilotDownGroup = Unit.getGroup(pilotDownUnit)
					if pilotDownGroup then
						Group.destroy(pilotDownGroup)
						if pilotDownPosition then
							local groupName = spawnGrunts(coa,pilotDownPosition,1,'temporary')
							local inFrontPos = findInFront(pilotName)
							if inFrontPos then
								timer.scheduleFunction(moveGroup2,{groupName, pilotDownPosition, inFrontPos},timer.getTime()+1)
								timer.scheduleFunction(Group.destroy,Group.getByName(groupName),timer.getTime()+math.sqrt((pilotDownPosition.x-inFrontPos.x)*(pilotDownPosition.x-inFrontPos.x)+(pilotDownPosition.z-inFrontPos.z)*(pilotDownPosition.z-inFrontPos.z))/3)
							end
						end
					end
					rescuedPilots[pilotName] = rescuedPilots[pilotName] + 1
				end
			end
		end
		for i = 1,#MASHzones[coa] do
			if MASHzones[coa][i].active then
				local zone = trigger.misc.getZone(MASHzones[coa][i].name)
				if zone then
					local zonePosition = zone.point
					local distance = (zonePosition.x-pilotPosition.x)*(zonePosition.x-pilotPosition.x)+(zonePosition.z-pilotPosition.z)*(zonePosition.z-pilotPosition.z)
					if distance < zone.radius*zone.radius then
						trigger.action.outTextForCoalition(side,rescuedPilots[pilotName] .. ' downed pilots have been dropped off at ' .. MASHzones[coa][i].name .. ' for 25 points each.',20)
						score[coa] = score[coa] + rescuedPilots[pilotName]*25
						local planecounter
						for planecounter = 1,rescuedPilots[pilotName] do
							timer.scheduleFunction(spawnFighter,coa,timer.getTime()+planecounter)
							trigger.action.outTextForCoalition(side,'A new AI fighter has been spawned.',20)
						end
						rescuedPilots[pilotName] = 0
						trigger.action.outTextForCoalition(side,rescuedSailors[pilotName]*8 .. ' rescued sailors have been dropped off at ' .. MASHzones[coa][i].name .. ' for ' .. rescuedSailors[pilotName]*25 .. ' points.',20)
						score[coa] = score[coa] + rescuedSailors[pilotName]*25
						rescuedSailors[pilotName] = 0
					end
				end
			end
		end
		if airbase then
			trigger.action.outTextForCoalition(side,rescuedPilots[pilotName] .. ' downed pilots have been dropped off at ' .. Airbase.getName(airbase) .. ' for 25 points each.',20)
			score[coa] = score[coa] + rescuedPilots[pilotName]*25
			local planecounter
			for planecounter = 1,rescuedPilots[pilotName] do
				timer.scheduleFunction(spawnFighter,coa,timer.getTime()+planecounter)
				trigger.action.outTextForCoalition(side,'A new AI fighter has been spawned.',20)
			end
			rescuedPilots[pilotName] = 0
			trigger.action.outTextForCoalition(side,rescuedSailors[pilotName]*8 .. ' rescued sailors have been dropped off at ' .. Airbase.getName(airbase) .. ' for ' .. rescuedSailors[pilotName]*25 .. ' points.',20)
			score[coa] = score[coa] + rescuedSailors[pilotName]*25
			rescuedSailors[pilotName] = 0
		end
		if coa == 'blue' then
			shipName = 'Oliver Hazzard Perry'
		else
			shipName = 'Neustrashimy'
		end
		local shipUnit = Unit.getByName(shipName)
		if shipUnit then
			local shipPosition = Unit.getPosition(shipUnit).p
			local distance = (shipPosition.x-pilotPosition.x)*(shipPosition.x-pilotPosition.x)+(shipPosition.z-pilotPosition.z)*(shipPosition.z-pilotPosition.z)
			if distance < 50000 and rescuedSailors[pilotName] == 0 and shipInDistress[shipName] then
				trigger.action.outTextForCoalition(side,pilotName .. ' has landed on the ' .. shipName .. '. 8 sailors have been rescued.',20)
				trigger.action.outTextForCoalition(side,'Take them to a friendly airbase or MASH [use F-10 other menu for a list]',20)
				rescuedSailors[pilotName] = 1
			end
		end
	end
end

hoverCheck2 = function(arg)
local pilotDownSide,pilotSide
	local pilotDownName = arg[1]
	local pilotName = arg[2]
	local counter = arg[3]
	local pilotDownGroup = Group.getByName(pilotDownName)
	if pilotDownGroup then
		pilotDownSide = Group.getCoalition(pilotDownGroup)
		pilotDownPosition = getLeadPosition(pilotDownName)
		local pilotUnit = Unit.getByName(pilotName)
		if pilotUnit then
			pilotSide = Unit.getCoalition(pilotUnit)
			if pilotDownSide == pilotSide then
				if counter == 0 then
					trigger.action.outTextForCoalition(pilotSide,pilotDownName .. ' has been rescued.',20)
					trigger.action.outTextForCoalition(pilotSide,'Take him to a friendly airbase or MASH [see F-10 other menu for list]',20)
					pilotDownGroup:destroy()
					rescuedPilots[pilotName] = rescuedPilots[pilotName] + 1
				else
					local pilotPosition = Unit.getPosition(pilotUnit).p
					local distance = math.sqrt((pilotDownPosition.x-pilotPosition.x)*(pilotDownPosition.x-pilotPosition.x)+(pilotDownPosition.z-pilotPosition.z)*(pilotDownPosition.z-pilotPosition.z))
					local terrainHeight = pilotDownPosition.y
					if terrainHeight < 0 then
						terrainHeight = 0
					end
					if distance < 1000 then
						if distance > 100 then
							trigger.action.signalFlare(pilotDownPosition, trigger.flareColor.White, 0)
						end
						trigger.action.outTextForGroup(Group.getID(Unit.getGroup(pilotUnit)),math.floor(distance) .. ' m',1) -- output warning text and audio
					end
					if string.find(pilotDownName, "Pilot Down") and distance < 20 and pilotPosition.y > (terrainHeight + 25) and pilotPosition.y < (terrainHeight + 35) then
						trigger.action.outTextForCoalition(pilotSide,pilotName .. ', hover here for ' .. counter .. ' s!',10)
						timer.scheduleFunction(hoverCheck2,{pilotDownName,pilotName,counter-1},timer.getTime()+1+distance/100)
					else
						-- trigger.action.outTextForCoalition(pilotSide,pilotName .. ' is ' .. math.floor(distance) .. ' m from ' .. pilotDownName,10)
						timer.scheduleFunction(hoverCheck2,{pilotDownName,pilotName,10},timer.getTime()+1+distance/100)
					end
				end
			end
		end
	end
end

hoverCheck = function(pilotDownName,counter)
local pilotDownSide,pilotSide
	local pilotDownGroup = Group.getByName(pilotDownName)
	if pilotDownGroup then
		pilotDownSide = Group.getCoalition(pilotDownGroup)
		local count
		for count = 1,#clientHeloNames do
			local pilotName = clientHeloNames[count]
			local pilotUnit = Unit.getByName(pilotName)
			if pilotUnit then
				pilotSide = Unit.getCoalition(pilotUnit)
				if pilotDownSide == pilotSide then
					pilotDownPosition = getLeadPosition(pilotDownName)
					local pilotPosition = Unit.getPosition(pilotUnit).p
					local distance = math.sqrt((pilotDownPosition.x-pilotPosition.x)*(pilotDownPosition.x-pilotPosition.x)+(pilotDownPosition.z-pilotPosition.z)*(pilotDownPosition.z-pilotPosition.z))
					-- trigger.action.outTextForCoalition(pilotSide,pilotName .. ' is ' .. math.floor(distance) .. ' m from ' .. pilotDownName,10)
					timer.scheduleFunction(hoverCheck2,{pilotDownName,pilotName,counter},timer.getTime()+1+distance/100)
				end
			end
		end
	end
end

function getHeading(unit, rawHeading)
	local unitpos = unit:getPosition()
	if unitpos then
		local Heading = math.atan2(unitpos.x.z, unitpos.x.x)
		if Heading < 0 then
			Heading = Heading + 2*math.pi  -- put heading in range of 0 to 2*pi
		end
		return Heading
	end
end

wasSpotted = function(pilotName,name)
	
	local pilotUnit = Unit.getByName(pilotName)
	if pilotUnit then
		local pilotSide = Unit.getCoalition(pilotUnit)
		local pilotPosition = Unit.getPosition(pilotUnit).p
		local angels = math.max(math.floor(pilotPosition.y/333),1)
		local heading = getHeading(pilotUnit)
		heading = (heading + 45/360*math.pi) % (2*math.pi)
		heading = math.floor(heading/2/math.pi*8)+1
		local headingText = headingTexts[heading]
		if pilotSide == coalition.side.BLUE then
			trigger.action.outSoundForCoalition(coalition.side.RED,'RadioClickAfter.ogg')
			trigger.action.outTextForCoalition(coalition.side.RED,'Enemy ' .. pilotUnit:getTypeName() .. ' has been spotted near ' .. name .. ' at angels ' .. angels .. ', flowing ' .. headingText .. '.',10)
			-- trigger.action.smoke({x = pilotPosition.x, y = math.max(land.getHeight({x = pilotPosition.x, y = pilotPosition.z}),0),z = pilotPosition.z}, trigger.smokeColor.Blue)
		else
			trigger.action.outSoundForCoalition(coalition.side.BLUE,'RadioClickAfter.ogg')
			trigger.action.outTextForCoalition(coalition.side.BLUE,'Enemy ' .. pilotUnit:getTypeName() .. ' has been spotted near ' .. name .. ' at angels ' .. angels .. ', flowing ' .. headingText .. '.',10)
			-- trigger.action.smoke({x = pilotPosition.x, y = math.max(land.getHeight({x = pilotPosition.x, y = pilotPosition.z}),0),z = pilotPosition.z}, trigger.smokeColor.Red)
		end
	end
end

overflyCheck = function(arg)
local zonePosition

	local zoneName = arg[1]
	local pilotName = arg[2]
	local groupName = arg[3]
	zonePosition = nil
	local zone = trigger.misc.getZone(zoneName)
	if zone then
		zonePosition = zone.point
	else
		local airbase = Airbase.getByName(zoneName)
		if airbase then
			zonePosition = Airbase.getPosition(airbase).p
		end
	end
	if zonePosition then
		local pilotUnit = Unit.getByName(pilotName)
		if pilotUnit then
			local pilotSide = Unit.getCoalition(pilotUnit)
			local pilotPosition = Unit.getPosition(pilotUnit).p
			local distance = math.sqrt((zonePosition.x-pilotPosition.x)*(zonePosition.x-pilotPosition.x)+(zonePosition.z-pilotPosition.z)*(zonePosition.z-pilotPosition.z))
			if distance < 3000 then
				-- trigger.action.outTextForCoalition(pilotSide,pilotName .. ' is ' .. math.floor(distance) .. ' m from ' .. zoneName,10)
				if Unit.inAir(pilotUnit) then
					wasSpotted(pilotName,zoneName)
				end
				timer.scheduleFunction(overflyCheck,{zoneName,pilotName,groupName},timer.getTime()+60)
			else
				-- trigger.action.outTextForCoalition(pilotSide,pilotName .. ' is ' .. math.floor(distance) .. ' m from ' .. zoneName,10)
				timer.scheduleFunction(overflyCheck,{zoneName,pilotName,groupName},timer.getTime()+1+distance/400)
			end
		else
			local group = Group.getByName(groupName)
			local count
			pilotUnit = nil
			local units = Group.getUnits(group)
			if units then
				for count = 1,#units do
					local unit = units[count]
					if unit then
						if Unit.isExist(unit) then
							pilotUnit = unit
							break
						end
					end
				end
			end
			if pilotUnit then
				timer.scheduleFunction(overflyCheck,{zoneName,Unit.getName(pilotUnit),groupName},timer.getTime()+60)
			end
		end
	end
end

doSpot = function(groupName)
	local group = Group.getByName(groupName)
	local count,pilotUnit
	local units = Group.getUnits(group)
	if units then
		for count = 1,#units do
			local unit = units[count]
			if unit then
				if Unit.isExist(unit) then
					pilotUnit = unit
					break
				end
			end
		end
	end
	if pilotUnit then
		local pilotName = Unit.getName(pilotUnit)
		local pilotSide = Unit.getCoalition(pilotUnit)
		local pilotPosition = Unit.getPosition(pilotUnit).p
		local count
		for count = 1,#airbaseList do
			local airbase = airbaseList[count]
			if Airbase.isExist(airbase) then
				local airbaseName = Airbase.getName(airbase)
				local airbasePosition = Airbase.getPosition(airbase).p
				local distance = math.sqrt((airbasePosition.x-pilotPosition.x)*(airbasePosition.x-pilotPosition.x)+(airbasePosition.z-pilotPosition.z)*(airbasePosition.z-pilotPosition.z))
				-- trigger.action.outTextForCoalition(pilotSide,pilotName .. ' is ' .. math.floor(distance) .. ' m from ' .. airbaseName,10)
				timer.scheduleFunction(overflyCheck,{airbaseName,pilotName,groupName},timer.getTime()+1+distance/100)
			end
		end
		for count = 1,#detectionZoneList do
			local zoneName = detectionZoneList[count]
			local zone = trigger.misc.getZone(zoneName)
			if zone then
				local zonePosition = zone.point
				local distance = math.sqrt((zonePosition.x-pilotPosition.x)*(zonePosition.x-pilotPosition.x)+(zonePosition.z-pilotPosition.z)*(zonePosition.z-pilotPosition.z))
				-- trigger.action.outTextForCoalition(pilotSide,pilotName .. ' is ' .. math.floor(distance) .. ' m from ' .. zoneName,10)
				timer.scheduleFunction(overflyCheck,{zoneName,pilotName,groupName},timer.getTime()+1+distance/100)
			end
		end
	end
end

closestLandmark = function(pilotPosition)
	local count,closestDistance,closestName,closestPosition
	closestDistance = 1E6
	closestName = nil
	closestPosition = nil
	for count = 1,#airbaseList do
		local airbase = airbaseList[count]
		if Airbase.isExist(airbase) then
			local airbaseName = Airbase.getName(airbase)
			local airbasePosition = Airbase.getPosition(airbase).p
			local distance = math.sqrt((airbasePosition.x-pilotPosition.x)*(airbasePosition.x-pilotPosition.x)+(airbasePosition.z-pilotPosition.z)*(airbasePosition.z-pilotPosition.z))
			-- trigger.action.outTextForCoalition(pilotSide,pilotName .. ' is ' .. math.floor(distance) .. ' m from ' .. airbaseName,10)
			if distance < closestDistance then
				closestDistance = distance
				closestName = airbaseName
				closestPosition = airbasePosition
			end
		end
	end
	for count = 1,#detectionZoneList do
		local zoneName = detectionZoneList[count]
		local zone = trigger.misc.getZone(zoneName)
		if zone then
			local zonePosition = zone.point
			local distance = math.sqrt((zonePosition.x-pilotPosition.x)*(zonePosition.x-pilotPosition.x)+(zonePosition.z-pilotPosition.z)*(zonePosition.z-pilotPosition.z))
			-- trigger.action.outTextForCoalition(pilotSide,pilotName .. ' is ' .. math.floor(distance) .. ' m from ' .. zoneName,10)
			if distance < closestDistance then
				closestDistance = distance
				closestName = zoneName
				closestPosition = zonePosition
			end
		end
	end
	return ({name = closestName,p = closestPosition})
end

tallyAAA = function(playerName) -- this is the main routine, coa contains the name of the coalition that was targeted by the missile
local i,coa,oppCoa,weaponName,playerPosition

	local playerUnit = Unit.getByName(playerName) -- get unit
	if playerUnit then -- is unit alive?
		tally[playerName] = true
		if Unit.getTypeName(playerUnit) ~= 'Ka-50' then
			if Unit.getCoalition(playerUnit) == coalition.side.BLUE then
				coa = 'blue'
				oppCoa = 'red'
			else
				coa = 'red'
				oppCoa = 'blue'
			end
			local minimumDistance = 1E6
			local minimumName = false
			for i=1,#AAAList[oppCoa] do
				local weaponName = AAAList[oppCoa][i]
				local weapon = Unit.getByName(weaponName)
				if weapon then
					local position = Unit.getPosition(weapon).p -- get position of missile
					playerPosition = Unit.getPosition(playerUnit).p -- get position of helicopter
					if land.isVisible(playerPosition, position) then
						local relativePosition = {x=position.x-playerPosition.x, y=position.y-playerPosition.y, z=position.z-playerPosition.z}
						local distance = math.sqrt(relativePosition.x*relativePosition.x+relativePosition.y*relativePosition.y+relativePosition.z*relativePosition.z)
						if distance < minimumDistance then
							minimumDistance = distance
							minimumName = weaponName
						end
					end
				end
			end
			if minimumName and minimumDistance < 5000 then
				local weapon = Unit.getByName(minimumName)
				if weapon then
					local position = Unit.getPosition(weapon).p -- get position of missile
					local relativePosition = {x=position.x-playerPosition.x, y=position.y-playerPosition.y, z=position.z-playerPosition.z}
					local playerHeading = getHeading(playerUnit) -- the rest of the code determines the 'o'clock' bearing of the missile relative to the helicopter
					local headingVector = {x = math.cos(playerHeading),y=0,z=math.sin(playerHeading)}
					local headingVectorPerpendicular = {x = math.cos(playerHeading+math.pi/2),y=0,z=math.sin(playerHeading+math.pi/2)}
					local forwardDistance = relativePosition.x*headingVector.x+relativePosition.y*headingVector.y+relativePosition.z*headingVector.z
					local rightDistance = relativePosition.x*headingVectorPerpendicular.x+relativePosition.y*headingVectorPerpendicular.y+relativePosition.z*headingVectorPerpendicular.z
					local angle = math.atan2(rightDistance,forwardDistance)*180/math.pi
					if angle < 0 then
						angle = 360+angle
					end
					angle = math.floor(angle*12/360+0.5)
					if angle == 0 then
						angle = 12
					end
					local text = '[copilot] Tally enemy ' .. Unit.getTypeName(weapon) ..', ' .. angle .. ' oclock for ' .. math.floor(minimumDistance/1800+1)
					trigger.action.outSoundForGroup(Group.getID(Unit.getGroup(playerUnit)),'tally.ogg') -- output warning text and audio
					trigger.action.outTextForGroup(Group.getID(Unit.getGroup(playerUnit)),playerName .. text,10) -- output warning text and audio
				end
			end
		end
		timer.scheduleFunction(tallyAAA,playerName,timer.getTime()+10)
	else
		tally[playerName] = false
	end
end

HS_incoming = function(arg) -- this is the main routine, coa contains the name of the coalition that was targeted by the missile
local i

	local coa = arg[1]
	local event = arg[2]
	local weapon = event.weapon
	if Weapon.isExist(weapon) then
		for i=1,#clientHeloNames do -- loop of all client helicopter in the mission that belong to the target coalition
			local playerName = clientHeloNames[i]
			local playerUnit = Unit.getByName(playerName) -- get unit
			if playerUnit then -- is unit alive?
				if Unit.getTypeName(playerUnit) == 'SA342M' or Unit.getTypeName(playerUnit) == 'Mi-8MT' or Unit.getTypeName(playerUnit) == 'UH-1H' then
					if (coa == 'blue' and Unit.getCoalition(playerUnit) == coalition.side.BLUE) or (coa == 'red' and Unit.getCoalition(playerUnit) == coalition.side.RED) then
						local position = Weapon.getPosition(weapon).p -- get position of missile
						local playerPosition = Unit.getPosition(playerUnit).p -- get position of helicopter
						local relativePosition = {x=position.x-playerPosition.x, y=position.y-playerPosition.y, z=position.z-playerPosition.z}
						if math.sqrt(relativePosition.x*relativePosition.x+relativePosition.y*relativePosition.y+relativePosition.z*relativePosition.z) < 5000 then -- was the missile launch within the detection range?
							local playerHeading = getHeading(playerUnit) -- the rest of the code determines the 'o'clock' bearing of the missile relative to the helicopter
							local headingVector = {x = math.cos(playerHeading),y=0,z=math.sin(playerHeading)}
							local headingVectorPerpendicular = {x = math.cos(playerHeading+math.pi/2),y=0,z=math.sin(playerHeading+math.pi/2)}
							local forwardDistance = relativePosition.x*headingVector.x+relativePosition.y*headingVector.y+relativePosition.z*headingVector.z
							local rightDistance = relativePosition.x*headingVectorPerpendicular.x+relativePosition.y*headingVectorPerpendicular.y+relativePosition.z*headingVectorPerpendicular.z
							local angle = math.atan2(rightDistance,forwardDistance)*180/math.pi
							if angle < 0 then
								angle = 360+angle
							end
							angle = math.floor(angle*12/360+0.5)
							if angle == 0 then
								angle = 12
							end
							local text = '[copilot] Incoming ' .. angle .. ' oclock'
							trigger.action.outSoundForGroup(Group.getID(Unit.getGroup(playerUnit)),'incoming.ogg') -- output warning text and audio
							trigger.action.outTextForGroup(Group.getID(Unit.getGroup(playerUnit)),playerName .. text,1) -- output warning text and audio
						end
					end
				end
			end
		end
		timer.scheduleFunction(HS_incoming,{coa,event},timer.getTime()+1) -- next warning will occur in 1 second
	end
end

printScore2 = function()

	local coa = {'blue','red'}
	local sides = {coalition.side.BLUE,coalition.side.RED}
	trigger.action.outText('Blue score: ' .. score.blue .. ', red score: ' .. score.red,20)
	local count
	for count =1,2 do
		outString = coa[count] .. ' sling load tasks [use F-10,F-4 menu for info about MASHs]: '
		local name,value
		for name,value in pairs(slingLoadTasks[coa[count]]) do
			if value then
				outString = outString .. name
			end
		end
		local i
		local clientHeloGroupNames = {}
		for i = 1,#clientHeloNames do
			local unit = Unit.getByName(clientHeloNames[i])
			if unit then
				if Unit.getCoalition(unit) == sides[count] then
					clientHeloGroupNames[Group.getName(Unit.getGroup(unit))] = true
				end
			end
		end
		for name,value in pairs(clientHeloGroupNames) do
			if value then
				trigger.action.outTextForGroup(Group.getID(Group.getByName(name)),outString,20)
			end
		end
	end
	timer.scheduleFunction(printScore,nil,timer.getTime() + 60)
end

printScore = function()

	local coa = {'blue','red'}
	local sides = {coalition.side.BLUE,coalition.side.RED}
	trigger.action.outText('Blue score: ' .. score.blue .. ', red score: ' .. score.red,20)
	AAAList = {blue = {}, red = {}}
	local count
	for count =1,2 do
		local outString = coa[count] .. ' airbases: '
		local AirbaseList = coalition.getAirbases(sides[count])
		local i
		for i = 1, #AirbaseList do
			local airbase = AirbaseList[i]
			if Airbase.isExist(airbase) then
				local airbaseName = Airbase.getName(airbase)
				outString = outString .. airbaseName .. ', '
			end
		end
		trigger.action.outText(outString,20)
		local groupList = coalition.getGroups(sides[count],Group.Category.GROUND)
		for i = 1, #groupList do
			local group = groupList[i]
			if Group.isExist(group) then
				local units = Group.getUnits(group)
				local j
				for j = 1,#units do
					local unit = Group.getUnits(group)[j]
					if Unit.isExist(unit) then
						if Unit.getDesc(unit).attributes["Air Defence"] then
							local unitName = Unit.getName(unit)
							-- trigger.action.outText('Found .. ' .. unitName .. Unit.getDesc(unit).typeName,10)
							AAAList[coa[count]][#AAAList[coa[count]]+1] = unitName
						end
					end
				end
			end
		end
	end
	timer.scheduleFunction(printScore2,nil,timer.getTime() + 60)
end

respondEvent = function(event) -- there is a pilot down
local unitType,coa,countryName,position3,position2,unitCategory

	-- if event.id == world.event.S_EVENT_HIT then -- was there a weapons launch by one of the SAM sites?
		-- if event.initiator then
			-- if Unit.isExist(event.initiator) then
				-- if Unit.getCoalition(event.initiator) == coalition.side.RED then
					-- trigger.action.outText('Blue pilot has been shot down, red side gains 10 points.',20)
					-- score.red = score.red + 10
				-- else
					-- trigger.action.outText('Red pilot has been shot down, blue side gains 10 points.',20)
					-- score.blue = score.blue + 10
				-- end
			-- end
		-- end
	-- end
	if event.id == world.event.S_EVENT_PILOT_DEAD then -- was there a weapons launch by one of the SAM sites?
		if event.initiator then
			if Unit.isExist(event.initiator) then
				if Unit.getCoalition(event.initiator) == coalition.side.BLUE then
					trigger.action.outText('Blue pilot has been shot down, red side gains 10 points.',20)
					score.red = score.red + 10
				else
					trigger.action.outText('Red pilot has been shot down, blue side gains 10 points.',20)
					score.blue = score.blue + 10
				end
			end
		end
	end
	if event.id == world.event.S_EVENT_DEAD then -- was there a weapons launch by one of the SAM sites?
		if event.initiator then
			if Unit.isExist(event.initiator) then
				trigger.action.outTextForCoalition(Unit.getCoalition(event.initiator),'This is ' .. Unit.getName(event.initiator) .. '. We are under attack and have casualties. Requesting immediate support!',60)
			end
		end
	end
	if event.id == world.event.S_EVENT_LAND then -- was there a weapons launch by one of the SAM sites?
		airbase = nil
		if event.initiator then
			if Unit.isExist(event.initiator) then
				local pilotName = Unit.getName(event.initiator)
				if onGround[pilotName] then
					if event.place then
						if Object.isExist(event.place) then
							if Object.getCategory(event.place) == Object.Category.BASE then
								if Airbase.getCoalition(event.place) == Unit.getCoalition(event.initiator) then
									airbase = event.place
								end
							end
						end
					end
					SpringfieldHasLanded(pilotName,airbase)
				end
			end
		end
	end
	if event.id == world.event.S_EVENT_SHOT then -- was there a weapons launch by one of the SAM sites?
		if event.initiator then
			if Unit.isExist(event.initiator) then
				if Unit.getCoalition(event.initiator) == coalition.side.BLUE then
					timer.scheduleFunction(HS_incoming,{'red',event},timer.getTime() + 1) -- warning will be given after reactionTime seconds
				else
					timer.scheduleFunction(HS_incoming,{'blue',event},timer.getTime() + 1) -- warning will be given after reactionTime seconds
				end
			end
		end
	end
	if event.id == world.event.S_EVENT_BASE_CAPTURED then
		if event.initiator then
			if Unit.isExist(event.initiator) then
				local initiatorCoalition = Unit.getCoalition(event.initiator)
				if initiatorCoalition == coalition.side.BLUE then
					outText = 'Blue has captured an airbase for 25 points.'
					score.blue = score.blue + 25
				else
					outText = 'Red has captured an airbase for 25 points.'
					score.red = score.red + 25
				end
				trigger.action.outText(outText,20)
			end
		end
	end
	if event.id == world.event.S_EVENT_EJECTION then
		local pilotUnit = event.initiator
		if pilotUnit then
			local side = Unit.getCoalition(pilotUnit)
			position3 = Unit.getPosition(pilotUnit).p
			position2 = {x = position3.x+100, y = position3.z+100}
			if land.getSurfaceType(position2) == land.SurfaceType.SHALLOW_WATER or land.getSurfaceType(position2) == land.SurfaceType.WATER then
			else
			end
			if side == coalition.side.BLUE then
				coa = 'blue'
				countryName = 'USA'
				unitType = 'Soldier M4'
			elseif side == coalition.side.RED then
				coa = 'red'
				countryName = 'RUSSIA'
				unitType = 'Infantry AK'
			else
				return
			end
			if side == coalition.side.BLUE then
				trigger.action.outText('A blue pilot ejected, red side gains 10 points.',20)
				score.red = score.red + 10
			else
				trigger.action.outText('A red pilot ejected, blue side gains 10 points.',20)
				score.blue = score.blue + 10
			end
			pilotDownCounter[coa] = pilotDownCounter[coa]+1
			groupCounter = groupCounter+1
			unitCounter = unitCounter+1
			coalition.addGroup(country.id[countryName], Unit.Category["GROUND_UNIT"], {
				["visible"] = false,
				["route"] = 
				{
					["spans"] = 
					{
					}, -- end of ["spans"]
					["points"] = 
					{
						[1] = 
						{
							["alt"] = 0,
							["type"] = "Turning Point",
							["ETA"] = 0,
							["alt_type"] = "RADAR",
							["formation_template"] = "",
							["y"] = position2.y,
							["x"] = position2.x,
							["name"] = "",
							["ETA_locked"] = true,
							["speed"] = 0,
							["action"] = "Off Road",
							["task"] = 
							{
								["id"] = "ComboTask",
								["params"] = 
								{
									["tasks"] = 
									{
										-- [1] = 
										-- {
											-- ["enabled"] = true,
											-- ["auto"] = false,
											-- ["id"] = "WrappedAction",
											-- ["number"] = 1,
											-- ["params"] = 
											-- {
												-- ["action"] = 
												-- {
													-- ["id"] = "SetFrequency",
													-- ["params"] = 
													-- {
														-- ["modulation"] = modulation,
														-- ["frequency"] = frequency,
													-- }, -- end of ["params"]
												-- }, -- end of ["action"]
											-- }, -- end of ["params"]
										-- }, -- end of [1]
										-- [2] = 
										-- {
											-- ["enabled"] = true,
											-- ["auto"] = false,
											-- ["id"] = "WrappedAction",
											-- ["number"] = 2,
											-- ["params"] = 
											-- {
												-- ["action"] = 
												-- {
													-- ["id"] = "TransmitMessage",
													-- ["params"] = 
													-- {
														-- ["loop"] = true,
														-- ["duration"] = 5,
														-- ["subtitle"] = "",
														-- ["file"] = "ResKey_Action_18",
													-- }, -- end of ["params"]
												-- }, -- end of ["action"]
											-- }, -- end of ["params"]
										-- }, -- end of [2]
									}, -- end of ["tasks"]
								}, -- end of ["params"]
							}, -- end of ["task"]
							["speed_locked"] = true,
						}, -- end of [1]
					}, -- end of ["points"]
				}, -- end of ["route"]
				["groupId"] = groupCounter,
				["tasks"] = 
				{
				}, -- end of ["tasks"]
				["hidden"] = false,
				["units"] = 
				{
					[1] = 
					{
						["type"] = unitType,
						["transportable"] = 
						{
							["randomTransportable"] = false,
						}, -- end of ["transportable"]
						["unitId"] = unitCounter,
						["skill"] = "Average",
						["y"] = position2.y,
						["x"] = position2.x,
						["name"] = coa .. ' Pilot Down Unit #' .. pilotDownCounter[coa],
						["playerCanDrive"] = true,
						["heading"] = 0,
					}, -- end of [1]
				}, -- end of ["units"]
				["y"] = position2.y,
				["x"] = position2.x,
				["name"] = coa .. ' Pilot Down Group #' .. pilotDownCounter[coa],
				["start_time"] = 0,
				["task"] = "Ground Nothing",
			})
			radio[coa .. ' Pilot Down Unit #' .. pilotDownCounter[coa]] = {frequency = frequency, modulation = modulation}
			local index = assignADF(coa,coa .. ' Pilot Down Group #' .. pilotDownCounter[coa])
			local lat, lon = coord.LOtoLL(position3)
			trigger.action.outSoundForCoalition(side,'RadioClickAfter.ogg')
			trigger.action.outTextForCoalition(side,'To all units. We have a pilot down at ' .. printLatLong(position3) .. ', broadcasting on ' .. HS_ADFlist[coa][index].name,20)
			hoverCheck(coa .. ' Pilot Down Group #' .. pilotDownCounter[coa],10)
		end
	end
end

activateTruck = function(convoyName)
	local convoyGroup = Group.getByName(convoyName)
	if convoyGroup then
		trigger.action.activateGroup(convoyGroup)
		local count2
		local units = Group.getUnits(convoyGroup)
		if units then
			for count2 = 1,#units do
				local unit = units[count2]
				if unit then
					timer.scheduleFunction(HS_onBecomesInactiveDo_sub1,{true,Unit.getName(unit)},timer.getTime()+1)
				end
			end
		end
		timer.scheduleFunction(truckSighted,convoyName,timer.getTime()+myRandom(10*60))
	end
end

spawnGrunts = function(coa,position3,size,customName,typeTable)
local groupName
	if coa == 'blue' then
		countryName = 'USA'
		unitType = 'Soldier M4'
	else
		countryName = 'RUSSIA'
		unitType = 'Infantry AK'
	end
	gruntsCounter[coa] = gruntsCounter[coa]+1
	groupCounter = groupCounter+1
	if customName then
		groupName = coa .. ' ' .. customName .. ' Group #' .. gruntsCounter[coa]
	else
		groupName = coa .. ' grunts Group #' .. gruntsCounter[coa]
	end
	local units = {}
	for i = 1,size do
		if typeTable then
			unitType = typeTable[i]
		end
		unitCounter = unitCounter+1
		units[i] = {
				["type"] = unitType,
				["transportable"] = 
				{
					["randomTransportable"] = false,
				}, -- end of ["transportable"]
				["unitId"] = unitCounter,
				["skill"] = "Average",
				["y"] = position3.z+i,
				["x"] = position3.x,
				["name"] = groupName .. ' Unit #' .. i,
				["playerCanDrive"] = true,
				["heading"] = 0,
			}
	end
	coalition.addGroup(country.id[countryName], Unit.Category["GROUND_UNIT"], {
		["visible"] = false,
		["route"] = 
		{
			["spans"] = 
			{
			}, -- end of ["spans"]
			["points"] = 
			{
				[1] = 
				{
					["alt"] = 0,
					["type"] = "Turning Point",
					["ETA"] = 0,
					["alt_type"] = "RADAR",
					["formation_template"] = "",
					["y"] = position3.z+3,
					["x"] = position3.x,
					["name"] = "",
					["ETA_locked"] = true,
					["speed"] = 0,
					["action"] = "Off Road",
					["task"] = 
					{
						["id"] = "ComboTask",
						["params"] = 
						{
							["tasks"] = 
							{
							}, -- end of ["tasks"]
						}, -- end of ["params"]
					}, -- end of ["task"]
					["speed_locked"] = true,
				}, -- end of [1]
			}, -- end of ["points"]
		}, -- end of ["route"]
		["groupId"] = groupCounter,
		["tasks"] = 
		{
		}, -- end of ["tasks"]
		["hidden"] = false,
		["units"] = units,
		["y"] = position3.z+3,
		["x"] = position3.x,
		["name"] = groupName,
		["start_time"] = 0,
		["task"] = "Ground Nothing",
	})
	if not customName then
		hoverCheck(groupName,10)
	elseif customName ~= 'temporary' then
		hoverCheck(groupName,10)
	end
	return groupName
end

countGrunts = function(coa)
local count

	count = 1
	while trigger.misc.getZone(coa .. ' grunts Zone #' .. count) do
		local zone = trigger.misc.getZone(coa .. ' grunts Zone #' .. count)
		local position3 = zone.point
		local groupName,minimumDistance = findClosestGrunts(coa,position3)
		if minimumDistance > 30 then
			local groupName = spawnGrunts(coa,position3,8)
			assignADF(coa,groupName)
		end
		count = count + 1
	end
	timer.scheduleFunction(countGrunts,coa,timer.getTime()+5)
end

countMANPADS = function(coa)
local count,typeTable

	count = 1
	typeTable = {}
	while trigger.misc.getZone(coa .. ' MANPADS Zone #' .. count) do
		local zone = trigger.misc.getZone(coa .. ' MANPADS Zone #' .. count)
		local position3 = zone.point
		local groupName,minimumDistance = findClosestMANPADS(coa,position3)
		if minimumDistance > 30 then
			local groupName
			if coa == 'blue' then
				local i
				for i = 1,8 do
					typeTable[i] = 'Stinger manpad'
				end
				groupName = spawnGrunts(coa,position3,8,nil,typeTable)
			else
				local i
				for i = 1,8 do
					typeTable[i] = 'SA-18 Igla-S manpad'
				end
				groupName = spawnGrunts(coa,position3,8,nil,typeTable)
			end
			assignADF(coa,groupName)
		end
		count = count + 1
	end
	timer.scheduleFunction(countMANPADS,coa,timer.getTime()+5)
end

shipExplosion = function(shipName)
	local shipUnit = Unit.getByName(shipName)
	if shipUnit then
		trigger.action.outSoundForCoalition(Unit.getCoalition(shipUnit),'RadioClickAfter.ogg')
		trigger.action.outTextForCoalition(Unit.getCoalition(shipUnit),'An explosion has rocked the ' .. shipName .. '. Evacuate sailors by landing on the ship\'s deck and fly them back to an active MASH.',20)
		trigger.action.explosion(Unit.getPosition(shipUnit).p, 100)
		timer.scheduleFunction(shipExplosion,shipName,timer.getTime() + myRandom(20*60))
		shipInDistress[shipName] = true
	else
		trigger.action.outText(shipName .. ' has sunk!',20)
	end
end

for count = 1,#clientHeloNames do
	onGround[clientHeloNames[count]] = true
end

airbaseList = world.getAirbases()

local handler = {}
handler.id = 1000
handler.f = respondEvent
function handler:onEvent(event)
	self.f(event)
end
world.addEventHandler(handler)

generateAAA('blue')
generateAAA('red')
-- generateSpeedBoats('blue')
-- generateSpeedBoats('red')
timer.scheduleFunction(activateTruck,'blue truck convoy #1',timer.getTime()+myRandom(10*60))
timer.scheduleFunction(activateTruck,'blue truck convoy #2',timer.getTime()+myRandom(10*60))
timer.scheduleFunction(activateTruck,'blue truck convoy #3',timer.getTime()+myRandom(10*60))
timer.scheduleFunction(activateTruck,'red truck convoy #1',timer.getTime()+myRandom(10*60))
timer.scheduleFunction(activateTruck,'red truck convoy #2',timer.getTime()+myRandom(10*60))
timer.scheduleFunction(activateTruck,'red truck convoy #3',timer.getTime()+myRandom(10*60))
timer.scheduleFunction(activateFighter,nil,timer.getTime()+factor*myRandom(10*60))
timer.scheduleFunction(activateCAS,nil,timer.getTime()+factor*myRandom(10*60))
timer.scheduleFunction(countGrunts,'blue',timer.getTime()+5)
timer.scheduleFunction(countGrunts,'red',timer.getTime()+7.5)
timer.scheduleFunction(countMANPADS,'blue',timer.getTime()+5)
timer.scheduleFunction(countMANPADS,'red',timer.getTime()+7.5)
timer.scheduleFunction(printScore,nil,timer.getTime() + 60)
-- timer.scheduleFunction(shipExplosion,'Oliver Hazzard Perry',timer.getTime() + myRandom(20*60))
-- timer.scheduleFunction(shipExplosion,'Neustrashimy',timer.getTime() + myRandom(20*60))

for count = 1,15 do
	local count2
	local group = Group.getByName('blue Armor Group #' .. count)
	if group then
		local units = Group.getUnits(group)
		if units then
			for count2 = 1,#units do
				local unit = units[count2]
				if unit then
					timer.scheduleFunction(HS_onBecomesInactiveDo_sub1,{true,Unit.getName(unit)},timer.getTime()+1)
				end
			end
		end
	end
	group = Group.getByName('red Armor Group #' .. count)
	if group then
		local units = Group.getUnits(group)
		if units then
			for count2 = 1,#units do
				local unit = units[count2]
				if unit then
					timer.scheduleFunction(HS_onBecomesInactiveDo_sub1,{true,Unit.getName(unit)},timer.getTime()+1)
				end
			end
		end
	end
end

