HS_AIOffWhenNotInSight = false
HS_restartWarningFlag = false
HS_restartFlag = false
HS_timeCounter = 0
HS_score = {blue = 0,red = 0}
HS_convoyCounter = {blue = 0,red = 0}
HS_numberOfBattles = 1
HS_infantryCounter = 0
HS_tankCounter = 0
HS_HumGroupCount = 0
HS_AAAcounter = {blue = 0, red = 0}
HS_menuItems = {blue = {}, red = {}}
HS_groupsInNeed = {blue = {}, red = {}}
HS_humanCargo = {["UH-1H"] = 8, ["Mi-8MT"] = 16}
HS_checkForSmokeList = {blue = {}, red = {}}
HS_checkForFlareList = {blue = {}, red = {}}
HS_checkForIncomingList = {blue = {}, red = {}}
HS_numberOfTroopsInCabin = {blue = {}, red = {}}
HS_typeOfTroopsInCabin = {blue = {}, red = {}}
HS_rescuedPilotsInCabin = {blue = {}, red = {}}
HS_opponent = {blue = 'red',red = 'blue'}
HS_wingmen = {blue = {},red ={}}
HS_pilotCounter = {blue = 0,red = 0}
HS_pilotDownCounter = {blue = 0,red = 0}
HS_temporaryGroupCounter = 0
HS_casualtyReport = false
HS_detectionRange = 10000 -- distance in meters, only helicopters within that distance from the missile launch site will detect the missile
HS_reactionTime = 0.5 -- time in seconds between launch of the missile and detection by the copilot
HS_country = {blue = 'USA', red = 'RUSSIA'}
HS_slingLoads = {}
HS_heightGuidanceOff = {}
HS_shipsToLandOn = {}

HS_hoverStop = {}
HS_hoverActive = {}
HS_IASstop = {}

HS_infantryTypes = {'Stinger manpad','Stinger comm','Soldier M249','Soldier M4','2B11 mortar','SA-18 Igla-S manpad','SA-18 Igla-S comm','Infantry AK','Paratrooper AKS-74','Paratrooper RPG-16'}

HS_callsigns = {
	'Enfield','Springfield','Uzi','Colt','Dodge','Ford','Chevy','Pontiac'
}
HS_ADFlist = {
	blue = {},
	red = {		
		{name = 'ARK-UD channel 1', frequency = 114166000, modulation = 0, group = nil},
		{name = 'ARK-UD channel 2', frequency = 114333000, modulation = 0, group = nil},
		{name = 'ARK-UD channel 3', frequency = 114583000, modulation = 0, group = nil},
		{name = 'ARK-UD channel 4', frequency = 121500000, modulation = 0, group = nil},
		{name = 'ARK-UD channel 5', frequency = 123100000, modulation = 0, group = nil},
		{name = 'ARK-UD channel 6', frequency = 124100000, modulation = 0, group = nil},
		{name = 'R-828 channel 1', frequency = 35654000, modulation = 0, group = nil},
		{name = 'R-828 channel 2', frequency = 25675000, modulation = 0, group = nil},
		{name = 'R-828 channel 3', frequency = 48543500, modulation = 0, group = nil},
		{name = 'R-828 channel 4', frequency = 35657500, modulation = 0, group = nil},
	}
}

HS_airfields = {
-- {name = 'Creech AFB', id = 1},
{name = 'Groom Lake AFB', id = 2},
{name = 'McCarran International Airport', id = 3},
{name = 'Nellis AFB', id = 4}
}

HS_setIncomingAudio = function(audio)
	HS_incomingAudio = audio
end

HS_setRadioStaticAudio = function(audio)
	HS_radioStaticAudio = audio
end

HS_setHoverDirectionsAudio = function(upAudio,downAudio,leftAudio,rightAudio,forwardAudio,backAudio)
	HS_upAudio = upAudio
	HS_downAudio = downAudio
	HS_leftAudio = leftAudio
	HS_rightAudio = rightAudio
	HS_forwardAudio = forwardAudio
	HS_backAudio = backAudio
end

HS_setBeaconAudio = function(audio)
	HS_beaconAudio = audio
end

HS_setSinkRateAudio = function(audio)
	HS_sinkRateAudio = audio
end

HS_setCargoHookedAudio = function(audio)
	HS_cargoHookedAudio = audio
end

HS_INCOM_outUnit = function(forUnit,outText,outTime) -- function outputs text to a specific unit using the mist message system

	if outText and outTime then
		local msg = {}
		msg.text = outText
		msg.displayTime = outTime
		msg.msgFor = {units = {forUnit}}
		msg.sound = HS_incomingAudio
		mist.message.add(msg)
	end
end

HS_sinkRate_outUnit = function(forUnit,outText,outTime) -- function outputs text to a specific unit using the mist message system

	if outText and outTime then
		local msg = {}
		msg.text = outText
		msg.displayTime = outTime
		msg.msgFor = {units = {forUnit}}
		msg.sound = HS_sinkRateAudio
		mist.message.add(msg)
	end
end

HS_outUnit = function(forUnit,outText,outTime) -- function outputs text to a specific unit using the mist message system

	if outText and outTime then
		local msg = {}
		msg.text = outText
		msg.displayTime = outTime
		msg.msgFor = {units = {forUnit}}
		msg.sound = HS_radioStaticAudio
		mist.message.add(msg)
	end
end

HS_out = function(coa,outText,outTime) -- function outputs text using the mist message system

	if outText and outTime then
		local msg = {}
		msg.text = outText
		msg.displayTime = outTime
		msg.msgFor = {coa = {coa}}
		msg.sound = HS_radioStaticAudio
		mist.message.add(msg)
	end
end

HS_initializeAirfieldList = function()
	HS_airfieldList = {blue = {}, red = {}}
	local count

	for count = 1,#HS_airfields do
		local airbase = Airbase.getByName(HS_airfields[count].name)
		if airbase then
			local coa = Airbase.getCoalition(airbase)
			if coa == coalition.side.RED then
				coa = 'red'
				table.insert(HS_airfieldList[coa],HS_airfields[count].name)
			elseif coa == coalition.side.BLUE then
				coa = 'blue'
				table.insert(HS_airfieldList[coa],HS_airfields[count].name)
			end
		end
	end
end

HS_getUnit = function(unitName)
local unit

	if type(unitName) == 'string' then
		if StaticObject.getByName(unitName) then
			unit = StaticObject.getByName(unitName)
		else
			unit = Unit.getByName(unitName)
		end
	else
		unit = unitName
	end
	return unit
end

HS_getGroup = function(groupName)
local group

	if type(groupName) == 'string' then
		group = Group.getByName(groupName)
	else
		group = groupName
	end
	return group
end

HS_isGroupDead = function(coa,groupName)

	local group = HS_getGroup(groupName)
	if group and Group.getSize(group) > 0 then
		mist.scheduleFunction(HS_isGroupDead,{coa,groupName},timer.getTime()+10)
	else
		-- HS_out(coa,'This is ' .. groupName .. '. I am the last man stand...',10)
		HS_groupsInNeed[coa][groupName] = nil
	end
end

HS_isTankGroupDead = function(coa,groupName,score)
local opponent

	local group = HS_getGroup(groupName)
	if group and Group.getSize(group) > 0 then
		mist.scheduleFunction(HS_isTankGroupDead,{coa,groupName,score},timer.getTime()+10)
	else
		opponent = HS_opponent[coa]
		HS_score[opponent] = HS_score[opponent] + score
		HS_out(opponent,groupName .. ' has been completely destroyed. Good work! ' .. math.floor(HS_score[opponent]) .. ' \% of mission has been completed,',20)
		HS_groupsInNeed[coa][groupName] = nil
	end
end

HS_isInfantryGroupInNeed = function(coa,groupName,alarmSize)

	local group = HS_getGroup(groupName)
	if group then
		if Group.getSize(group) < alarmSize and not HS_groupsInNeed[coa][groupName] then
			HS_out(coa,'This is ' .. groupName .. '. We are taking heavy losses and need immediate reinforcements.',10)
			HS_groupsInNeed[coa][groupName] = true
		end
		if Group.getSize(group) > alarmSize and HS_groupsInNeed[coa][groupName] then
			HS_out(coa,'This is ' .. groupName .. '. Thanks for the reinforcement troops. Knew we can count on you. Out.',10)
			HS_removeADF(coa,groupName)
			HS_groupsInNeed[coa][groupName] = nil
		end
		mist.scheduleFunction(HS_isInfantryGroupInNeed,{coa,groupName,alarmSize},timer.getTime()+10)
	end
end

HS_isTankGroupInNeed = function(coa,groupName,alarmSize)

	local group = HS_getGroup(groupName)
	if group then
		if Group.getSize(group) < alarmSize and not HS_groupsInNeed[coa][groupName] then
			HS_out(coa,'This is ' .. groupName .. ' located at ' .. HS_estimatePresentPosition(groupName) .. '. We are taking heavy losses and need immediate support.',30)
			HS_groupsInNeed[coa][groupName] = true
		else
			mist.scheduleFunction(HS_isTankGroupInNeed,{coa,groupName,alarmSize},timer.getTime()+10)
		end
	end
end

HS_getLeadPos = function(groupName)
local count

	local group = HS_getGroup(groupName)
	if group then
		local units = Group.getUnits(group)
		for count = 1,#units do
			if units[count] then 
				return(Unit.getPosition(units[count]).p)
			end
		end
	else
		return nil
	end
end

HS_getAvgPos = function(groupName)
local count

	local totalPosition = {x = 0,y = 0,z = 0}
	local group = HS_getGroup(groupName)
	if group then
		local units = Group.getUnits(group)
		for count = 1,#units do
			if units[count] then 
				totalPosition = mist.vec.add(totalPosition,Unit.getPosition(units[count]).p)
			end
		end
		if #units > 0 then
			return mist.vec.scalar_mult(totalPosition,1/#units)
		else
			return nil
		end
	else
		return nil
	end
end

HS_getHeading = function (position1,position2) -- determine heading from point 1 to point 2
local heading

	if position1 and position2 then
		local heading = math.floor(math.atan2(position1.z-position2.z,position1.x-position2.x)*57.3)
		if heading<0 then
			heading=heading+360
		end
		return heading
	else
		return 0
	end
end

HS_getUnitCoalition = function(playerName)
	local unit = HS_getUnit(playerName)
	if unit then
		if Unit.getCoalition(unit) == coalition.side.BLUE then
			return 'blue'
		else
			return 'red'
		end
	else
		return nil
	end
end

HS_getGroupCoalition = function(playerGroupName)
	local group = HS_getGroup(playerGroupName)
	if group then
		if Group.getCoalition(group) == coalition.side.BLUE then
			return 'blue'
		else
			return 'red'
		end
	else
		return nil
	end
end

HS_groupSetCommand = function(groupName,action)
local group
local groupController

	if groupName then
		group = HS_getGroup(groupName)
		if group then
			groupController = Group.getController(group)
			Controller.setCommand(groupController,action)
		end
	end
end

HS_groupDoNotDisperse = function(groupName)
local action = 	{
					["id"] = "Option",
					["params"] = 
					{
						["name"] = 8,
					}, -- end of ["params"]
				} -- end of ["action"]
	HS_groupSetCommand(groupName,action)
end

HS_stopTransmission = function(groupName)
local action = 	{
					["id"] = "StopTransmission",
					["params"] = 
					{
					}, -- end of ["params"]
				} -- end of ["action"]
	HS_groupSetCommand(groupName,action)
end

HS_startTransmission = function(groupName)
local action =	{
				["id"] = "TransmitMessage",
				["params"] = 
				{
					["file"] = HS_beaconAudio,
					["subtitle"] = "",
					["loop"] = true,
					["duration"] = 5,
				}, -- end of ["params"]
			} -- end of ["action"]
	HS_groupSetCommand(groupName,action)
end

HS_groupSetADF = function(groupName,ADF,modulation)
local action =	{
				["id"] = "SetFrequency",
				["params"] = 
				{
					["modulation"] = modulation,
					["frequency"] = ADF,
				}, -- end of ["params"]
			} -- end of ["action"]
	HS_groupSetCommand(groupName,action)
end

HS_groupStart = function(groupName)
local action = 	{
					["id"] = "Start",
					["params"] =
					{
					}, -- end of ["params"]
				} -- end of ["action"]
	HS_groupSetCommand(groupName,action)
end

HS_onTouchDownDo_sub1 = function(unitInAir,unitName,code,arguments)
	local unit = HS_getUnit(unitName)
	if unit and Unit.isActive(unit) then
		if unitInAir and not Unit.inAir(unit) then
			mist.scheduleFunction(code,arguments,timer.getTime()+0.1)
		end
		mist.scheduleFunction(HS_onTouchDownDo_sub1,{Unit.inAir(unit),unitName,code,arguments},timer.getTime()+1)
	end
end

HS_onTouchDownDo = function(unitName,code,arguments)
	local unit = HS_getUnit(unitName)
	if unit and Unit.isActive(unit) then
		mist.scheduleFunction(HS_onTouchDownDo_sub1,{Unit.inAir(unit),unitName,code,arguments},timer.getTime()+1)
	end
end

HS_onTakeOffDo_sub1 = function(unitInAir,unitName,code,arguments)
	local unit = HS_getUnit(unitName)
	if unit and Unit.isActive(unit) then
		if not unitInAir and Unit.inAir(unit) then
			mist.scheduleFunction(code,arguments,timer.getTime()+0.1)
		end
		mist.scheduleFunction(HS_onTakeOffDo_sub1,{Unit.inAir(unit),unitName,code,arguments},timer.getTime()+1)
	end
end

HS_onTakeOffDo = function(unitName,code,arguments)
	local unit = HS_getUnit(unitName)
	if unit and Unit.isActive(unit) then
		mist.scheduleFunction(HS_onTakeOffDo_sub1,{Unit.inAir(unit),unitName,code,arguments},timer.getTime()+1)
	end
end

HS_onStaticTakeOffDo_sub1 = function(previousPosition,moved,unitName,code,arguments)
	local staticPosition = StaticObject.getPosition(StaticObject.getByName(unitName)).p
	if staticPosition then
		if not moved and mist.utils.get3DDist(previousPosition,staticPosition) >0.1 then
			mist.scheduleFunction(code,arguments,timer.getTime()+1)
		else
			mist.scheduleFunction(HS_onStaticTakeOffDo_sub1,{staticPosition,mist.utils.get3DDist(previousPosition,staticPosition)>0.1,unitName,code,arguments},timer.getTime()+0.1)
		end
	end
end

HS_onStaticTakeOffDo = function(unitName,code,arguments)
	mist.scheduleFunction(HS_onStaticTakeOffDo_sub1,{StaticObject.getPosition(StaticObject.getByName(unitName)).p,false,unitName,code,arguments},timer.getTime()+1)
end

HS_onStaticTouchDownDo_sub1 = function(previousPosition,moved,unitName,code,arguments)
	local staticPosition = StaticObject.getPosition(StaticObject.getByName(unitName)).p
	if staticPosition then
		if moved and mist.utils.get3DDist(previousPosition,staticPosition)<0.1 then
			mist.scheduleFunction(code,arguments,timer.getTime()+1)
		else
			mist.scheduleFunction(HS_onStaticTouchDownDo_sub1,{staticPosition,mist.utils.get3DDist(previousPosition,staticPosition)>0.1,unitName,code,arguments},timer.getTime()+0.1)
		end
	end
end

HS_onStaticTouchDownDo = function(unitName,code,arguments)
	mist.scheduleFunction(HS_onStaticTouchDownDo_sub1,{StaticObject.getPosition(StaticObject.getByName(unitName)).p,false,unitName,code,arguments},timer.getTime()+1)
end

HS_onBecomesActiveDo_sub1 = function(unitIsActive,unitName,code,arguments)
	if mist.DBs.unitsByName[unitName] and not unitIsActive then
		mist.scheduleFunction(code,arguments,timer.getTime()+0.1)
		mist.scheduleFunction(HS_onBecomesActiveDo_sub1,{true,unitName,code,arguments},timer.getTime()+1)
	elseif unitIsActive then
		mist.scheduleFunction(HS_onBecomesActiveDo_sub1,{true,unitName,code,arguments},timer.getTime()+1)
	else
		mist.scheduleFunction(HS_onBecomesActiveDo_sub1,{false,unitName,code,arguments},timer.getTime()+1)
	end
end

HS_onBecomesActiveDo = function(unitName,code,arguments)
	mist.scheduleFunction(HS_onBecomesActiveDo_sub1,{false,unitName,code,arguments},timer.getTime()+1)
end

HS_onBecomesInactiveDo_sub1 = function(unitIsActive,unitName,code,arguments)
	if mist.DBs.unitsByName[unitName] then
		mist.scheduleFunction(HS_onBecomesInactiveDo_sub1,{true,unitName,code,arguments},timer.getTime()+1)
	else
		if unitIsActive then
			mist.scheduleFunction(code,arguments,timer.getTime()+0.1)
		end
		mist.scheduleFunction(HS_onBecomesInactiveDo_sub1,{false,unitName,code,arguments},timer.getTime()+1)
	end
end

HS_onBecomesInactiveDo = function(unitName,code,arguments)
	mist.scheduleFunction(HS_onBecomesInactiveDo_sub1,{false,unitName,code,arguments},timer.getTime()+1)
end

HS_setBlueCountry = function(country)
	HS_country.blue = country
end

HS_setRedCountry = function(country)
	HS_country.red = country
end

HS_addGroundGroup = function(country,groupName,numberOfTroops,position,typeNameTable)
local i
local units = {}
local unitPosition
local country2

	if country == 'blue' or country == 'red' then
		country2 = HS_country[country]
	else
		country2 = country
	end

	for i =1,numberOfTroops do
		unitPosition = mist.getRandPointInCircle(mist.utils.makeVec3(position), 3.5*math.sqrt(numberOfTroops)) -- get random position for individual unit
		table.insert(units,
		{
			["x"] = unitPosition.x,
			["y"] = unitPosition.y,
			["type"] = typeNameTable[i],
			["name"] = groupName .. ' Unit #' .. i,
			["heading"] = 0,
			["skill"] = "Random"
		})
	end
	if #units > 0 then
		mist.dynAdd({country = country2, category = 'GROUND_UNIT', name = groupName, hidden = false, units = units })
		return groupName
	else
		return nil
	end
end

HS_addGroundGroupAtPositions = function(country,groupName,numberOfTroops,position,typeNameTable)
local i
local units = {}
local unitPosition
local country2

	if country == 'blue' or country == 'red' then
		country2 = HS_country[country]
	else
		country2 = country
	end

	for i =1,numberOfTroops do
		table.insert(units,
		{
			["x"] = position[i].x,
			["y"] = position[i].y,
			["type"] = typeNameTable[i],
			["name"] = groupName .. ' Unit #' .. i,
			["heading"] = 0,
			["skill"] = "Random"
		})
	end
	if #units > 0 then
		mist.dynAdd({country = country2, category = 'GROUND_UNIT', name = groupName, hidden = false, units = units })
		return groupName
	else
		return nil
	end
end

HS_addInfantryGroup = function(country,groupName,numberOfTroops,position,typeNameTable)
local count,unitType

	local typeNameTable2 = {}
	if not typeNameTable then
		if string.lower(country) == 'blue' or string.lower(country) == string.lower(HS_country.blue) then
			unitType = 'Soldier M4'
		else
			unitType = 'Infantry AK'
		end
		for count = 1,numberOfTroops do
			typeNameTable2[count] = unitType
		end
	else
		typeNameTable2 = typeNameTable
	end
	local groupName = HS_addGroundGroup(country,groupName,numberOfTroops,position,typeNameTable2)
	local group = HS_getGroup(groupName)
	if HS_AIOffWhenNotInSight and string.sub(groupName,1,string.len('Temporary')) ~= 'Temporary' then
		mist.scheduleFunction(trigger.action.setGroupAIOff,{group},timer.getTime()+1)
	end
	return groupName
end

HS_addTankGroup = function(country,groupName,numberOfTanks,position,typeNameTable)
local count,unitType

	local typeNameTable2 = {}
	if not typeNameTable then
		if string.lower(country) == 'blue' or string.lower(country) == string.lower(HS_country.blue) then
			unitType = 'M-1 Abrams'
		else
			unitType = 'T-90'
		end
		for count = 1,numberOfTanks do
			typeNameTable2[count] = unitType
		end
	else
		typeNameTable2 = typeNameTable
	end
	local groupName = HS_addGroundGroupAtPositions(country,groupName,numberOfTanks,position,typeNameTable2)
	local group = HS_getGroup(groupName)
	if HS_AIOffWhenNotInSight and string.sub(groupName,1,string.len('Temporary')) ~= 'Temporary' then
		mist.scheduleFunction(trigger.action.setGroupAIOff,{group},timer.getTime()+1)
	end
	return groupName
end

HS_isGroupInfantry = function(groupName)
local count,count2

	local group = HS_getGroup(groupName)
	if group then
		local units = Group.getUnits(group)
		for count =1,#units do
			if units[count] then
				local unitType = units[count]:getTypeName()
				for count2 = 1,#HS_infantryTypes do
					if unitType == HS_infantryTypes[count2] then
						return Unit.getName(units[count])
					end
				end
			end
		end
	end
	return nil
end

HS_moveGroup = function(groupName,B,pathType,speed)

	local group = HS_getGroup(groupName)
	if group then
		local endPoint = mist.utils.makeVec2(B)
		path = {}
		path[#path + 1] = mist.ground.buildWP(HS_getAvgPos(groupName),pathType,speed) -- first point on path is present position
		path[#path + 1] = mist.ground.buildWP(endPoint,pathType,speed) -- second point on path is target position
		mist.goRoute(groupName, path) -- schedule ground unit move
	end
end

HS_moveGroupToGroup = function(groupName,targetGroupName,pathType,speed,noUpdate)

	-- HS_out('blue','[Moving Group]',10)
	local startPoint = HS_getAvgPos(groupName)
	local endPoint = HS_getAvgPos(targetGroupName)
	if startPoint and endPoint then
		local relativeVector = mist.vec.sub(startPoint,endPoint)
		relativeVector = mist.vec.scalar_mult(relativeVector,20/(mist.vec.mag(relativeVector)+1))
		endPoint = mist.vec.add(endPoint,relativeVector)
		HS_moveGroup(groupName,endPoint,pathType,speed)
		if not noUpdate then
			mist.scheduleFunction(HS_moveGroupToGroup,{groupName,targetGroupName,pathType,speed},timer.getTime()+20)
		end
	end
end

HS_moveGroupToUnit = function(groupName,targetUnitName,pathType,speed)

	local startPoint = HS_getAvgPos(groupName)
	local endPoint = HS_getUnitPosition(targetUnitName)
	if startPoint and endPoint then
		local relativeVector = mist.vec.sub(startPoint,endPoint)
		relativeVector = mist.vec.scalar_mult(relativeVector,20/(mist.vec.mag(relativeVector)+1))
		endPoint = mist.vec.add(endPoint,relativeVector)
		HS_moveGroup(groupName,endPoint,pathType,speed)
		mist.scheduleFunction(HS_moveGroupToUnit,{groupName,targetUnitName,pathType,speed},timer.getTime()+20)
	end
end

HS_isVec = function(vector)
	if vector then
		if vector.x and vector.y then
			return true
		else
			return false
		end
	else
		return false
	end
end

HS_getUnitPosition = function(playerName)
	if HS_isVec(playerName) then
		return playerName
	else
		local playerUnit = HS_getUnit(playerName)
		if not playerUnit then
			return nil
		end
		return Unit.getPosition(playerUnit).p
	end
end

HS_closestInfantryGroup = function(coa,playerName,excludeList)
local groupName,value

	local closestOne = nil
	local distance = 1E6
	local playerPosition = HS_getUnitPosition(playerName)
	if playerPosition then
		for groupName,value in pairs(mist.DBs.groupsByName) do
			if HS_isGroupInfantry(groupName) then
				local exclude = false
				if excludeList then
					for count = 1,#excludeList do
						if string.sub(groupName,1,string.len(excludeList[count])) == excludeList[count] then
							exclude = true
						end
					end
				end
				if HS_getGroupCoalition(groupName) == coa and not exclude then
					local infantryPosition = HS_getAvgPos(groupName) 
					if mist.utils.get2DDist(playerPosition,infantryPosition) < distance then
						distance = mist.utils.get2DDist(playerPosition,infantryPosition)
						closestOne = groupName
					end
				end
			end
		end
	end
	return closestOne,distance
end

HS_closestInfantryGroupWithPrefix = function(coa,playerName,prefix)
local groupName,value

	local closestOne = nil
	local distance = 1E6
	local playerPosition = HS_getUnitPosition(playerName)
	if playerPosition then
		for groupName,value in pairs(mist.DBs.groupsByName) do
			if HS_isGroupInfantry(groupName) then
				if HS_getGroupCoalition(groupName) == coa and string.sub(groupName,1,string.len(prefix)) == prefix then
					local infantryPosition = HS_getAvgPos(groupName) 
					if mist.utils.get2DDist(playerPosition,infantryPosition) < distance then
						distance = mist.utils.get2DDist(playerPosition,infantryPosition)
						closestOne = groupName
					end
				end
			end
		end
	end
	return closestOne,distance
end

HS_totalInfantrySize = function (coa,excludeList)
local groupName,value,count

	local totalSize = 0
	for groupName,value in pairs(mist.DBs.groupsByName) do
		if HS_isGroupInfantry(groupName) then
			local exclude = false
			if excludeList then
				for count = 1,#excludeList do
					if string.sub(groupName,1,string.len(excludeList[count])) == excludeList[count] then
						exclude = true
					end
				end
			end
			if HS_getGroupCoalition(groupName) == coa and not exclude then
				local group = HS_getGroup(groupName)
				if group then
					totalSize = totalSize + Group.getSize(group)
				end
			end
		end
	end
	return totalSize
end

HS_makeInfantryMove = function(excludeList)
local distance
local closestOne
local groupName,value,count

	local timeCount = 0
	for groupName,value in pairs(mist.DBs.groupsByName) do
		local exclude = false
		if excludeList then
			for count = 1,#excludeList do
				if string.sub(groupName,1,string.len(excludeList[count])) == excludeList[count] then
					exclude = true
				end
			end
		end
		local unitName = HS_isGroupInfantry(groupName)
		if unitName and not exclude then
			local coa = HS_getGroupCoalition(groupName)
			closestOne,distance = HS_closestInfantryGroup(HS_opponent[coa],unitName,excludeList)
			if closestOne then
				timeCount = timeCount + 1
				mist.scheduleFunction(HS_moveGroup,{groupName,HS_getAvgPos(closestOne),'Off Road',10},timer.getTime()+timeCount)
			end
		end
	end
end

HS_makeInfantryGroupAttack = function(groupName,nextTime,excludeList)
local distance
local closestOne

	if HS_getGroup(groupName) then
		local coa = HS_getGroupCoalition(groupName)
		closestOne,distance = HS_closestInfantryGroup(HS_opponent[coa],HS_getAvgPos(groupName),excludeList)
		if closestOne and distance < 5000 then
			HS_moveGroup(groupName,HS_getLeadPos(closestOne),'Off Road',10)
		end
		mist.scheduleFunction(HS_makeInfantryGroupAttack,{groupName,nextTime,excludeList},timer.getTime()+nextTime)
	end
end

HS_infantryBattle = function(numberOfInfantryGroups,groupSize,battleZoneName,coalitionZones,alarmSize)
local count,position,alarmSize2

	if alarmSize then
		alarmSize2 = alarmSize
	else
		alarmSize2 = groupSize-5
	end
	for count = 1,numberOfInfantryGroups do
		repeat
			position = mist.getRandPointInCircle(mist.utils.zoneToVec3(battleZoneName),mist.DBs.zonesByName[battleZoneName].radius)
		until mist.utils.get2DDist(position, mist.utils.zoneToVec3(coalitionZones.blue)) < mist.DBs.zonesByName[coalitionZones.blue].radius
		HS_infantryCounter = HS_infantryCounter + 1
		mist.scheduleFunction(HS_addInfantryGroup,{HS_country.blue,'blue Infantry Group #' .. HS_infantryCounter,mist.random(math.floor(groupSize/2),math.floor(groupSize*1.5)),position},timer.getTime()+count)
		repeat
			position = mist.getRandPointInCircle(mist.utils.zoneToVec3(battleZoneName),mist.DBs.zonesByName[battleZoneName].radius)
		until mist.utils.get2DDist(position, mist.utils.zoneToVec3(coalitionZones.red)) < mist.DBs.zonesByName[coalitionZones.red].radius
		mist.scheduleFunction(HS_addInfantryGroup,{HS_country.red,'red Infantry Group #' .. HS_infantryCounter,mist.random(math.floor(groupSize/2),math.floor(groupSize*1.5)),position},timer.getTime()+count)
		mist.scheduleFunction(HS_isGroupDead,{'blue','blue Infantry Group #' .. HS_infantryCounter},timer.getTime()+count+0.2)
		mist.scheduleFunction(HS_isInfantryGroupInNeed,{'blue','blue Infantry Group #' .. HS_infantryCounter,alarmSize2},timer.getTime()+count+0.4)
		mist.scheduleFunction(HS_makeInfantryGroupAttack,{'blue Infantry Group #' .. HS_infantryCounter,60},timer.getTime()+count+0.6)
		mist.scheduleFunction(HS_isGroupDead,{'red','red Infantry Group #' .. HS_infantryCounter},timer.getTime()+count+0.3)
		mist.scheduleFunction(HS_isInfantryGroupInNeed,{'red','red Infantry Group #' .. HS_infantryCounter,alarmSize2},timer.getTime()+count+0.5)
		mist.scheduleFunction(HS_makeInfantryGroupAttack,{'red Infantry Group #' .. HS_infantryCounter,60},timer.getTime()+count+0.7)
	end
end

HS_tankBattle = function(numberOfTankGroups,groupSize,battleZoneName,coalitionZones,alarmSize)
local count,count2,position,alarmSize2
local position

	if alarmSize then
		alarmSize2 = alarmSize
	else
		alarmSize2 = groupSize/2
	end
	for count = 1,numberOfTankGroups do
		position = {}
		for count2 = 1,math.floor(groupSize*1.5) do
			repeat
				position[count2] = mist.getRandPointInCircle(mist.utils.zoneToVec3(battleZoneName),mist.DBs.zonesByName[battleZoneName].radius)
			until mist.utils.get2DDist(position[count2], mist.utils.zoneToVec3(coalitionZones.blue)) < mist.DBs.zonesByName[coalitionZones.blue].radius
		end
		HS_tankCounter = HS_tankCounter + 1
		mist.scheduleFunction(HS_addTankGroup,{HS_country.blue,'blue Armor Group #' .. HS_tankCounter,mist.random(math.floor(groupSize/2),math.floor(groupSize*1.5)),position},timer.getTime()+count)
		position = {}
		for count2 = 1,math.floor(groupSize*1.5) do
			repeat
				position[count2] = mist.getRandPointInCircle(mist.utils.zoneToVec3(battleZoneName),mist.DBs.zonesByName[battleZoneName].radius)
			until mist.utils.get2DDist(position[count2], mist.utils.zoneToVec3(coalitionZones.red)) < mist.DBs.zonesByName[coalitionZones.red].radius
		end
		mist.scheduleFunction(HS_addTankGroup,{HS_country.red,'red Armor Group #' .. HS_tankCounter,mist.random(math.floor(groupSize/2),math.floor(groupSize*1.5)),position},timer.getTime()+count)
		mist.scheduleFunction(HS_isTankGroupDead,{'blue','blue Armor Group #' .. HS_tankCounter,100/HS_numberOfBattles/numberOfTankGroups},timer.getTime()+count+0.2)
		mist.scheduleFunction(HS_isTankGroupInNeed,{'blue','blue Armor Group #' .. HS_tankCounter,alarmSize2},timer.getTime()+count+0.4)
		mist.scheduleFunction(HS_moveGroupToGroup,{'blue Armor Group #' .. HS_tankCounter,'red Armor Group #' .. HS_tankCounter,'Off Road',10,true},timer.getTime()+mist.random(60*60))
		mist.scheduleFunction(HS_isTankGroupDead,{'red','red Armor Group #' .. HS_tankCounter,100/HS_numberOfBattles/numberOfTankGroups},timer.getTime()+count+0.3)
		mist.scheduleFunction(HS_isTankGroupInNeed,{'red','red Armor Group #' .. HS_tankCounter,alarmSize2},timer.getTime()+count+0.5)
		mist.scheduleFunction(HS_moveGroupToGroup,{'red Armor Group #' .. HS_tankCounter,'blue Armor Group #' .. HS_tankCounter,'Off Road',10,true},timer.getTime()+mist.random(60*60))
	end
	HS_generateAirDefence('blue',2,coalitionZones.blue)
	HS_generateAirDefence('red',2,coalitionZones.red)
	HS_generateArty('blue',2,coalitionZones.blue,HS_getHeading(mist.utils.zoneToVec3(coalitionZones.blue),mist.utils.zoneToVec3(coalitionZones.red)))
	HS_generateArty('red',2,coalitionZones.red,HS_getHeading(mist.utils.zoneToVec3(coalitionZones.red),mist.utils.zoneToVec3(coalitionZones.blue)))
	
	-- generate JTAC
	local count1 = math.floor(tonumber(string.match(battleZoneName,"%d+")))
	local JTACstartVEC2 = mist.getRandPointInCircle(mist.utils.zoneToVec3(battleZoneName),mist.DBs.zonesByName[battleZoneName].radius)
	local JTACendVEC2 = mist.getRandPointInCircle(mist.utils.zoneToVec3(battleZoneName),mist.DBs.zonesByName[battleZoneName].radius)
	local HumPos1VEC2 = mist.getRandPointInCircle(mist.utils.zoneToVec3(battleZoneName),mist.DBs.zonesByName[battleZoneName].radius/2)
	local HumPos2VEC2 = mist.getRandPointInCircle(mist.utils.zoneToVec3(battleZoneName),mist.DBs.zonesByName[battleZoneName].radius/2)
	local HumPos3VEC2 = mist.getRandPointInCircle(mist.utils.zoneToVec3(battleZoneName),mist.DBs.zonesByName[battleZoneName].radius/2)
	HS_HumGroupCount = HS_HumGroupCount+1
	mist.dynAdd({country = 'USA', category = 'GROUND_UNIT',
		["visible"] = false,
		["taskSelected"] = true,
		["route"] = 
		{
			["spans"] = 
			{
				[1] = 
				{
					[1] = 
					{
						["y"] = HumPos1VEC2.y,
						["x"] = HumPos1VEC2.x,
					}, -- end of [1]
					[2] = 
					{
						["y"] = HumPos2VEC2.y,
						["x"] = HumPos2VEC2.x,
					}, -- end of [2]
				}, -- end of [1]
				[2] = 
				{
					[1] = 
					{
						["y"] = HumPos2VEC2.y,
						["x"] = HumPos2VEC2.x,
					}, -- end of [1]
					[2] = 
					{
						["y"] = HumPos3VEC2.y,
						["x"] = HumPos3VEC2.x,
					}, -- end of [2]
				}, -- end of [2]
				[3] = 
				{
					[1] = 
					{
						["y"] = HumPos3VEC2.y,
						["x"] = HumPos3VEC2.x,
					}, -- end of [1]
					[2] = 
					{
						["y"] = HumPos3VEC2.y,
						["x"] = HumPos3VEC2.x,
					}, -- end of [2]
				}, -- end of [3]
			}, -- end of ["spans"]
			["points"] = 
			{
				[1] = 
				{
					["alt"] = 0,
					["type"] = "Turning Point",
					["ETA"] = 0,
					["alt_type"] = "RADAR",
					["formation_template"] = "",
					["y"] = HumPos1VEC2.y,
					["x"] = HumPos1VEC2.x,
					["name"] = "WP 1",
					["ETA_locked"] = true,
					["speed"] = 5.5555555555556,
					["action"] = "Off Road",
					["task"] = 
					{
						["id"] = "ComboTask",
						["params"] = 
						{
							["tasks"] = 
							{
								[1] = 
								{
									["enabled"] = true,
									["auto"] = true,
									["id"] = "WrappedAction",
									["number"] = 1,
									["params"] = 
									{
										["action"] = 
										{
											["id"] = "EPLRS",
											["params"] = 
											{
												["value"] = true,
												["groupId"] = 1,
											}, -- end of ["params"]
										}, -- end of ["action"]
									}, -- end of ["params"]
								}, -- end of [1]
								[2] = 
								{
									["enabled"] = true,
									["auto"] = false,
									["id"] = "FAC",
									["number"] = 2,
									["params"] = 
									{
										["number"] = 1,
										["designation"] = "Auto",
										["modulation"] = 1,
										["callname"] = HS_HumGroupCount,
										["datalink"] = true,
										["frequency"] = (30+HS_HumGroupCount)*1000000,
									}, -- end of ["params"]
								}, -- end of [2]
								[3] = 
								{
									["number"] = 3,
									["auto"] = false,
									["id"] = "WrappedAction",
									["enabled"] = true,
									["params"] = 
									{
										["action"] = 
										{
											["id"] = "SetInvisible",
											["params"] = 
											{
												["value"] = true,
											}, -- end of ["params"]
										}, -- end of ["action"]
									}, -- end of ["params"]
								}, -- end of [1]
							}, -- end of ["tasks"]
						}, -- end of ["params"]
					}, -- end of ["task"]
					["speed_locked"] = true,
				}, -- end of [1]
				[2] = 
				{
					["alt"] = 0,
					["type"] = "Turning Point",
					["ETA"] = 541.66274619199,
					["alt_type"] = "RADAR",
					["formation_template"] = "",
					["y"] = HumPos2VEC2.y,
					["x"] = HumPos2VEC2.x,
					["name"] = "WP 2",
					["ETA_locked"] = false,
					["speed"] = 5.5555555555556,
					["action"] = "Off Road",
					["task"] = 
					{
						["id"] = "ComboTask",
						["params"] = 
						{
							["tasks"] = 
							{
							}, -- end of ["tasks"]
						}, -- end of ["params"]
					}, -- end of ["task"]
					["speed_locked"] = true,
				}, -- end of [2]
				[3] = 
				{
					["alt"] = 0,
					["type"] = "Turning Point",
					["ETA"] = 1126.706543611,
					["alt_type"] = "RADAR",
					["formation_template"] = "",
					["y"] = HumPos3VEC2.y,
					["x"] = HumPos3VEC2.x,
					["name"] = "WP 3",
					["ETA_locked"] = false,
					["speed"] = 5.5555555555556,
					["action"] = "Off Road",
					["task"] = 
					{
						["id"] = "ComboTask",
						["params"] = 
						{
							["tasks"] = 
							{
							}, -- end of ["tasks"]
						}, -- end of ["params"]
					}, -- end of ["task"]
					["speed_locked"] = true,
				}, -- end of [3]
			}, -- end of ["points"]
		}, -- end of ["route"]
		["tasks"] = 
		{
		}, -- end of ["tasks"]
		["hidden"] = false,
		["units"] = 
		{
			[1] = 
			{
				["type"] = "M1043 HMMWV Armament",
				["transportable"] = 
				{
					["randomTransportable"] = false,
				}, -- end of ["transportable"]
				["skill"] = "Random",
				["y"] = HumPos1VEC2.y,
				["x"] = HumPos1VEC2.x,
				["name"] = "HUMVEE Group " .. HS_HumGroupCount .. " Unit 1",
				["playerCanDrive"] = true,
				["heading"] = 1.7812265301409,
			}, -- end of [1]
		}, -- end of ["units"]
		["y"] = HumPos1VEC2.y,
		["x"] = HumPos1VEC2.x,
		["name"] = "HUMVEE Group " .. HS_HumGroupCount,
		["start_time"] = 0,
		["task"] = "Ground Nothing",
	})
	mist.dynAdd({country = 'USA', category = 'AIRPLANE', 
									["modulation"] = 0,
									["tasks"] = 
									{
									}, -- end of ["tasks"]
									["radioSet"] = true,
									["task"] = "AFAC",
									["uncontrolled"] = false,
									["taskSelected"] = true,
									["route"] = 
									{
										["points"] = 
										{
											[1] = 
											{
												["alt"] = 3000,
												["type"] = "Turning Point",
												["action"] = "Turning Point",
												["alt_type"] = "BARO",
												["formation_template"] = "",
												["properties"] = 
												{
													["vnav"] = 1,
													["scale"] = 0,
													["angle"] = 0,
													["vangle"] = 0,
													["steer"] = 2,
												}, -- end of ["properties"]
												["ETA"] = 0,
												["y"] = JTACstartVEC2.y,
												["x"] = JTACstartVEC2.x,
												["name"] = "WP 1",
												["speed"] = 69.444444444444,
												["ETA_locked"] = true,
												["task"] = 
												{
													["id"] = "ComboTask",
													["params"] = 
													{
														["tasks"] = 
														{
															[1] = 
															{
																["number"] = 1,
																["auto"] = false,
																["id"] = "WrappedAction",
																["enabled"] = true,
																["params"] = 
																{
																	["action"] = 
																	{
																		["id"] = "SetInvisible",
																		["params"] = 
																		{
																			["value"] = true,
																		}, -- end of ["params"]
																	}, -- end of ["action"]
																}, -- end of ["params"]
															}, -- end of [1]
															[2] = 
															{
																["number"] = 2,
																["auto"] = true,
																["id"] = "FAC",
																["enabled"] = true,
																["params"] = 
																{
																	["number"] = 1,
																	["designation"] = "Auto",
																	["modulation"] = 0,
																	["callname"] = count1,
																	["datalink"] = true,
																	["frequency"] = (125+count1)*1000000,
																}, -- end of ["params"]
															}, -- end of [2]
															[3] = 
															{
																["enabled"] = true,
																["auto"] = false,
																["id"] = "Orbit",
																["number"] = 3,
																["params"] = 
																{
																	["altitude"] = 3000,
																	["pattern"] = "Race-Track",
																	["speed"] = 55.555555555556,
																}, -- end of ["params"]
															}, -- end of [3]
														}, -- end of ["tasks"]
													}, -- end of ["params"]
												}, -- end of ["task"]
												["speed_locked"] = true,
											}, -- end of [1]
											[2] = 
											{
												["alt"] = 3000,
												["type"] = "Turning Point",
												["action"] = "Turning Point",
												["alt_type"] = "BARO",
												["formation_template"] = "",
												["properties"] = 
												{
													["vnav"] = 1,
													["scale"] = 0,
													["angle"] = 0,
													["vangle"] = 0,
													["steer"] = 2,
												}, -- end of ["properties"]
												["ETA"] = 232.28777648005,
												["y"] = JTACendVEC2.y,
												["x"] = JTACendVEC2.x,
												["name"] = "WP2",
												["speed"] = 69.444444444444,
												["ETA_locked"] = false,
												["task"] = 
												{
													["id"] = "ComboTask",
													["params"] = 
													{
														["tasks"] = 
														{
														}, -- end of ["tasks"]
													}, -- end of ["params"]
												}, -- end of ["task"]
												["speed_locked"] = true,
											}, -- end of [2]
										}, -- end of ["points"]
									}, -- end of ["route"]
									["hidden"] = false,
									["units"] = 
									{
										[1] = 
										{
											["alt"] = 3000,
											["alt_type"] = "BARO",
											["livery_id"] = "'camo' scheme",
											["skill"] = "Random",
											["speed"] = 69.444444444444,
											["type"] = "MQ-9 Reaper",
											["psi"] = -1.4750049900867,
											["y"] = JTACstartVEC2.y,
											["x"] = JTACstartVEC2.x,
											["name"] = "JTAC group " .. count1 .. " unit 1",
											["payload"] = 
											{
												["pylons"] = 
												{
												}, -- end of ["pylons"]
												["fuel"] = 1300,
												["flare"] = 0,
												["chaff"] = 0,
												["gun"] = 100,
											}, -- end of ["payload"]
											["heading"] = 1.4750049900867,
											["callsign"] = 
											{
												[1] = count1,
												[2] = 1,
												[3] = 1,
												["name"] = HS_callsigns[count1] .. " 1-1",
											}, -- end of ["callsign"]
											["onboard_num"] = "011",
										}, -- end of [1]
									}, -- end of ["units"]
									["y"] = JTACstartVEC2.y,
									["x"] = JTACstartVEC2.x,
									["name"] = "JTAC group " .. count1,
									["communication"] = true,
									["start_time"] = 0,
									["frequency"] = 125+count1,
				})
end

HS_setNumberOfTroopsInCabin = function(playerName,number)
	local coa = HS_getUnitCoalition(playerName)
	if coa then
		HS_numberOfTroopsInCabin[coa][playerName] = number
	end
end

HS_setTypeOfTroopsInCabin = function(playerName,typeNameTable)
local count

	local coa = HS_getUnitCoalition(playerName)
	HS_getTypeOfTroopsInCabin(playerName)
	for count = 1,#typeNameTable do
		HS_typeOfTroopsInCabin[coa][playerName][#HS_typeOfTroopsInCabin[coa][playerName]+1] = typeNameTable[count]
	end
end

HS_getNumberOfTroopsInCabin = function(playerName)
	local coa = HS_getUnitCoalition(playerName)
	if coa then
		if not HS_numberOfTroopsInCabin[coa][playerName] then
			HS_numberOfTroopsInCabin[coa][playerName]=0
		end
		return HS_numberOfTroopsInCabin[coa][playerName]
	else
		return nil
	end
end

HS_getTypeOfTroopsInCabin = function(playerName)
local count

	local coa = HS_getUnitCoalition(playerName)
	if not HS_typeOfTroopsInCabin[coa][playerName] then
		HS_typeOfTroopsInCabin[coa][playerName]= {}
		for count = 1,HS_getNumberOfTroopsInCabin(playerName) do
			if coa == 'blue' then
				HS_typeOfTroopsInCabin[coa][playerName][#HS_typeOfTroopsInCabin[coa][playerName]+1] = 'Soldier M4'
			else
				HS_typeOfTroopsInCabin[coa][playerName][#HS_typeOfTroopsInCabin[coa][playerName]+1] = 'Infantry AK'
			end
		end
	end
	return HS_typeOfTroopsInCabin[coa][playerName]
end

HS_setNumberOfRescuedPilotsInCabin = function(playerName,number)
	local coa = HS_getUnitCoalition(playerName)
	if coa then
		HS_rescuedPilotsInCabin[coa][playerName] = number
	end
end

HS_getNumberOfRescuedPilotsInCabin = function(playerName)
	local coa = HS_getUnitCoalition(playerName)
	if coa then
		if not HS_rescuedPilotsInCabin[coa][playerName] then
			HS_rescuedPilotsInCabin[coa][playerName]=0
		end
		return HS_rescuedPilotsInCabin[coa][playerName]
	else
		return nil
	end
end

HS_getTypeNameTable = function(groupName)
local count,count2

	local typeNameTable = {}
	local group = HS_getGroup(groupName)
	if group then
		local units = Group.getUnits(group)
		for count =1,#units do
			if units[count] then
				local unitType = units[count]:getTypeName()
				for count2 = 1,#HS_infantryTypes do
					if unitType == HS_infantryTypes[count2] then
						typeNameTable[#typeNameTable+1] = unitType
						break
					end
				end
			end
		end
	end
	return typeNameTable
end

HS_removeFromGroup = function(groupName,number)
local count,count2

	local number2 = number
	local group = HS_getGroup(groupName)
	if group then
		local units = Group.getUnits(group)
		for count =1,#units do
			if units[#units+1-count] then
				local unitType = units[#units+1-count]:getTypeName()
				for count2 = 1,#HS_infantryTypes do
					if unitType == HS_infantryTypes[count2] then
						units[#units+1-count]:destroy()
						number2 = number2-1
						break
					end
				end
				if number2 == 0 then
					break
				end
			end
		end
	end
end

HS_loading = function(coa,playerName,groupName)

	local playerUnit = HS_getUnit(playerName)
	if playerUnit and not Unit.inAir(playerUnit) then
		local group = HS_getGroup(groupName)
		if group then
			local typeNameTable = HS_getTypeNameTable(groupName)
			local groupSize = #typeNameTable
			local position = HS_getAvgPos(groupName)
			if string.sub(groupName,1,string.len('Temporary Pilot Down')) == 'Temporary Pilot Down' then
				group:destroy()
				HS_setNumberOfRescuedPilotsInCabin(playerName,HS_getNumberOfRescuedPilotsInCabin(playerName)+groupSize)
			else
				local numberOfTroopsToBeLoaded = groupSize
				if numberOfTroopsToBeLoaded > HS_humanCargo[HS_getUnit(playerName):getTypeName()]-HS_getNumberOfTroopsInCabin(playerName) then
					numberOfTroopsToBeLoaded = HS_humanCargo[HS_getUnit(playerName):getTypeName()]-HS_getNumberOfTroopsInCabin(playerName)
					HS_removeFromGroup(groupName,numberOfTroopsToBeLoaded)
					local typeNameTable2 = HS_getTypeNameTable(groupName)
					group:destroy()
					HS_addInfantryGroup(coa,'Left over ' .. groupName,#typeNameTable2,position,typeNameTable2)
				else
					group:destroy()
				end
				HS_setTypeOfTroopsInCabin(playerName,typeNameTable)
				HS_setNumberOfTroopsInCabin(playerName,HS_getNumberOfTroopsInCabin(playerName)+numberOfTroopsToBeLoaded)
			end
			HS_out(coa,'This is ' .. playerName .. '. Troops are on board.',10)
		end
	end	
end

HS_extractFromGroup = function(groupName,number)
local count,count2

	local number2 = number
	local typeNameTable = {}
	local group = HS_getGroup(groupName)
	if group then
		local units = Group.getUnits(group)
		for count =1,#units do
			if units[count] then
				local unitType = units[count]:getTypeName()
				for count2 = 1,#HS_infantryTypes do
					if unitType == HS_infantryTypes[count2] then
						typeNameTable[#typeNameTable+1] = unitType
						units[count]:destroy()
						number2 = number2-1
						break
					end
				end
				if number2 == 0 then
					break
				end
			end
		end
	end
	return typeNameTable
end

HS_loadTroops = function(playerName)
local closestOne,distance,numberOfTroopsToBeLoaded
local count

	local playerUnit = HS_getUnit(playerName)
	if playerUnit and not Unit.inAir(playerUnit) then
		local playerPosition = Unit.getPosition(playerUnit).p
		local coa = HS_getUnitCoalition(playerName)
		HS_out(coa,'This is ' .. playerName .. '. Request to load troops.',10)
		closestOne,distance = HS_closestInfantryGroup(coa,playerName,{'Temporary'})
		if distance > 2000 then
			HS_out(coa,'There are no friendly troops in the area',10)
		elseif closestOne then
			local startPosition = HS_getAvgPos(closestOne)
			local closestGroup = HS_getGroup(closestOne)
			local initialSize = Group.getSize(closestGroup)
			if string.sub(closestOne,1,string.len('Pilot Down')) == 'Pilot Down' then
				numberOfTroopsToBeLoaded = initialSize
				HS_removeADF(coa,closestOne)
				HS_groupsInNeed[coa][closestOne] = nil
			else
				numberOfTroopsToBeLoaded = HS_humanCargo[HS_getUnit(playerName):getTypeName()]-HS_getNumberOfTroopsInCabin(playerName)
			end
			if numberOfTroopsToBeLoaded > 0 then
				local typeNameTable = HS_extractFromGroup(closestGroup,numberOfTroopsToBeLoaded)
				numberOfTroopsToBeLoaded = #typeNameTable
				if numberOfTroopsToBeLoaded > initialSize then
					numberOfTroopsToBeLoaded = initialSize
				end
				HS_temporaryGroupCounter = HS_temporaryGroupCounter + 1
				local temporaryName = 'Temporary ' .. closestOne .. ' # ' .. HS_temporaryGroupCounter
				HS_out(coa,'This is ' .. closestOne .. '. ' .. numberOfTroopsToBeLoaded .. ' troops are on their way.',10)
				HS_addInfantryGroup(coa,temporaryName,numberOfTroopsToBeLoaded,startPosition,typeNameTable)
				mist.scheduleFunction(HS_moveGroupToUnit,{temporaryName,playerName,'Off Road',10},timer.getTime()+1)
				mist.scheduleFunction(HS_loading,{coa,playerName,temporaryName},timer.getTime()+mist.utils.get2DDist(startPosition,playerPosition)/3+1)
			end
		end
	end
end

HS_groupLoadTroops = function(playerGroupName)
local count

	local playerGroup = HS_getGroup(playerGroupName)
	if playerGroup then
		local units = Group.getUnits(playerGroup)
		if units then
			for count = 1,#units do
				playerUnit = units[count]
				if playerUnit and not Unit.inAir(playerUnit) then
					local playerName = Unit.getName(playerUnit)
					mist.scheduleFunction(HS_loadTroops,{playerName},timer.getTime()+count)
				end
			end
		end
	end
end

HS_loadTroopsFromGroup = function(playerName,targetGroupName)
local numberOfTroopsToBeLoaded
local count

	local playerUnit = HS_getUnit(playerName)
	if playerUnit and not Unit.inAir(playerUnit) then
		local playerPosition = Unit.getPosition(playerUnit).p
		local coa = HS_getUnitCoalition(playerName)
		HS_out(coa,'This is ' .. playerName .. '. Request to load troops.',10)
		local targetGroup = HS_getGroup(targetGroupName)
		if targetGroup then
			local startPosition = HS_getAvgPos(targetGroupName)
			local initialSize = Group.getSize(targetGroup)
			if string.sub(targetGroupName,1,string.len('Pilot Down')) == 'Pilot Down' then
				numberOfTroopsToBeLoaded = initialSize
			else
				numberOfTroopsToBeLoaded = HS_humanCargo[HS_getUnit(playerName):getTypeName()]-HS_getNumberOfTroopsInCabin(playerName)
			end
			if numberOfTroopsToBeLoaded > 0 then
				local typeNameTable = HS_extractFromGroup(targetGroupName,numberOfTroopsToBeLoaded)
				numberOfTroopsToBeLoaded = #typeNameTable
				if numberOfTroopsToBeLoaded > initialSize then
					numberOfTroopsToBeLoaded = initialSize
				end
				HS_temporaryGroupCounter = HS_temporaryGroupCounter + 1
				local temporaryName = 'Temporary ' .. targetGroupName .. ' # ' .. HS_temporaryGroupCounter
				HS_out(coa,'This is ' .. targetGroupName .. '. ' .. numberOfTroopsToBeLoaded .. ' troops are on their way.',10)
				HS_addInfantryGroup(coa,temporaryName,numberOfTroopsToBeLoaded,startPosition,typeNameTable)
				mist.scheduleFunction(HS_moveGroupToUnit,{temporaryName,playerName,'Off Road',10},timer.getTime()+1)
				mist.scheduleFunction(HS_loading,{coa,playerName,temporaryName},timer.getTime()+mist.utils.get2DDist(startPosition,playerPosition)/3+1)
			end
		end
	end
end

HS_groupLoadTroopsFromGroup = function(playerGroupName,targetGroupName)
local count

	local playerGroup = HS_getGroup(playerGroupName)
	if playerGroup then
		local units = Group.getUnits(playerGroup)
		if units then
			for count = 1,#units do
				playerUnit = units[count]
				if playerUnit and not Unit.inAir(playerUnit) then
					local playerName = Unit.getName(playerUnit)
					mist.scheduleFunction(HS_loadTroopsFromGroup,{playerName,targetGroupName},timer.getTime()+count)
				end
			end
		end
	end
end

HS_combineLists = function(listTable)
local count1,count2

	local list = {}
	for count1 = 1,#listTable do
		for count2 = 1,#listTable[count1] do
			local typeName = listTable[count1][count2]
			if list[typeName] then
				table.insert(list[typeName],typeName)
			else
				list[typeName] = {typeName}
			end
		end
	end
	return list
end

HS_mergeTwoGroups = function(coa,groupName,groupName2)
local count,typeName,typeNameTable1,typeNameTable2,value

	local position = nil
	local name = groupName
	local group = HS_getGroup(groupName)
	if group then
		position = HS_getAvgPos(groupName)
		typeNameTable1 = HS_getTypeNameTable(groupName)
		group:destroy()
	else
		HS_temporaryGroupCounter = HS_temporaryGroupCounter + 1
		name = groupName .. HS_temporaryGroupCounter
		typeNameTable1 = {}
	end
	local group2 = HS_getGroup(groupName2)
	if group2 then
		if not position then
			position = HS_getAvgPos(groupName2)
		end
		typeNameTable2 = HS_getTypeNameTable(groupName2)
		group2:destroy()
	else
		typeNameTable2 = {}
	end
	local typeNameTable = HS_combineLists({typeNameTable1,typeNameTable2})
	for typeName,value in pairs(typeNameTable) do
		if HS_groupsInNeed[coa][groupName] or HS_groupsInNeed[coa][groupName2] then
			HS_groupsInNeed[coa][groupName] = false
			HS_groupsInNeed[coa][groupName2] = false
			HS_groupsInNeed[coa][name .. typeName] = true
		end
		HS_addInfantryGroup(coa,name .. typeName,#value,position,value)
		if string.sub(name,1,string.len('Assault')) == 'Assault' then
			mist.scheduleFunction(HS_makeInfantryGroupAttack,{name .. typeName,60},timer.getTime()+1)
		end
	end
end

HS_offloadTroops = function(playerName)
local airfieldName,closestOne,distance,closestOne1,distance1,closestOne2,distance2
local count

	local playerUnit = HS_getUnit(playerName)
	if playerUnit and not Unit.inAir(playerUnit) then
		local coa = HS_getUnitCoalition(playerName)
		if HS_getNumberOfRescuedPilotsInCabin(playerName) > 0 then
			HS_initializeAirfieldList()
			if #HS_airfieldList[coa] > 0 then
				airfieldName,distance = HS_closestAirfield(coa,Unit.getPosition(playerUnit).p,HS_airfieldList)
				if distance < 5000 then
					for count = 1,HS_getNumberOfRescuedPilotsInCabin(playerName) do
						HS_out(coa,'Rescued pilot offloaded. Plane will respawn in 1 min.',10)
						HS_pilotCounter[coa] = HS_pilotCounter[coa] + 1
						if coa == 'blue' then
							mist.scheduleFunction(HS_flyFighterMission,{coa,'F-16 Group #' .. HS_pilotCounter[coa]},timer.getTime()+60) -- respawn rescued pilot
						else
							mist.scheduleFunction(HS_flyFighterMission,{coa,'Su Group #' .. HS_pilotCounter[coa]},timer.getTime()+60) -- respawn rescued pilot
						end
					end
					HS_setNumberOfRescuedPilotsInCabin(playerName,0)
				else
					HS_out(coa,'Rescued pilots can only be offloadeded at an active airfield. The closest field is ' .. airfieldName .. ', ' .. distance .. ' m away.',10)
				end
			end
		end
		if HS_getNumberOfTroopsInCabin(playerName) > 0 then
			local playerPosition = Unit.getPosition(playerUnit).p
			closestOne1,distance1 = HS_closestInfantryGroup(coa,playerName,{'Temporary','Pilot Down'})
			closestOne2,distance2 = HS_closestInfantryGroup(HS_opponent[coa],playerName,{'Temporary','Pilot Down'})
			if distance1 < distance2 then
				distance = distance1
				closestOne = closestOne1
			else
				distance = distance2
				closestOne = closestOne2
			end
			local heading = mist.getHeading(playerUnit) -- get player heading
			local startPosition = {x=playerPosition.x+20*math.cos(heading+math.pi/4),y=playerPosition.z+20*math.sin(heading+math.pi/4)}
			HS_out(coa,'This is ' .. playerName .. '. Offloading ' .. HS_getNumberOfTroopsInCabin(playerName) .. ' troops.',10)
			HS_temporaryGroupCounter = HS_temporaryGroupCounter + 1
			if closestOne and distance < 2000 then
				local endPosition = HS_getAvgPos(closestOne)
				local temporaryName = 'Temporary Infantry Group #' .. HS_temporaryGroupCounter
				local assaultName = 'Assault Group #' .. HS_temporaryGroupCounter
				if distance == distance1 then
					HS_addInfantryGroup(coa,temporaryName,HS_getNumberOfTroopsInCabin(playerName),startPosition,HS_getTypeOfTroopsInCabin(playerName))
					mist.scheduleFunction(HS_moveGroupToGroup,{temporaryName,closestOne,'Off Road',10},timer.getTime()+1)
					mist.scheduleFunction(HS_mergeTwoGroups,{coa,closestOne,temporaryName},timer.getTime()+mist.utils.get2DDist(endPosition,startPosition)/3+1)
				else
					HS_addInfantryGroup(coa,assaultName,HS_getNumberOfTroopsInCabin(playerName),startPosition,HS_getTypeOfTroopsInCabin(playerName))
					mist.scheduleFunction(HS_makeInfantryGroupAttack,{assaultName,60},timer.getTime()+1)
				end
			else
				HS_addInfantryGroup(coa,coa .. ' offloaded troops #' .. HS_temporaryGroupCounter,HS_getNumberOfTroopsInCabin(playerName),startPosition,HS_getTypeOfTroopsInCabin(playerName))
			end
			HS_setNumberOfTroopsInCabin(playerName,0)
			HS_typeOfTroopsInCabin[coa][playerName] = {}
		end
	end
end

HS_groupOffloadTroops = function(playerGroupName)
local count

	local playerGroup = HS_getGroup(playerGroupName)
	local units = Group.getUnits(playerGroup)
	for count = 1,#units do
		playerUnit = units[count]
		if playerUnit and not Unit.inAir(playerUnit) then
			local playerName = Unit.getName(playerUnit)
			mist.scheduleFunction(HS_offloadTroops,{playerName},timer.getTime()+count)
		end
	end
end

HS_offloadTroopsToGroup = function(playerName,targetGroupName)
local count

	local playerUnit = HS_getUnit(playerName)
	if playerUnit and not Unit.inAir(playerUnit) then
		local coa = HS_getUnitCoalition(playerName)
		if HS_getNumberOfTroopsInCabin(playerName) > 0 then
			local playerPosition = Unit.getPosition(playerUnit).p
			local heading = mist.getHeading(playerUnit) -- get player heading
			local startPosition = {x=playerPosition.x+20*math.cos(heading+math.pi/4),y=playerPosition.z+20*math.sin(heading+math.pi/4)}
			HS_out(coa,'This is ' .. playerName .. '. Offloading ' .. HS_getNumberOfTroopsInCabin(playerName) .. ' troops.',10)
			HS_temporaryGroupCounter = HS_temporaryGroupCounter + 1
			if HS_getGroup(targetGroupName) then
				local endPosition = HS_getAvgPos(targetGroupName)
				local temporaryName = 'Temporary ' .. coa .. ' Infantry Group #' .. HS_temporaryGroupCounter
				if distance == distance1 then
					HS_addInfantryGroup(coa,temporaryName,HS_getNumberOfTroopsInCabin(playerName),startPosition,HS_getTypeOfTroopsInCabin(playerName))
					mist.scheduleFunction(HS_moveGroupToGroup,{temporaryName,targetGroupName,'Off Road',10},timer.getTime()+1)
					mist.scheduleFunction(HS_mergeTwoGroups,{coa,targetGroupName,temporaryName},timer.getTime()+mist.utils.get2DDist(endPosition,startPosition)/3+1)
				end
			else
				HS_addInfantryGroup(coa,targetGroupName,HS_getNumberOfTroopsInCabin(playerName),startPosition,HS_getTypeOfTroopsInCabin(playerName))
			end
			HS_setNumberOfTroopsInCabin(playerName,0)
			HS_typeOfTroopsInCabin[coa][playerName] = {}
		end
	end
end

HS_groupOffloadTroopsToGroup = function(playerGroupName,targetGroupName)
local count

	local playerGroup = HS_getGroup(playerGroupName)
	local units = Group.getUnits(playerGroup)
	for count = 1,#units do
		playerUnit = units[count]
		if playerUnit and not Unit.inAir(playerUnit) then
			local playerName = Unit.getName(playerUnit)
			mist.scheduleFunction(HS_offloadTroopsToGroup,{playerName,targetGroupName},timer.getTime()+count)
		end
	end
end

HS_checkForFlag = function(flagName,code,arguments)
	if trigger.misc.getUserFlag(flagName) == 1 then
		trigger.action.setUserFlag(flagName,0)
		mist.scheduleFunction(code,arguments,timer.getTime()+0.1)
	end
	mist.scheduleFunction(HS_checkForFlag,{flagName,code,arguments},timer.getTime()+1)
end

HS_addRadioItem = function(playerGroupName,itemText,code,arguments)
local count

	local playerGroup = HS_getGroup(playerGroupName)
	if playerGroup then
		local coa = HS_getGroupCoalition(playerGroupName)
		if not HS_menuItems[coa][playerGroupName] then
			HS_menuItems[coa][playerGroupName] = {}
		else
			for count = 1,#HS_menuItems[coa][playerGroupName] do
				if HS_menuItems[coa][playerGroupName][count].text == itemText then
					return false
				end
			end
		end
		table.insert(HS_menuItems[coa][playerGroupName],{id = Group.getID(playerGroup), text = itemText}) -- add radio item to "F10" menu
		trigger.action.addOtherCommandForGroup(Group.getID(playerGroup), itemText, coa .. itemText .. playerGroupName) -- add radio item to "F10" menu
		trigger.action.setUserFlag(coa .. itemText .. playerGroupName,0)
		mist.scheduleFunction(HS_checkForFlag,{coa .. itemText .. playerGroupName,code,arguments},timer.getTime()+1)
	end
end

HS_removeRadioItems = function(playerGroupName)
local i

	local coa = HS_getGroupCoalition(playerGroupName)
	if menuItems[coa][playerGroupName] then
		for i =1,#menuItems[coa][playerGroupName] do
			trigger.action.removeOtherCommandForGroup(menuItems[coa][playerGroupName][i].id, menuItems[coa][playerGroupName][i].text)
		end
	end
	menuItems[coa][playerGroupName] = {}
end

HS_closestAirfield = function (coa,playerName,airfieldList)
local distance
local newDistance
local i
local airfieldName
local airfieldPosition
local closestOne

	closestOne = 0
	local playerPosition = HS_getUnitPosition(playerName)
	if playerPosition then
		if airfieldList[coa] then
			distance = 1000000
			for i =1,#airfieldList[coa] do -- this loop finds the airfield unit that is closest to the helo
				airfieldName = airfieldList[coa][i]
				if airfieldName then
					airfieldPosition = Airbase.getPosition(Airbase.getByName(airfieldName)).p
					newDistance = mist.utils.get2DDist(playerPosition, airfieldPosition)
					if newDistance < distance then -- is this the closest one so far
						distance = newDistance
						closestOne = i -- yes, mark it as such
					end
				end
			end
			return airfieldList[coa][closestOne],distance
		end
	end
end

HS_findAirfieldId = function(airfieldName)
local count,ID
	ID = 0
	for count = 1,#HS_airfields do
		if HS_airfields[count].name == airfieldName then
			ID = HS_airfields[count].id
			break
		end
	end
	return ID
end

HS_flyMission = function(playerGroupName,targetGroupName)
local airfieldName,distance 

	HS_groupStart(playerGroupName) -- start up engine
	local group = HS_getGroup(playerGroupName)
	if group then
		local playerName = Unit.getName(Group.getUnits(group)[1])
		local coa = HS_getUnitCoalition(playerName)
		local infantryPosition = HS_getAvgPos(targetGroupName)
		local startPoint = HS_getAvgPos(playerGroupName)
		local hoverPoint1 = mist.getRandPointInCircle(infantryPosition, 1000, 50)
		local hoverPoint2 = mist.getRandPointInCircle(startPoint, 100, 50)
		local landPoint = mist.getRandPointInCircle (infantryPosition, 1000, 50)
		HS_initializeAirfieldList()
		if #HS_airfieldList[coa] > 0 then
			airfieldName,distance = HS_closestAirfield(coa,startPoint,HS_airfieldList)
			HS_out(coa,'This is ' .. playerName .. '. Ready for take-off from ' .. airfieldName .. '. Objective is to assist ' .. targetGroupName .. '.',30)
			local airfieldId = HS_findAirfieldId(airfieldName)
			local currentTime = timer.getTime()
			if airfieldId > 0 then
				local misTask =
				{ 
					id = 'Mission', 
					params =
					{ 
						route =
						{ 
							points =
							{
								[1] = 
								{
									["alt"] = startPoint.y,
									["type"] = "TakeOffParking",
									["action"] = "From Parking Area",
									["alt_type"] = "BARO",
									["formation_template"] = "",
									["properties"] = 
									{
										["vnav"] = 1,
										["scale"] = 0,
										["angle"] = 0,
										["vangle"] = 0,
										["steer"] = 2,
									}, -- end of ["properties"]
									["ETA"] = currentTime,
									["airdromeId"] = airfieldId,
									["y"] = startPoint.z,
									["x"] = startPoint.x,
									["speed"] = 41.666666666667,
									["ETA_locked"] = true,
									["task"] = 
									{
										["id"] = "ComboTask",
										["params"] = 
										{
											["tasks"] = 
											{
											}, -- end of ["tasks"]
										}, -- end of ["params"]
									}, -- end of ["task"]
									["speed_locked"] = false,
								}, -- end of [1]
								[2] = 
								{
									["alt"] = 100,
									["type"] = "Turning Point",
									["action"] = "Turning Point",
									["alt_type"] = "RADIO",
									["formation_template"] = "",
									["properties"] = 
									{
										["vnav"] = 1,
										["scale"] = 0,
										["angle"] = 0,
										["vangle"] = 0,
										["steer"] = 2,
									}, -- end of ["properties"]
									["ETA"] = currentTime+200,
									["y"] = hoverPoint1.y,
									["x"] = hoverPoint1.x,
									["speed"] = 41.666666666667,
									["ETA_locked"] = false,
									["task"] = 
									{
										["id"] = "ComboTask",
										["params"] = 
										{
											["tasks"] = 
											{
												[1] = 
												{
													["number"] = 1,
													["auto"] = false,
													["id"] = "Land",
													["enabled"] = true,
													["params"] = 
													{
														["y"] = landPoint.y,
														["x"] = landPoint.x,
														["duration"] = 30,
														["durationFlag"] = true,
													}, -- end of ["params"]
												}, -- end of [1]
											}, -- end of ["tasks"]
										}, -- end of ["params"]
									}, -- end of ["task"]
									["speed_locked"] = true,
								}, -- end of [2]
								[3] = 
								{
									["alt"] = 100,
									["type"] = "Turning Point",
									["action"] = "Turning Point",
									["alt_type"] = "RADIO",
									["formation_template"] = "",
									["properties"] = 
									{
										["vnav"] = 1,
										["scale"] = 0,
										["angle"] = 0,
										["vangle"] = 0,
										["steer"] = 2,
									}, -- end of ["properties"]
									["ETA"] = currentTime+400,
									["y"] = hoverPoint2.y,
									["x"] = hoverPoint2.x,
									["speed"] = 41.666666666667,
									["ETA_locked"] = false,
									["task"] = 
									{
										["id"] = "ComboTask",
										["params"] = 
										{
											["tasks"] = 
											{
												[1] = 
												{
													["number"] = 1,
													["auto"] = false,
													["id"] = "Land",
													["enabled"] = true,
													["params"] = 
													{
														["y"] = startPoint.z,
														["x"] = startPoint.x,
														["duration"] = 1800,
														["durationFlag"] = true,
													}, -- end of ["params"]
												}, -- end of [1]
											}, -- end of ["tasks"]
										}, -- end of ["params"]
									}, -- end of ["task"]
									["speed_locked"] = true,
								}, -- end of [3]
							}, -- end of ["points"]
						},	
					},
				}
				local groupCon = group:getController()
				if groupCon then
					mist.scheduleFunction(Controller.pushTask,{groupCon,misTask},timer.getTime()+10) -- new task begins in 10s
				end
			end
		end
	end
end

HS_AIhasTouchedDown = function(playerName)
local airfield,distance

	local playerUnit = HS_getUnit(playerName)
	if playerUnit then
		local playerGroup = Unit.getGroup(playerUnit)
		if playerGroup then
			local coa = HS_getUnitCoalition(playerName)
			local playerGroupName = Group.getName(playerGroup)
			HS_initializeAirfieldList()
			if #HS_airfieldList[coa] > 0 then
				airfieldName,distance = HS_closestAirfield(coa,Unit.getPosition(playerUnit).p,HS_airfieldList)
				if distance < 3000 then
					if HS_getNumberOfTroopsInCabin(playerName)+HS_getNumberOfRescuedPilotsInCabin(playerName) > 0 then
						HS_offloadTroops(playerName)
					end
					local groupName = mist.cloneGroup(playerGroupName,true) -- respawn helo
					mist.scheduleFunction(Group.destroy,{playerGroup},timer.getTime()+10)			
					mist.scheduleFunction(HS_declareAsAI,{groupName},timer.getTime()+20) -- respawn helo
				elseif HS_getNumberOfTroopsInCabin(playerName)+HS_getNumberOfRescuedPilotsInCabin(playerName) > 0 then
					HS_offloadTroops(playerName)
				else
					HS_loadTroops(playerName)
				end
			end
		end
	end
end

HS_howManyGroupsInNeed = function(coa)
local groupName,value

	local count = 0
	for groupName,value in pairs(HS_groupsInNeed[coa]) do
		count = count+1
	end
	return count
end

HS_pickGroupInNeed = function(coa,count)
local groupName,value

	local count2 = count
	for groupName,value in pairs(HS_groupsInNeed[coa]) do
		count2 = count2-1
		if count2 == 0 then
			return groupName
		end
	end
end

HS_declareAsAI = function(playerGroupName)
local count,closestGroup,distance,closestPickUpGroup

	local group = HS_getGroup(playerGroupName)
	if group then
		local coa = HS_getGroupCoalition(playerGroupName)
		local units = Group.getUnits(group)
		local numberOfTroopsInNeed = HS_howManyGroupsInNeed(coa)
		if numberOfTroopsInNeed > 0 then
			closestGroup = HS_pickGroupInNeed(coa,mist.random(numberOfTroopsInNeed))
		else
			closestGroup,distance = HS_closestInfantryGroup(coa,HS_getAvgPos(playerGroupName),{'Airfield','Temporary','Left over','MANPADS'})
		end
		closestPickUpGroup,distance = HS_closestInfantryGroup(coa,HS_getAvgPos(playerGroupName),{'Temporary'})
		mist.scheduleFunction(HS_flyMission,{playerGroupName,closestGroup},timer.getTime()+mist.utils.get2DDist(HS_getAvgPos(playerGroupName),HS_getAvgPos(closestPickUpGroup))/3+1)
		for count = 1, #units do
			local unit = units[count]
			if unit then
				local playerName = Unit.getName(unit)
				HS_onTouchDownDo(playerName,HS_AIhasTouchedDown,{playerName})
				if string.sub(closestGroup,1,string.len('Pilot Down')) ~= 'Pilot Down' then
					mist.scheduleFunction(HS_loadTroops,{playerName},timer.getTime()+count)
				end
			end
		end
	end
end

HS_estimatePresentPosition = function(playerGroupName)
	local playerName = Unit.getName(Group.getUnits(HS_getGroup(playerGroupName))[1])
	local outText = mist.getLLString({units = {playerName}, acc = 0, DMS = true})
	local firstmin = string.find(outText, '\'', 1)
	local string1 = string.sub(outText, 1, firstmin)
	firstmin = string.find(outText, 'N', 1)
	local string2 = string.sub(outText, firstmin)
	firstmin = string.find(string2, '\'', 1)
	string2 = string.sub(string2, 1, firstmin)
	local coa = HS_getGroupCoalition(playerGroupName)
	return string1 .. ' ' .. string2 .. ' W '
end

HS_checkForSmoke = function(coa,playerGroupName,infantryList)
local groupName,value,color,closestOne

	local timing = 0
	local newInfantryList = {}
	local playerGroup = HS_getGroup(playerGroupName)
	if playerGroup then
		local playerUnits = Group.getUnits(playerGroup)
		if playerUnits then
			for count = 1,#playerUnits do
				local playerUnit = playerUnits[count]
				if playerUnit then
					local playerPosition = HS_getAvgPos(playerGroupName)
					for groupName,value in pairs(mist.DBs.groupsByName) do
						if HS_isGroupInfantry(groupName) and coa == HS_getGroupCoalition(groupName) and string.sub(groupName,1,string.len('Temporary')) ~= 'Temporary' then
							local infantryPosition = HS_getAvgPos(groupName)
							if playerPosition and infantryPosition and mist.utils.get2DDist(playerPosition, infantryPosition) < 5000 then
								if not infantryList[groupName] then
									newInfantryList[groupName] = 1
									if coa == 'blue' then
										color = 4
									else
										color = 1
									end
									timing = timing + 5
									mist.scheduleFunction(HS_out,{coa,Unit.getName(playerUnit) .. ', this is ' .. groupName .. '. Popping smoke',10},timer.getTime()+timing)
									mist.scheduleFunction(trigger.action.smoke,{infantryPosition, color},timer.getTime()+timing)
									closestOne,distance = HS_closestInfantryGroup(HS_opponent[coa],Unit.getName(Group.getUnits(HS_getGroup(groupName))[1]))
									if distance < 5000 then
										local enemyInfantryPosition = HS_getAvgPos(closestOne)
										local heading = HS_getHeading(enemyInfantryPosition,infantryPosition)
										mist.scheduleFunction(HS_out,{coa, 'The enemy is at a distance of ' .. math.floor((mist.utils.get2DDist(enemyInfantryPosition,infantryPosition)+50)/100)*100 .. ' meters, heading ' .. heading .. ' from our position.',10},timer.getTime()+timing+1)
									end
								else
									newInfantryList[groupName] = infantryList[groupName]+1
									if newInfantryList[groupName] > 10 then
										newInfantryList[groupName] = nil
									end
								end
							end
						end
					end
					break
				end
			end
		end
		mist.scheduleFunction(HS_checkForSmoke,{coa,playerGroupName,newInfantryList},timer.getTime()+30)
	end
end

HS_addCheckForSmoke = function(playerGroupName)
	local playerGroup = HS_getGroup(playerGroupName)
	if playerGroup then
		local coa = HS_getGroupCoalition(playerGroupName)
		if HS_checkForSmokeList[coa][playerGroupName] then
			return false
		end
		HS_checkForSmokeList[coa][playerGroupName] = true
		mist.scheduleFunction(HS_checkForSmoke,{coa,playerGroupName,{}},timer.getTime()+30)
	end
end

HS_friendlyInfantryReleaseFlare = function(coa,playerGroupName,color)
local groupName,value

	local playerGroup = HS_getGroup(playerGroupName)
	if playerGroup then
		local playerUnits = Group.getUnits(playerGroup)
		if playerUnits then
			for count = 1,#playerUnits do
				local playerUnit = playerUnits[count]
				if playerUnit then
					local playerPosition = HS_getAvgPos(playerGroupName)
					for groupName,value in pairs(mist.DBs.groupsByName) do
						if HS_isGroupInfantry(groupName) and coa == HS_getGroupCoalition(groupName) then
							local infantryPosition = HS_getAvgPos(groupName)
							if playerPosition and infantryPosition and mist.utils.get2DDist(playerPosition, infantryPosition) < 5000 then
								mist.scheduleFunction(HS_out,{coa,Unit.getName(playerUnit) .. ', this is ' .. groupName .. '. Popping flare',10},timer.getTime()+2*math.random())
								mist.scheduleFunction(trigger.action.signalFlare,{infantryPosition, color,0},timer.getTime()+2*math.random())
							end
						end
					end
					break
				end
			end
		end
	end
end

HS_friendlyInfantryReleaseSmoke = function(coa,playerGroupName,color)
local groupName,value

	local playerGroup = HS_getGroup(playerGroupName)
	if playerGroup then
		local playerUnits = Group.getUnits(playerGroup)
		if playerUnits then
			for count = 1,#playerUnits do
				local playerUnit = playerUnits[count]
				if playerUnit then
					local playerPosition = HS_getAvgPos(playerGroupName)
					for groupName,value in pairs(mist.DBs.groupsByName) do
						if HS_isGroupInfantry(groupName) and coa == HS_getGroupCoalition(groupName) then
							local infantryPosition = HS_getAvgPos(groupName)
							if playerPosition and infantryPosition and mist.utils.get2DDist(playerPosition, infantryPosition) < 5000 then
								mist.scheduleFunction(HS_out,{coa,Unit.getName(playerUnit) .. ', this is ' .. groupName .. '. Popping smoke.',10},timer.getTime()+2*math.random())
								mist.scheduleFunction(trigger.action.smoke,{infantryPosition, color,0},timer.getTime()+2*math.random())
							end
						end
					end
					break
				end
			end
		end
	end
end

HS_checkForFlare = function(coa,playerGroupName,infantryList)
local groupName,value,color,closestOne

	local timing = 0
	local newInfantryList = {}
	local playerGroup = HS_getGroup(playerGroupName)
	if playerGroup then
		local playerUnits = Group.getUnits(playerGroup)
		if playerUnits then
			for count = 1,#playerUnits do
				local playerUnit = playerUnits[count]
				if playerUnit then
					local playerPosition = HS_getAvgPos(playerGroupName)
					for groupName,value in pairs(mist.DBs.groupsByName) do
						if HS_isGroupInfantry(groupName) and coa == HS_getGroupCoalition(groupName) and string.sub(groupName,1,string.len('Temporary')) ~= 'Temporary' then
							local infantryPosition = HS_getAvgPos(groupName)
							if playerPosition and infantryPosition and mist.utils.get2DDist(playerPosition, infantryPosition) < 3000 then
								if not infantryList[groupName] then
									newInfantryList[groupName] = 1
									if coa == 'blue' then
										color = 3
									else
										color = 1
									end
									timing = timing + 5
									mist.scheduleFunction(HS_out,{coa,Unit.getName(playerUnit) .. ', this is ' .. groupName .. '. Popping flare',10},timer.getTime()+timing)
									mist.scheduleFunction(trigger.action.signalFlare,{infantryPosition, color,0},timer.getTime()+timing)
									if HS_AIOffWhenNotInSight and string.sub(groupName,1,string.len('Airfield')) ~= 'Airfield' then
										mist.scheduleFunction(trigger.action.setGroupAIOn,{HS_getGroup(groupName)},timer.getTime()+1)
									end
									closestOne,distance = HS_closestInfantryGroup(HS_opponent[coa],Unit.getName(Group.getUnits(HS_getGroup(groupName))[1]))
									if distance < 3000 then
										if HS_AIOffWhenNotInSight then
											mist.scheduleFunction(trigger.action.setGroupAIOn,{HS_getGroup(closestOne)},timer.getTime()+1)
										end
										local enemyInfantryPosition = HS_getAvgPos(closestOne)
										local heading = HS_getHeading(enemyInfantryPosition,infantryPosition)
										mist.scheduleFunction(HS_out,{coa, 'The enemy is at a distance of ' .. math.floor((mist.utils.get2DDist(enemyInfantryPosition,infantryPosition)+50)/100)*100 .. ' meters, heading ' .. heading .. ' from our position.',10},timer.getTime()+timing+1)
									end
								else
									newInfantryList[groupName] = infantryList[groupName]+1
									if newInfantryList[groupName] > 10 then
										newInfantryList[groupName] = nil
									end
								end
							end
						end
					end
					break
				end
			end
		end
		mist.scheduleFunction(HS_checkForFlare,{coa,playerGroupName,newInfantryList},timer.getTime()+30)
	end
end

HS_addCheckForFlare = function(playerGroupName)
	local playerGroup = HS_getGroup(playerGroupName)
	if playerGroup then
		local coa = HS_getGroupCoalition(playerGroupName)
		if HS_checkForFlareList[coa][playerGroupName] then
			return false
		end
		HS_checkForFlareList[coa][playerGroupName] = true
		mist.scheduleFunction(HS_checkForFlare,{coa,playerGroupName,{}},timer.getTime()+30)
	end
end

HS_generateAirDefence = function(coa,number,zone)
local i
local unitType,country

	if coa == 'red' then
		unitType = 'Tor 9A331'
	else
		unitType = 'M1097 Avenger'
	end
	country = HS_country[coa]
	
	local units = {}
	HS_AAAcounter[coa] = HS_AAAcounter[coa] + 1
	for i =1,number do
		local unitPosition = mist.getRandPointInCircle(mist.utils.zoneToVec3(zone),mist.DBs.zonesByName[zone].radius) -- get random position for individual unit
		table.insert(units,
		{
			["x"] = unitPosition.x,
			["y"] = unitPosition.y,
			["type"] = unitType,
			["name"] = coa .. ' AAA Group #' .. HS_AAAcounter[coa] .. 'Unit #' .. i,
			["heading"] = 0,
			["skill"] = "Random"
		})
	end
	mist.dynAdd({country = country, category = 'GROUND_UNIT', name = coa .. ' AAA Group #' .. HS_AAAcounter[coa], hidden = false, units = units })

	if coa == 'red' then
		unitType = 'SA-18 Igla-S manpad'
	else
		unitType = 'Stinger manpad'
	end

	units = {}
	for i =1,number do
		local unitPosition = mist.getRandPointInCircle(mist.utils.zoneToVec3(zone),mist.DBs.zonesByName[zone].radius) -- get random position for individual unit
		table.insert(units,
		{
			["x"] = unitPosition.x,
			["y"] = unitPosition.y,
			["type"] = unitType,
			["name"] = coa .. ' MANPADS Group #' .. HS_AAAcounter[coa] .. 'Unit #' .. i,
			["heading"] = 0,
			["skill"] = "Average"
		})
	end
	mist.dynAdd({country = country, category = 'GROUND_UNIT', name = coa .. ' MANPADS Group #' .. HS_AAAcounter[coa], hidden = false, units = units })
end

HS_generateArty = function(coa,number,zone,heading)
local i
local unitType,country

	if coa == 'red' then
		unitType = 'SAU Msta'
	else
		unitType = 'M-109'
	end
	country = HS_country[coa]
	
	local units = {}
	HS_AAAcounter[coa] = HS_AAAcounter[coa] + 1
	for i =1,number do
		local unitPosition = mist.getRandPointInCircle(mist.utils.zoneToVec3(zone),mist.DBs.zonesByName[zone].radius) -- get random position for individual unit
		table.insert(units,
		{
			["x"] = unitPosition.x,
			["y"] = unitPosition.y,
			["type"] = unitType,
			["name"] = coa .. ' AAA Group #' .. HS_AAAcounter[coa] .. 'Unit #' .. i,
			["heading"] = heading,
			["skill"] = "Random"
		})
	end
	mist.dynAdd({country = country, category = 'GROUND_UNIT', name = coa .. ' AAA Group #' .. HS_AAAcounter[coa], hidden = false, units = units })

	if coa == 'red' then
		unitType = 'BMP-3'
	else
		unitType = 'M1043 HMMWV Armament'
	end

	units = {}
	for i =1,number do
		local unitPosition = mist.getRandPointInCircle(mist.utils.zoneToVec3(zone),mist.DBs.zonesByName[zone].radius) -- get random position for individual unit
		table.insert(units,
		{
			["x"] = unitPosition.x,
			["y"] = unitPosition.y,
			["type"] = unitType,
			["name"] = coa .. ' MANPADS Group #' .. HS_AAAcounter[coa] .. 'Unit #' .. i,
			["heading"] = heading,
			["skill"] = "Average"
		})
	end
	mist.dynAdd({country = country, category = 'GROUND_UNIT', name = coa .. ' MANPADS Group #' .. HS_AAAcounter[coa], hidden = false, units = units })
end

HS_incoming = function(coa,event) -- this is the main routine, coa contains the name of the coalition that was targeted by the missile
local key,value

	local weapon = event.weapon
	if Weapon.isExist(weapon) then
		for playerName,value in pairs(HS_checkForIncomingList[coa]) do -- loop of all client helicopter in the mission that belong to the target coalition
			local playerUnit = HS_getUnit(playerName) -- get unit
			if playerUnit then -- is unit alive?
				local position = Weapon.getPosition(weapon).p -- get position of missile
				local playerPosition = Unit.getPosition(playerUnit).p -- get position of helicopter
				local relativePosition = mist.vec.sub(position,playerPosition)
				if mist.vec.mag(relativePosition) < HS_detectionRange then -- was the missile launch within the detection range?
					local playerHeading = mist.getHeading(playerUnit) -- the rest of the code determines the 'o'clock' bearing of the missile relative to the helicopter
					local headingVector = {x = math.cos(playerHeading),y=0,z=math.sin(playerHeading)}
					local headingVectorPerpendicular = {x = math.cos(playerHeading+math.pi/2),y=0,z=math.sin(playerHeading+math.pi/2)}
					local forwardDistance = mist.vec.dp(relativePosition,headingVector)
					local rightDistance = mist.vec.dp(relativePosition,headingVectorPerpendicular)
					local angle = math.atan2(rightDistance,forwardDistance)*180/math.pi
					if angle < 0 then
						angle = 360+angle
					end
					angle = math.floor(angle*12/360+0.5)
					if angle == 0 then
						angle = 12
					end
					local text = '[copilot] Incoming ' .. angle .. ' oclock'
					HS_INCOM_outUnit(playerName,text,1) -- output warning text and audio
				end
			end
		end
		mist.scheduleFunction(HS_incoming,{coa,event},timer.getTime()+1) -- next warning will occur in 1 second
	end
end

HS_addCheckForIncoming = function(playerName)
	local coa = HS_getUnitCoalition(playerName)
	if HS_checkForIncomingList[coa][playerName] then
		return false
	end
	HS_checkForIncomingList[coa][playerName] = true
	return true
end

HS_bogeyDope = function(playerName) -- this is the main routine, coa contains the name of the coalition that was targeted by the missile
local count,unitName
	local closestOne = nil
	local distance = 1E6
	local playerPosition = HS_getUnitPosition(playerName)
	if playerPosition then
		if playerPosition.y > 100+land.getHeight(mist.utils.makeVec2(playerPosition)) then
			local coa = HS_getUnitCoalition(playerName)
			local opponentCoa = HS_opponent[coa]
			for count = 1,#mist.DBs.unitsByCat["plane"] do
				if mist.DBs.unitsByCat["plane"][count]["coalition"] == opponentCoa then
					unitName = mist.DBs.unitsByCat["plane"][count]["unitName"]
					local enemyPosition = HS_getUnitPosition(unitName) 
					if enemyPosition and unitName ~= 'Overlord' and unitName ~= '999' then
						if enemyPosition.y > 100+land.getHeight(mist.utils.makeVec2(enemyPosition)) and mist.utils.get2DDist(playerPosition,enemyPosition) < distance then
							distance = mist.utils.get2DDist(playerPosition,enemyPosition)
							closestOne = unitName
						end
					end
				end
			end
			if closestOne then
				if distance < 1000 then
					if coa == 'blue' then
						HS_out(coa,playerName .. ', this is Overlord. We have a contact, likely a bandit: merged.',10)
					else
						HS_out(coa,playerName .. ', this is 999. We have a contact, likely a bandit: merged.',10)
					end
				elseif coa == 'blue' then
					HS_out(coa,playerName .. ', this is Overlord. We have a contact, likely a bandit: BRA ' .. mist.getBRString({units = {closestOne}, ref = playerPosition, alt = playerPosition.y}),10)
				else
					HS_out(coa,playerName .. ', this is 999. We have a contact, likely a bandit: BRA ' .. mist.getBRString({units = {closestOne}, ref = playerPosition, alt = playerPosition.y, metric = true}),10)
				end
			end
		end
		mist.scheduleFunction(HS_bogeyDope,{playerName},timer.getTime()+30+mist.random(60))
	end
end

HS_addBogeyDope = function(playerName)
	mist.scheduleFunction(HS_bogeyDope,{playerName},timer.getTime()+30+mist.random(60))
end

HS_sinkRate = function(playerName) -- this is the main routine, coa contains the name of the coalition that was targeted by the missile
	local playerUnit = HS_getUnit(playerName) -- get unit
	if playerUnit then -- is unit alive?
		local playerHeading = mist.getHeading(playerUnit)
		local headingVector = {x = math.cos(playerHeading),y=0,z=math.sin(playerHeading)}
		local velocity = Unit.getVelocity(playerUnit) -- let's get its velocity
		local forwardVelocity = math.abs(mist.vec.dp(velocity,headingVector))
		local sinkRate = -velocity.y
		if forwardVelocity < 15 and sinkRate > 2.5 then
			HS_sinkRate_outUnit(playerName,'[copilot] sink rate',1)
			mist.scheduleFunction(HS_sinkRate,{playerName},timer.getTime()+1) -- next warning will occur in 1 second
			return
		end
		mist.scheduleFunction(HS_sinkRate,{playerName},timer.getTime()+0.3) -- next warning will occur in 0.3 second
	end
end

HS_addCheckForSinkRate = function(playerName)
	mist.scheduleFunction(HS_sinkRate,{playerName},timer.getTime()+0.3) -- next warning will occur in 1 second
end

HS_hoverGuidance = function(playerName,hoverPoint,duration)

local duration2

	local playerUnit = HS_getUnit(playerName)
	if playerUnit then
		local name = hoverPoint.name
		local position2 = hoverPoint.position
		local minD = hoverPoint.minD
		local maxD = hoverPoint.maxD
		local minH = hoverPoint.minH
		local maxH = hoverPoint.maxH
		local hoverDuration = hoverPoint.hoverDuration
		local code = hoverPoint.code
		local arguments = hoverPoint.arguments
		if duration then
			duration2 = duration
		else
			duration2 = 0
		end
		position = HS_getUnitPosition(position2)
		if not HS_hoverActive[playerName] or HS_hoverActive[playerName] == name then
			local groupId = Group.getID(Unit.getGroup(playerUnit))
			local playerPosition = Unit.getPosition(playerUnit).p -- position of helicopter pilot
			local coa = HS_getUnitCoalition(playerName)
			local landHeight = land.getHeight(mist.utils.makeVec2(playerPosition)) -- get altitude of ground
			local playerHeading = math.atan2(Unit.getPosition(playerUnit).x.z,Unit.getPosition(playerUnit).x.x) -- beginning of code that determines crew chief instructions
			local headingVector = {x = math.cos(playerHeading),y=0,z=math.sin(playerHeading)}
			local headingVectorPerpendicular = {x = -math.sin(playerHeading),y=0,z=math.cos(playerHeading)}
			local relativePosition = mist.vec.sub(position,playerPosition)
			local forwardDistance = mist.vec.dp(relativePosition,headingVector)
			local rightDistance = mist.vec.dp(relativePosition,headingVectorPerpendicular)
			local distance = math.sqrt(forwardDistance*forwardDistance+rightDistance*rightDistance) -- beginning of code that determines crew chief instructions
			if distance < minD then
				duration2 = duration2 + 1
			elseif distance > minD and distance < maxD then -- are we in the distance range where we want crew chief instructions?
				duration2 = 0
				if math.abs(forwardDistance) > math.abs(rightDistance) then -- now output the appropriate instructions
					trigger.action.outTextForGroup(groupId,math.floor(math.abs(forwardDistance)+0.5) .. 'm',1)
					if forwardDistance > 0 then
						trigger.action.outSoundForGroup(groupId,HS_forwardAudio)
					else
						trigger.action.outSoundForGroup(groupId,HS_backAudio)
					end
				else
					trigger.action.outTextForGroup(groupId,math.floor(math.abs(rightDistance)+0.5) .. 'm',1)
					if rightDistance > 0 then
						trigger.action.outSoundForGroup(groupId,HS_rightAudio)
					else
						trigger.action.outSoundForGroup(groupId,HS_leftAudio)
					end
				end
			end
			if distance < maxD then
				HS_hoverActive[playerName] = name
				if playerPosition.y-2 > landHeight + maxH then
					duration2 = 0
					mist.scheduleFunction(trigger.action.outSoundForGroup,{groupId,HS_downAudio},timer.getTime()+0.5)
				elseif playerPosition.y-2 < landHeight + minH then
					duration2 = 0
					mist.scheduleFunction(trigger.action.outSoundForGroup,{groupId,HS_upAudio},timer.getTime()+0.5)
				end
			end
			if duration2 > hoverDuration then
				duration2 = 0
				mist.scheduleFunction(code,arguments,timer.getTime()+0.5)
			end
			if HS_hoverActive[playerName] == name and (distance > maxD or HS_hoverStop[playerName][name]) then
				HS_hoverActive[playerName] = nil
			end
		end
		if not HS_hoverStop[playerName][name] then
			mist.scheduleFunction(HS_hoverGuidance,{playerName,{name = name,position = position2,minD = minD,maxD = maxD,minH = minH,maxH = maxH,hoverDuration = hoverDuration,code = code,arguments = arguments},duration2},timer.getTime()+1) -- start this function for each unitName you want the hover guidance, will be run every second
		end
	end
end

HS_addHoverGuidance = function(playerName,hoverPoint)
	if not HS_hoverStop[playerName] then
		HS_hoverStop[playerName] = {}
	end
	HS_hoverStop[playerName][hoverPoint.name] = false
	if not HS_hoverActive[playerName] then
		HS_hoverActive[playerName] = nil
	end
	mist.scheduleFunction(HS_hoverGuidance,{playerName,hoverPoint},timer.getTime()+1) -- start this function for each unitName you want the hover guidance, will be run every second
end

HS_stopHoverGuidance = function(playerName,hoverPointName)
	if not HS_hoverStop[playerName] then
		HS_hoverStop[playerName] = {}
	end
	HS_hoverStop[playerName][hoverPointName] = true
end

HS_fighterHasTouchedDown = function(coa,groupName)
	HS_getGroup(groupName):destroy()
	HS_flyFighterMission(coa,groupName .. ' new')
end

HS_setAirBattleZone = function(zoneName)

	HS_airBattleZone = zoneName
end

HS_flyFighterMission = function(coa,groupName,airstart)
local count
local altitude

	HS_initializeAirfieldList()
	if #HS_airfieldList[coa] > 0 then
		local airfield = HS_airfieldList[coa][mist.random(#HS_airfieldList[coa])]
		local airfieldId = HS_findAirfieldId(airfield)
		local airbase = Airbase.getByName(airfield)
		if airbase then
			local position = Airbase.getPosition(airbase).p
			local waypoints = {}
			local points = {}
			local currentTime = timer.getTime()
			for count = 1,6 do
				waypoints[count] = mist.getRandPointInCircle(mist.utils.zoneToVec3(HS_airBattleZone),mist.DBs.zonesByName[HS_airBattleZone].radius)
				table.insert(points,{
										["alt"] = 6096,
										["type"] = "Turning Point",
										["action"] = "Turning Point",
										["alt_type"] = "BARO",
										["formation_template"] = "",
										["properties"] = 
										{
											["vnav"] = 1,
											["scale"] = 0,
											["angle"] = 0,
											["vangle"] = 0,
											["steer"] = 2,
										}, -- end of ["properties"]
										["ETA"] = currentTime+(count-1)*100,
										["y"] = waypoints[count].y,
										["x"] = waypoints[count].x,
										["speed"] = 138.88888888889,
										["ETA_locked"] = false,
										["task"] = 
										{
											["id"] = "ComboTask",
											["params"] = 
											{
												["tasks"] = 
												{
												}, -- end of ["tasks"]
											}, -- end of ["params"]
										}, -- end of ["task"]
										["speed_locked"] = true,
									})
			end
			if airstart then
				altitude = 6096+mist.random(1000)
				position = mist.utils.makeVec3(mist.getRandPointInCircle(position,2000))
				points[1].y = position.z
				points[1].x = position.x
			else
				altitude = 0
				points[1] = {
								["alt"] = 0,
								["type"] = "TakeOffParking",
								["action"] = "From Parking Area",
								["alt_type"] = "RADAR",
								["formation_template"] = "",
								["properties"] = 
								{
									["vnav"] = 1,
									["scale"] = 0,
									["angle"] = 0,
									["vangle"] = 0,
									["steer"] = 2,
								}, -- end of ["properties"]
								["ETA"] = currentTime,
								["airdromeId"] = airfieldId,
								["y"] = position.z,
								["x"] = position.x,
								["speed"] = 0,
								["ETA_locked"] = true,
								["task"] = 
								{
									["id"] = "ComboTask",
									["params"] = 
									{
										["tasks"] = 
										{
											[1] = 
											{
												["number"] = 1,
												["auto"] = true,
												["id"] = "EngageTargets",
												["enabled"] = true,
												["key"] = "CAP",
												["params"] = 
												{
													["targetTypes"] = 
													{
														[1] = "Planes",
													}, -- end of ["targetTypes"]
													["priority"] = 0,
												}, -- end of ["params"]
											}, -- end of [1]
										}, -- end of ["tasks"]
									}, -- end of ["params"]
								}, -- end of ["task"]
								["speed_locked"] = true,
							}
			end
			if coa == 'blue' then
				HS_pilotCounter[coa] = HS_pilotCounter[coa]+1
				local unitName = 'Enfield' .. HS_pilotCounter[coa] .. '1 (Fighter)'
				mist.scheduleFunction(mist.dynAdd,{{country = 'USA', category = 'AIRPLANE', 
					["modulation"] = 0,
					["radioSet"] = false,
					["task"] = "CAP",
					["uncontrolled"] = false,
					["taskSelected"] = true,
					["route"] = 
					{
						["points"] = points
					}, -- end of ["route"]
					["hidden"] = false,
					["units"] = 
					{
						[1] = 
						{
							["alt"] = altitude,
							["hardpoint_racks"] = true,
							["alt_type"] = "RADAR",
							["livery_id"] = "usaf 77th fs (sw) shaw afb",
							["skill"] = "Random",
							["speed"] = 152.77777777778,
							["type"] = "F-16C bl.52d",
							["unitId"] = 140,
							["psi"] = -0.1672834992885,
							["y"] = position.z,
							["x"] = position.x,
							["name"] = unitName,
							["payload"] = 
							{
								["pylons"] = 
								{
									[1] = 
									{
										["CLSID"] = "{C8E06185-7CD6-4C90-959F-044679E90751}",
									}, -- end of [1]
									[3] = 
									{
										["CLSID"] = "{444BA8AE-82A7-4345-842E-76154EFCCA46}",
									}, -- end of [3]
									[4] = 
									{
										["CLSID"] = "{F376DBEE-4CAE-41BA-ADD9-B2910AC95DEC}",
									}, -- end of [4]
									[5] = 
									{
										["CLSID"] = "{CAAC1CFD-6745-416B-AFA4-CB57414856D0}",
									}, -- end of [5]
									[6] = 
									{
										["CLSID"] = "{6D21ECEA-F85B-4E8D-9D51-31DC9B8AA4EF}",
									}, -- end of [6]
									[7] = 
									{
										["CLSID"] = "{F376DBEE-4CAE-41BA-ADD9-B2910AC95DEC}",
									}, -- end of [7]
									[8] = 
									{
										["CLSID"] = "{444BA8AE-82A7-4345-842E-76154EFCCA46}",
									}, -- end of [8]
									[10] = 
									{
										["CLSID"] = "{C8E06185-7CD6-4C90-959F-044679E90751}",
									}, -- end of [10]
								}, -- end of ["pylons"]
								["fuel"] = 2483,
								["flare"] = 45,
								["chaff"] = 90,
								["gun"] = 100,
							}, -- end of ["payload"]
							["heading"] = -1.4896291831607,
							["callsign"] = 
							{
								[1] = 1,
								[2] = HS_pilotCounter[coa],
								[3] = 1,
								["name"] = 'Enfield' .. HS_pilotCounter[coa] .. '1',
							}, -- end of ["callsign"]
							["onboard_num"] = '1' .. HS_pilotCounter[coa],
						}, -- end of [1]
					}, -- end of ["units"]
					["y"] = position.z,
					["x"] = position.x,
					["name"] = groupName,
					["communication"] = true,
					["frequency"] = 124,
				}},timer.getTime()+1)
				mist.scheduleFunction(HS_onTouchDownDo,{unitName,HS_fighterHasTouchedDown,{coa,groupName}},timer.getTime()+2)
			else
				HS_pilotCounter[coa] = HS_pilotCounter[coa]+1
				local unitName = '' .. 500+HS_pilotCounter[coa] .. ' (Fighter)'
				mist.scheduleFunction(mist.dynAdd,{{country = 'RUSSIA', category = 'AIRPLANE', 
					["modulation"] = 0,
					["radioSet"] = false,
					["task"] = "CAP",
					["uncontrolled"] = false,
					["taskSelected"] = true,
					["route"] = 
					{
						["points"] = points, -- end of ["points"]
					}, -- end of ["route"]
					["hidden"] = false,
					["units"] = 
					{
						[1] = 
						{
							["alt"] = altitude,
							["hardpoint_racks"] = true,
							["alt_type"] = "RADAR",
							["livery_id"] = "Kilpyavr AFB (Maresyev)",
							["skill"] = "Random",
							["speed"] = 152.77777777778,
							["type"] = "Su-27",
							["UnitId"] = 207,
							["psi"] = -1.8954786763516,
							["y"] = position.z,
							["x"] = position.x,
							["name"] = unitName,
							["payload"] = 
							{
								["pylons"] = 
								{
									[1] = 
									{
										["CLSID"] = "{44EE8698-89F9-48EE-AF36-5FD31896A82F}",
									}, -- end of [1]
									[2] = 
									{
										["CLSID"] = "{FBC29BFE-3D24-4C64-B81D-941239D12249}",
									}, -- end of [2]
									[3] = 
									{
										["CLSID"] = "{B79C379A-9E87-4E50-A1EE-7F7E29C2E87A}",
									}, -- end of [3]
									[4] = 
									{
										["CLSID"] = "{E8069896-8435-4B90-95C0-01A03AE6E400}",
									}, -- end of [4]
									[5] = 
									{
										["CLSID"] = "{E8069896-8435-4B90-95C0-01A03AE6E400}",
									}, -- end of [5]
									[6] = 
									{
										["CLSID"] = "{E8069896-8435-4B90-95C0-01A03AE6E400}",
									}, -- end of [6]
									[7] = 
									{
										["CLSID"] = "{E8069896-8435-4B90-95C0-01A03AE6E400}",
									}, -- end of [7]
									[8] = 
									{
										["CLSID"] = "{B79C379A-9E87-4E50-A1EE-7F7E29C2E87A}",
									}, -- end of [8]
									[9] = 
									{
										["CLSID"] = "{FBC29BFE-3D24-4C64-B81D-941239D12249}",
									}, -- end of [9]
									[10] = 
									{
										["CLSID"] = "{44EE8698-89F9-48EE-AF36-5FD31896A82A}",
									}, -- end of [10]
								}, -- end of ["pylons"]
								["fuel"] = 7520,
								["flare"] = 96,
								["chaff"] = 96,
								["gun"] = 100,
							}, -- end of ["payload"]
							["heading"] = -1.4896291831607,
							["callsign"] = 500+HS_pilotCounter[coa],
							["onboard_num"] = '1' .. HS_pilotCounter[coa],
						}, -- end of [1]
					}, -- end of ["units"]
					["y"] = position.z,
					["x"] = position.x,
					["name"] = groupName,
					["communication"] = true,
					["frequency"] = 127.5,
				}},timer.getTime()+1)
				mist.scheduleFunction(HS_onTouchDownDo,{unitName,HS_fighterHasTouchedDown,{coa,groupName}},timer.getTime()+2)
			end
		end
	end
end

HS_flyTransportMission = function(coa,groupName)

	HS_initializeAirfieldList()
	if #HS_airfieldList[coa] > 0 then
		local airfield1 = HS_airfieldList[coa][mist.random(#HS_airfieldList[coa])]
		local airfieldId1 = HS_findAirfieldId(airfield1)
		local airbase1 = Airbase.getByName(airfield1)
		local airfield2 = HS_airfieldList[coa][mist.random(#HS_airfieldList[coa])]
		local airfieldId2 = HS_findAirfieldId(airfield2)
		local airbase2 = Airbase.getByName(airfield2)
		if airbase1 and airbase2 then
			local position1 = Airbase.getPosition(airbase1).p
			local position2 = Airbase.getPosition(airbase2).p
			local currentTime = timer.getTime()
			if coa == 'blue' then
				HS_pilotCounter[coa] = HS_pilotCounter[coa]+1
				local unitName = 'Pontiac' .. HS_pilotCounter[coa] .. '1 (Transport)'
				mist.scheduleFunction(mist.dynAdd,{{country = 'USA', category = 'AIRPLANE', 
					["modulation"] = 0,
					["radioSet"] = false,
					["task"] = "Transport",
					["uncontrolled"] = false,
					["taskSelected"] = true,
					["route"] = 
					{
										["points"] = 
										{
											[1] = 
											{
												["alt"] = 0,
												["type"] = "TakeOffParking",
												["action"] = "From Parking Area",
												["alt_type"] = "RADAR",
												["formation_template"] = "",
												["properties"] = 
												{
													["vnav"] = 1,
													["scale"] = 0,
													["angle"] = 0,
													["vangle"] = 0,
													["steer"] = 2,
												}, -- end of ["properties"]
												["ETA"] = 0,
												["airdromeId"] = airfieldId1,
												["y"] = position1.z,
												["x"] = position1.x,
												["speed"] = 138.88888888889,
												["ETA_locked"] = true,
												["task"] = 
												{
													["id"] = "ComboTask",
													["params"] = 
													{
														["tasks"] = 
														{
														}, -- end of ["tasks"]
													}, -- end of ["params"]
												}, -- end of ["task"]
												["speed_locked"] = true,
											}, -- end of [1]
											[2] = 
											{
												["alt"] = 0,
												["type"] = "Land",
												["action"] = "Landing",
												["alt_type"] = "RADAR",
												["formation_template"] = "",
												["properties"] = 
												{
													["vnav"] = 1,
													["scale"] = 0,
													["angle"] = 0,
													["vangle"] = 0,
													["steer"] = 2,
												}, -- end of ["properties"]
												["ETA"] = 301.91778256772,
												["airdromeId"] = airfieldId2,
												["y"] = position2.z,
												["x"] = position2.x,
												["speed"] = 138.88888888889,
												["ETA_locked"] = false,
												["task"] = 
												{
													["id"] = "ComboTask",
													["params"] = 
													{
														["tasks"] = 
														{
														}, -- end of ["tasks"]
													}, -- end of ["params"]
												}, -- end of ["task"]
												["speed_locked"] = true,
											}, -- end of [2]
										}, -- end of ["points"]
					}, -- end of ["route"]
					["hidden"] = false,
					["units"] = 
					{
						[1] = 
						{
							["alt"] = 0,
							["alt_type"] = "RADAR",
							["livery_id"] = "US Air Force",
							["skill"] = "Random",
							["speed"] = 0,
							["type"] = "C-130",
							["unitId"] = 1,
							["psi"] = -0.42841579216973,
							["y"] = position1.z,
							["x"] = position1.x,
							["name"] = unitName,
							["payload"] = 
											{
												["pylons"] = 
												{
												}, -- end of ["pylons"]
												["fuel"] = "20830",
												["flare"] = 60,
												["chaff"] = 120,
												["gun"] = 100,
											}, -- end of ["payload"]
							["heading"] = -1.4896291831607,
							["callsign"] = 
							{
								[1] = 8,
								[2] = HS_pilotCounter[coa],
								[3] = 1,
								["name"] = 'Pontiac' .. HS_pilotCounter[coa] .. '1',
							}, -- end of ["callsign"]
							["onboard_num"] = '1' .. HS_pilotCounter[coa],
						}, -- end of [1]
					}, -- end of ["units"]
					["y"] = position1.z,
					["x"] = position1.x,
					["name"] = groupName,
					["communication"] = true,
					["frequency"] = 124,
				}},timer.getTime()+1)
			else
				HS_pilotCounter[coa] = HS_pilotCounter[coa]+1
				local unitName = '' .. 900+HS_pilotCounter[coa] .. ' (Transport)'
				mist.scheduleFunction(mist.dynAdd,{{country = 'RUSSIA', category = 'AIRPLANE', 
					["modulation"] = 0,
					["radioSet"] = false,
					["task"] = "Transport",
					["uncontrolled"] = false,
					["taskSelected"] = true,
					["route"] = 
					{
						["points"] =                                     {
											[1] = 
											{
												["alt"] = 0,
												["type"] = "TakeOffParking",
												["action"] = "From Parking Area",
												["alt_type"] = "RADAR",
												["formation_template"] = "",
												["properties"] = 
												{
													["vnav"] = 1,
													["scale"] = 0,
													["angle"] = 0,
													["vangle"] = 0,
													["steer"] = 2,
												}, -- end of ["properties"]
												["ETA"] = 0,
												["airdromeId"] = airfieldId1,
												["y"] = position1.z,
												["x"] = position1.x,
												["speed"] = 138.88888888889,
												["ETA_locked"] = true,
												["task"] = 
												{
													["id"] = "ComboTask",
													["params"] = 
													{
														["tasks"] = 
														{
														}, -- end of ["tasks"]
													}, -- end of ["params"]
												}, -- end of ["task"]
												["speed_locked"] = true,
											}, -- end of [1]
											[2] = 
											{
												["alt"] = 0,
												["type"] = "Land",
												["action"] = "Landing",
												["alt_type"] = "RADAR",
												["formation_template"] = "",
												["properties"] = 
												{
													["vnav"] = 1,
													["scale"] = 0,
													["angle"] = 0,
													["vangle"] = 0,
													["steer"] = 2,
												}, -- end of ["properties"]
												["ETA"] = 301.91778256772,
												["airdromeId"] = airfieldId2,
												["y"] = position2.z,
												["x"] = position2.x,
												["speed"] = 138.88888888889,
												["ETA_locked"] = false,
												["task"] = 
												{
													["id"] = "ComboTask",
													["params"] = 
													{
														["tasks"] = 
														{
														}, -- end of ["tasks"]
													}, -- end of ["params"]
												}, -- end of ["task"]
												["speed_locked"] = true,
											}, -- end of [2]
										}, -- end of ["points"]
					}, -- end of ["route"]
					["hidden"] = false,
					["units"] = 
					{
						[1] = 
						{
							["alt"] = 0,
							["alt_type"] = "RADAR",
							["livery_id"] = "Aeroflot",
							["skill"] = "Random",
							["speed"] = 0,
							["type"] = "An-26B",
							["unitId"] = 1,
							["psi"] = 1.4896291831607,
							["y"] = position1.z,
							["x"] = position1.x,
							["name"] = unitName,
							["payload"] = 
											{
												["pylons"] = 
												{
												}, -- end of ["pylons"]
												["fuel"] = "5500",
												["flare"] = 384,
												["chaff"] = 384,
												["gun"] = 100,
											}, -- end of ["payload"]
							["heading"] = -1.4896291831607,
							["callsign"] = 900+HS_pilotCounter[coa],
							["onboard_num"] = '1' .. HS_pilotCounter[coa],
						}, -- end of [1]
					}, -- end of ["units"]
					["y"] = position1.z,
					["x"] = position1.x,
					["name"] = groupName,
					["communication"] = true,
					["frequency"] = 124,
				}},timer.getTime()+1)
			end
		end
	end
end

HS_setSEADZone = function(zones)

	HS_SEADZone = zones
end

HS_flyHelicopterSEADMission = function(coa,groupName)
local count

	HS_initializeAirfieldList()
	if #HS_airfieldList[coa] > 0 then
		local airfield = HS_airfieldList[coa][mist.random(#HS_airfieldList[coa])]
		local airfieldId = HS_findAirfieldId(airfield)
		local airbase = Airbase.getByName(airfield)
		local zone = HS_SEADZone[coa]
		if airbase then
			local position = Airbase.getPosition(airbase).p
			local waypoints = {}
			local points = {}
			local currentTime = timer.getTime()
			for count = 2,6 do
				waypoints[count] = mist.getRandPointInCircle(mist.utils.zoneToVec3(zone),mist.DBs.zonesByName[zone].radius)
				table.insert(points,{
										["alt"] = 150,
										["type"] = "Turning Point",
										["action"] = "Turning Point",
										["alt_type"] = "RADAR",
										["formation_template"] = "",
										["properties"] = 
										{
											["vnav"] = 1,
											["scale"] = 0,
											["angle"] = 0,
											["vangle"] = 0,
											["steer"] = 2,
										}, -- end of ["properties"]
										["ETA"] = currentTime+(count-1)*200,
										["y"] = waypoints[count].y,
										["x"] = waypoints[count].x,
										["speed"] = 70,
										["ETA_locked"] = false,
										["task"] = 
										{
											["id"] = "ComboTask",
											["params"] = 
											{
												["tasks"] = 
												{
												}, -- end of ["tasks"]
											}, -- end of ["params"]
										}, -- end of ["task"]
										["speed_locked"] = true,
									})
			end
			points[1] = {
							["alt"] = 0,
							["type"] = "TakeOffParking",
							["action"] = "From Parking Area",
							["alt_type"] = "RADAR",
							["formation_template"] = "",
							["properties"] = 
							{
								["vnav"] = 1,
								["scale"] = 0,
								["angle"] = 0,
								["vangle"] = 0,
								["steer"] = 2,
							}, -- end of ["properties"]
							["ETA"] = currentTime,
							["airdromeId"] = airfieldId,
							["y"] = position.z,
							["x"] = position.x,
							["speed"] = 0,
							["ETA_locked"] = true,
							["task"] = 
							{
								["id"] = "ComboTask",
								["params"] = 
								{
									["tasks"] = 
									{
										[1] = 
										{
											["number"] = 1,
											["auto"] = false,
											["id"] = "EngageTargets",
											["enabled"] = true,
											["params"] = 
											{
												["targetTypes"] = 
												{
													[1] = "Air Defence",
												}, -- end of ["targetTypes"]
												["maxDistEnabled"] = false,
												["priority"] = 0,
												["maxDist"] = 15000,
											}, -- end of ["params"]
										}, -- end of [1]
									}, -- end of ["tasks"]
								}, -- end of ["params"]
							}, -- end of ["task"]
							["speed_locked"] = true,
						}
			if coa == 'blue' then
				HS_pilotCounter[coa] = HS_pilotCounter[coa]+1
				local unitName = 'Uzi' .. HS_pilotCounter[coa] .. '1 (helicopter SEAD)'
				mist.scheduleFunction(mist.dynAdd,{{country = 'USA', category = 'helicopter', 
					["modulation"] = 0,
					["radioSet"] = false,
					["task"] = "CAS",
					["uncontrolled"] = false,
					["taskSelected"] = true,
					["route"] = 
					{
						["points"] = points
					}, -- end of ["route"]
					["hidden"] = false,
					["units"] = 
					{
						[1] = 
						{
							["alt"] = 0,
							["hardpoint_racks"] = true,
							["alt_type"] = "RADAR",
							["livery_id"] = "USA X Black",
							["skill"] = "Random",
							["speed"] = 0,
							["type"] = "AH-1W",
							["unitId"] = 1,
							["psi"] = -0.14747899115982,
							["y"] = position.z,
							["x"] = position.x,
							["name"] = unitName,
							["payload"] = 
							{
								["pylons"] = 
								{
									[1] = 
									{
										["CLSID"] = "{88D18A5E-99C8-4B04-B40B-1C02F2018B6E}",
									}, -- end of [1]
									[4] = 
									{
										["CLSID"] = "{88D18A5E-99C8-4B04-B40B-1C02F2018B6E}",
									}, -- end of [4]
								}, -- end of ["pylons"]
								["fuel"] = 1125,
								["flare"] = 30,
								["chaff"] = 30,
								["gun"] = 100,
							}, -- end of ["payload"]
							["heading"] = 0,
							["callsign"] = 
							{
								[1] = 3,
								[2] = HS_pilotCounter[coa],
								[3] = 1,
								["name"] = 'Uzi ' .. HS_pilotCounter[coa] .. '-1',
							}, -- end of ["callsign"]
							["onboard_num"] = "050",
						}, -- end of [1]
					}, -- end of ["units"]
					["y"] = position.z,
					["x"] = position.x,
					["name"] = groupName,
					["communication"] = true,
					["frequency"] = 124,
				}},timer.getTime()+1)
				mist.scheduleFunction(HS_onTouchDownDo,{unitName,HS_fighterHasTouchedDown,{coa,groupName}},timer.getTime()+2)
			else
				HS_pilotCounter[coa] = HS_pilotCounter[coa]+1
				local unitName = '' .. 600+HS_pilotCounter[coa] .. ' (helicopter SEAD)'
				mist.scheduleFunction(mist.dynAdd,{{country = 'RUSSIA', category = 'helicopter', 
					["modulation"] = 0,
					["radioSet"] = false,
					["task"] = "CAS",
					["uncontrolled"] = false,
					["taskSelected"] = true,
					["route"] = 
					{
						["points"] = points, -- end of ["points"]
					}, -- end of ["route"]
					["hidden"] = false,
					["units"] = 
					{
						[1] = 
						{
							["alt"] = 0,
							["hardpoint_racks"] = true,
							["alt_type"] = "RADAR",
							["livery_id"] = "standard 1",
							["skill"] = "Random",
							["speed"] = 0,
							["type"] = "Mi-24V",
							["unitId"] = 1,
							["psi"] = -0.14747899115987,
							["y"] = position.z,
							["x"] = position.x,
							["name"] = unitName,
							["payload"] = 
							{
								["pylons"] = 
								{
									[3] = 
									{
										["CLSID"] = "{FC56DF80-9B09-44C5-8976-DCFAFF219062}",
									}, -- end of [3]
									[4] = 
									{
										["CLSID"] = "{FC56DF80-9B09-44C5-8976-DCFAFF219062}",
									}, -- end of [4]
								}, -- end of ["pylons"]
								["fuel"] = 1363,
								["flare"] = 192,
								["chaff"] = 0,
								["gun"] = 100,
							}, -- end of ["payload"]
							["heading"] = 0,
							["callsign"] = 600+HS_pilotCounter[coa],
							["onboard_num"] = "050",
						}, -- end of [1]
					}, -- end of ["units"]
					["y"] = position.z,
					["x"] = position.x,
					["name"] = groupName,
					["communication"] = true,
					["frequency"] = 127.5,
				}},timer.getTime()+1)
				mist.scheduleFunction(HS_onTouchDownDo,{unitName,HS_fighterHasTouchedDown,{coa,groupName}},timer.getTime()+2)
			end
		end
	end
end

HS_pilotDown = function(event) -- there is a pilot down
local unitType

	local pilotUnit = event.initiator
	if pilotUnit then
		local coa = HS_getUnitCoalition(pilotUnit)
		if coa == 'blue' then
			unitType = 'Soldier M4'
		else
			unitType = 'Infantry AK'
		end
		HS_pilotDownCounter[coa] = HS_pilotDownCounter[coa]+1
		local groupName = 'Pilot Down ' .. coa .. ' Group #' .. HS_pilotDownCounter[coa]
		mist.dynAdd({country = HS_country[coa], category = 'GROUND_UNIT', 
			["visible"] = false,
			["taskSelected"] = true,
			["route"] = 
			{
				["spans"] = 
				{
				}, -- end of ["spans"]
				["points"] = 
				{
					[1] = 
					{
						["alt"] = 0,
						["type"] = "Turning Point",
						["alt_type"] = "RADAR",
						["formation_template"] = "",
						["y"] = mist.vec.add(Unit.getPosition(pilotUnit).p,{x=100,y=0,z=100}).z,
						["x"] = mist.vec.add(Unit.getPosition(pilotUnit).p,{x=100,y=0,z=100}).x,
						["name"] = groupName .. 'WP 1',
						["speed"] = 0,
						["action"] = "Off Road",
						["task"] = 
						{
							["id"] = "ComboTask",
							["params"] = 
							{
								["tasks"] = 
								{
									[1] = 
									{
										["enabled"] = true,
										["auto"] = false,
										["id"] = "EmbarkToTransport",
										["number"] = 1,
										["params"] = 
										{
											["y"] = mist.vec.add(Unit.getPosition(pilotUnit).p,{x=50,y=0,z=50}).z,
											["x"] = mist.vec.add(Unit.getPosition(pilotUnit).p,{x=50,y=0,z=50}).x,
											["zoneRadius"] = 500,
										}, -- end of ["params"]
									}, -- end of [1]
								}, -- end of ["tasks"]
							}, -- end of ["params"]
						}, -- end of ["task"]
						["speed_locked"] = true,
					}, -- end of [1]
				}, -- end of ["points"]
			}, -- end of ["route"]
			["tasks"] = 
			{
			}, -- end of ["tasks"]
			["hidden"] = false,
			["units"] = 
			{
				[1] = 
				{
					["type"] = unitType,
					["transportable"] = 
					{
						["randomTransportable"] = false,
					}, -- end of ["transportable"]
					["skill"] = "Average",
					["y"] = mist.vec.add(Unit.getPosition(pilotUnit).p,{x=100,y=0,z=100}).z,
					["x"] = mist.vec.add(Unit.getPosition(pilotUnit).p,{x=100,y=0,z=100}).x,
					["name"] = groupName .. 'Unit 1',
					["playerCanDrive"] = true,
					["heading"] = 0,
				}, -- end of [1]
			}, -- end of ["units"]
			["y"] = mist.vec.add(Unit.getPosition(pilotUnit).p,{x=100,y=0,z=100}).z,
			["x"] = mist.vec.add(Unit.getPosition(pilotUnit).p,{x=100,y=0,z=100}).z,
			["name"] = groupName,
			["task"] = "Ground Nothing",
		})
		HS_groupsInNeed[coa][groupName] = true
		HS_out(coa,'To all units. We have a pilot down at ' .. HS.estimatePresentPosition(groupName) .. ' broadcasting on ' .. HS.assignADF(coa,groupName),20)
	end
end

HS_reportIAS = function(playerName,oldSpeed,oldHeading,oldTime)
local headingText

	local speed = 0
	local heading = 0
	local unit = HS_getUnit(playerName)
	local coa = HS_getUnitCoalition(unit)
	local currentTime = oldTime
	if unit then
		local playerPosition = Unit.getPosition(unit).p
		local landHeight = land.getHeight({x=playerPosition.x,y=playerPosition.z})
		if playerPosition.y > landHeight+10 then
			heading = math.floor((mist.getHeading(unit)*180/math.pi+5)/10)*10
			if heading < 100 then
				headingText = '0' .. heading
			else
				headingText = '' .. heading
			end
			if headingText == '00' then
				headingText = '360'
			end
			local velocity = Unit.getVelocity(unit) -- let's get its velocity
			local wind = atmosphere.getWind(playerPosition)
			local relativeVelocity = mist.vec.sub(velocity,wind)
			speed = mist.vec.mag(relativeVelocity)  -- calculate its speed
			if speed > 10 and (math.abs(speed - oldSpeed) > 2.5 or math.abs(heading-oldHeading) > 10 or timer.getTime() - oldTime > 60) then
				if coa == 'blue' then
					HS.out(coa,'This is ' ..  playerName .. '. ' .. math.floor(((1-4.5E-5*playerPosition.y)*speed*1.944+2.5)/5)*5 .. ' kts indicated, heading ' .. headingText .. '. ',10)
				else
					HS.out(coa,'This is ' ..  playerName .. '. ' .. math.floor(((1-4.5E-5*playerPosition.y)*speed*1.944*1.852+2.5)/5)*5 .. ' kph indicated, heading ' .. headingText .. '. ',10)
				end
				currentTime = timer.getTime()
			end
		end
		if not HS_IASstop[playerName] then
			mist.scheduleFunction(HS_reportIAS,{playerName,speed,heading,currentTime},timer.getTime() + 3)
		end
	end
end

HS_addReportIAS = function(playerName)
	HS_IASstop[playerName] = false
	mist.scheduleFunction(HS_reportIAS,{playerName,0,0,timer.getTime()},timer.getTime() + 3)
end

HS_stopReportIAS = function(playerName)
	HS_IASstop[playerName] = true
end

local function customEventHandler(event)
local count,key,value,playerName,cargoName,dropOffPoint,dropOffPosition,uponDelivery

-- eventlist = {
			   -- 'SHOT',
			   -- 'HIT',
			   -- 'TAKEOFF',
			   -- 'LAND',
			   -- 'CRASH',
			   -- 'EJECTION',
			   -- 'REFUELING',
			   -- 'DEAD',
			   -- 'PILOT_DEAD',
			   -- 'BASE_CAPTURED',
			   -- 'MISSION_START',
			   -- 'MISSION_END',
			   -- 'TOOK_CONTROL',
			   -- 'REFUELING_STOP',
			   -- 'BIRTH',
			   -- 'HUMAN_FAILURE',
			   -- 'ENGINE_STARTUP',
			   -- 'ENGINE_SHUTDOWN',
			   -- 'PLAYER_ENTER_UNIT',
			   -- 'PLAYER_LEAVE_UNIT',
			   -- '',
			   -- '',
			   -- '',
			   -- '',
			   -- '',
			   -- '',
			   -- '',
			   -- '',
			   -- '',
			   -- '',
			-- }
	-- HS.out('blue','An event has occured: ' .. event.id .. eventlist[event.id],10)
	-- HS.out('red','An event has occured: ' .. event.id .. eventlist[event.id],10)
	-- HS_out('blue', mist.utils.serialize('event',event),20) 
	if event.id == 4 then -- landing
		if event.place then
			local name = event.place:getName()
			if name then
				if HS_shipsToLandOn[name] then
					if HS_shipsToLandOn[name].playerName == event.initiator:getName() then
						mist.scheduleFunction(HS_shipsToLandOn[name].code,HS_shipsToLandOn[name].arguments,timer.getTime() + 0.5)
					end
				end
			end
		end
	end
	
	-- if event.id == world.event.S_EVENT_EJECTION then
		-- HS_pilotDown(event)
	-- end

	-- if event.id == 15 then
		-- local isCargo = false
		-- for key,value in pairs(HS_slingLoads) do
			-- if event.initiator:getName() == key then
				-- playerName = value.playerName
				-- cargoName = value.cargoName
				-- dropOffPoint = value.dropOffPoint
				-- uponDelivery = value.uponDelivery
				-- isCargo = true
				-- break
			-- end
		-- end
		-- if isCargo then
			-- if dropOffPoint then 
				-- HS_stopHoverGuidance(playerName,'hover point ' .. dropOffPoint)
				-- if uponDelivery then
					-- mist.scheduleFunction(uponDelivery,{playerName,cargoName,dropOffPoint},timer.getTime()+1)
				-- end
			-- end
			-- HS_slingLoads[event.initiator:getName()] = nil
		-- end
	-- end
	if HS_AIOffWhenNotInSight and event.id == 2 then
		if event.initiator then
			local group = Unit.getGroup(event.initiator)
			if group then
				if HS_isGroupInfantry(group) then
					mist.scheduleFunction(trigger.action.setGroupAIOn,{group},timer.getTime()+1)
				end
			end
		end
	end
	if HS_casualtyReport then
		local text = ''
		if event.initiator then
			local playerName = Unit.getName(event.initiator)
			if playerName then
				if event.id == 2 then
					text = 'This ' .. playerName .. ' we are taking hits.'
				elseif event.id == 8 then
					text = 'This ' .. playerName .. ' we are taking casualties.'
				elseif event.id == 22 then
					text = 'This ' .. playerName .. '. We have opened fire.'
				end
				if text ~= '' then
					if HS_getUnitCoalition(playerName) == 'blue' then
						trigger.action.outSoundForCoalition(coalition.side.BLUE,HS_radioStaticAudio)
						trigger.action.outTextForCoalition(coalition.side.BLUE,text,3)
					else
						trigger.action.outSoundForCoalition(coalition.side.RED,HS_radioStaticAudio)
						trigger.action.outTextForCoalition(coalition.side.RED,text,3)
					end
				end
			end
		end
	end

-- BEGIN: ADD THIS TO YOUR EVENT HANDLER
	if event.id == world.event.S_EVENT_SHOT then -- was there a weapons launch by one of the SAM sites? 
		if event.initiator then
			mist.scheduleFunction(HS_incoming,{HS_opponent[HS_getUnitCoalition(event.initiator)],event},timer.getTime() + HS_reactionTime) -- warning will be given after reactionTime seconds
		end
	end
-- END: ADD THIS TO YOUR EVENT HANDLER
end

HS_initializeFARP = function(FARPname)
local count2,country
local FARPunits = {blue = {"M978 HEMTT Tanker","M978 HEMTT Tanker","Hummer","M 818","M1043 HMMWV Armament","M48 Chaparral","M48 Chaparral"} , red = {"ATMZ-5","ATMZ-5","Ural-375 PBU","Ural-375 PBU","Ural-375 PBU","Ural-375","Strela-1 9P31","Strela-1 9P31"}}local unitCount

	local position = mist.DBs.unitsByName[FARPname].point
	local coa = mist.DBs.unitsByName[FARPname].coalition
	local units = {}
	for count2 = 1,#FARPunits[coa] do
		table.insert(units,	{
								["type"] = FARPunits[coa][count2],
								["name"] = FARPname .. ' Unit #' .. count2,
								["heading"] = 0,
								["skill"] = "Random",
								["x"] = position.x - 110,
								["y"] = position.y + 110 - 20*count2,
							})
	end
	mist.dynAdd({country = HS_country[coa], category = 'GROUND_UNIT', name = FARPname .. ' Vehicle Group', hidden = false, units = units})

	country = HS_country[coa]
	
	local static1 = {
		country = country,
		category = "Fortifications",
		x = position.x + 110-20,
		y = position.y - 110,
		type = "FARP Ammo Dump Coating",
		name = FARPname .. ' Ammo Depot',
	}
	 
	local static2 = {
		country = country,
		category = "Fortifications",
		x = position.x + 110-40,
		y = position.y - 110,
		type = "FARP CP Blindage",
		name = FARPname .. ' Building',
	}
	 
	local static3 = {
		country = country,
		category = "Fortifications",
		x = position.x + 110-60,
		y = position.y - 110,
		type = "FARP Fuel Depot",
		name = FARPname .. ' Fuel Depot',
	}
	mist.dynAddStatic(static1) 
	mist.dynAddStatic(static2) 
	mist.dynAddStatic(static3) 
end

HS_clearADFlist = function(coa)
local count
	
	for count = 1,#HS_ADFlist[coa] do
		local entry = HS_ADFlist[coa][count]
		if entry.group then
			local groupName = entry.group
			local group = HS_getGroup(groupName)
			if group then
				HS_stopTransmission(groupName)
			end
			HS_ADFlist[coa][count].group = nil
		end
	end
end

HS_removeADF = function(coa,groupName)
local count
	
	for count = 1,#HS_ADFlist[coa] do
		local entry = HS_ADFlist[coa][count]
		if entry.group and entry.group == groupName then
			local groupName = entry.group
			local group = HS_getGroup(groupName)
			if group then
				HS_stopTransmission(groupName)
			end
			HS_ADFlist[coa][count].group = nil
		end
	end
end

HS_assignADF = function(coa,groupName)
local count
	
	for count = 1,#HS_ADFlist[coa] do
		local entry = HS_ADFlist[coa][count]
		if entry.group and entry.group == groupName then
			HS_stopTransmission(groupName)
			mist.scheduleFunction(HS_groupSetADF,{groupName,entry.frequency,entry.modulation},timer.getTime()+1)
			mist.scheduleFunction(HS_startTransmission,{groupName},timer.getTime()+2)
			HS_ADFlist[coa][count].group = groupName
			return entry.name
		end
	end

	for count = 1,#HS_ADFlist[coa] do
		local entry = HS_ADFlist[coa][count]
		if not entry.group then
			mist.scheduleFunction(HS_groupSetADF,{groupName,entry.frequency,entry.modulation},timer.getTime()+1)
			mist.scheduleFunction(HS_startTransmission,{groupName},timer.getTime()+2)
			HS_ADFlist[coa][count].group = groupName
			return entry.name
		end
	end	
	return nil
end

HS_restartMission = function(missionTime,noPlayerTime)
local playerName,value

	if timer.getTime() > missionTime and not HS_restartWarningFlag then
		HS_restartWarningFlag = true
		out('blue','MISSION WILL RESTART IN 5 MINUTES !',60)
		out('red','MISSION WILL RESTART IN 5 MINUTES !',60)
	end
	if timer.getTime() > missionTime+300 and not HS_restartFlag then
		HS_restartFlag = true
	end
	for playerName,value in pairs(mist.DBs.humansByName) do
		local playerUnit = HS_getUnit(playerName)
		if playerUnit and Unit.isActive(playerUnit) then
			HS_timeCounter = 0
			return
		end
	end
	HS_timeCounter = HS_timeCounter + 10
	if HS_timeCounter > noPlayerTime and not HS_restartFlag then
		HS_restartFlag = true
	end
end

HS_hasConvoyArrived = function(coa,convoyGroupName)
local airfieldName,distance,closestOne

	local convoyGroup = HS_getGroup(convoyGroupName)
	if convoyGroup then
		local convoyPosition = HS_getAvgPos(convoyGroupName)
		-- if mist.utils.get2DDist(convoyPosition,endPosition) < 1000 then
			HS_initializeAirfieldList()
			if #HS_airfieldList[coa] > 0 then
				airfieldName,distance = HS_closestAirfield(coa,convoyPosition,HS_airfieldList)
				if distance < 3000 then
					HS_out(coa,convoyGroupName .. ' has arrived at ' .. airfieldName .. ' with supplies.',10)
					closestOne,distance = HS_closestInfantryGroupWithPrefix(coa,convoyPosition,'Airfield')
					local groupSize = 0
					if closestOne and distance < 5000 then
						local closestGroup = HS_getGroup(closestOne)
						groupSize = Group.getSize(closestGroup)
						closestGroup:destroy()
					end
					local newSize = groupSize+Group.getSize(convoyGroup)*5
					HS_out(coa,airfieldName .. ' now has ' .. newSize .. ' combat-ready troops.',10)
					if closestOne and distance < 5000 then
						HS_addInfantryGroup(coa,closestOne,newSize,HS_getAvgPos(closestOne))
					else
						HS_temporaryGroupCounter = HS_temporaryGroupCounter + 1
						HS_addInfantryGroup(coa,'Airfield ' .. airfieldName .. ' Airborne Infantry Platoon #' .. HS_temporaryGroupCounter,newSize,convoyPosition)
					end
					convoyGroup:destroy()
					return
				-- end
			end
		end
		mist.scheduleFunction(HS_hasConvoyArrived,{coa,convoyGroupName},timer.getTime()+60)		
	end
end

HS_spotConvoy = function(coa,groupName)
local count
local headingTexts = {'north','north-east','east','south-east','south','south-west','west','north-west'}
	local group = HS_getGroup(groupName)
	if group and Group.getSize(group) > 0 then
		local units = Group.getUnits(group)
		local headingText = ''
		for count = 1,#units do
			if units[count] then
				local heading = mist.getHeading(units[count])
				heading = (heading + 45/360*math.pi) % (2*math.pi)
				heading = math.floor(heading/2/math.pi*8)+1
				headingText = headingTexts[heading]
				break
			end
		end
		HS_out(HS_opponent[coa],'An enemy truck convoy has been spotted near ' .. HS_estimatePresentPosition(groupName).. ', driving ' .. headingText,30)
		mist.scheduleFunction(HS_spotConvoy,{coa,groupName},timer.getTime()+150+mist.random(150))
	else
		HS_out(HS_opponent[coa],'Enemy truck convoy ' .. groupName .. ' has been destroyed. Nice work.',10)
	end
end

HS_spotMechanized = function(coa,groupName)
local count
local headingTexts = {'north','north-east','east','south-east','south','south-west','west','north-west'}
	local group = HS_getGroup(groupName)
	if group and Group.getSize(group) > 0 then
		local units = Group.getUnits(group)
		local headingText = ''
		for count = 1,#units do
			if units[count] then
				local heading = mist.getHeading(units[count])
				heading = (heading + 45/360*math.pi) % (2*math.pi)
				heading = math.floor(heading/2/math.pi*8)+1
				headingText = headingTexts[heading]
				break
			end
		end
		HS_out(HS_opponent[coa],'An enemy mechanized platoon has been spotted near ' .. HS_estimatePresentPosition(groupName).. ', driving ' .. headingText,30)
		mist.scheduleFunction(HS_spotMechanized,{coa,groupName},timer.getTime()+150+mist.random(150))
	else
		HS_out(HS_opponent[coa],'Enemy mechanized platoon ' .. groupName .. ' has been destroyed. Nice work.',10)
	end
end

HS_isConvoyDead = function(coa,groupName,zoneName)
	if HS_getGroup(groupName) and Group.getSize(HS_getGroup(groupName)) > 0 then
		mist.scheduleFunction(HS_isConvoyDead,{coa,groupName,zoneName},timer.getTime()+60)
	else
		mist.scheduleFunction(HS_createNewConvoy,{coa,zoneName},timer.getTime()+1)
	end
end

HS_createNewConvoy = function(coa)
	local convoyUnits = { blue = {'Hummer','M 818','M1043 HMMWV Armament'} , red = {'Ural-375 ZU-23','UAZ-469','Ural-4320T'}} -- list of units that make up the convoy
	local units = {}
	local position

	HS_convoyCounter[coa] = HS_convoyCounter[coa] + 1
	local groupName = coa .. ' convoy #' .. HS_convoyCounter[coa]
	HS_groupDoNotDisperse(groupName) -- keep driving if attacked
	Group.activate(HS.getGroup(groupName))
	mist.scheduleFunction(HS_hasConvoyArrived,{coa,groupName},timer.getTime()+60)
	mist.scheduleFunction(HS_spotConvoy,{coa,groupName},timer.getTime()+150+mist.random(150))
	return groupName
end

HS_scheduleMissionRestart = function(missionTime,noPlayerTime)

	mist.scheduleFunction(HS_restartMission,{missionTime,noPlayerTime},timer.getTime()+5,10) -- schedule possible mission restart
end

HS_out('blue','Removed event handler',10)

-- mist.addEventHandler(customEventHandler) -- initialize event handler

local count

for count = 1,20 do
	table.insert(HS_ADFlist.blue,{name = 'FM '.. 30.25+(count-1)*0.5 .. ' MHz', frequency = (30.25+(count-1)*0.5)*1E6, modulation = 1, group = nil})
	table.insert(HS_ADFlist.red,{name = 'ARC-9 ADF '.. 502+(count-1)*40 .. ' kHz', frequency = (502+(count-1)*40)*1E3, modulation = 0, group = nil})
end

HS_cableTight = function(playerName,hoverPointName)
	local playerUnit = HS_getUnit(playerName)
	if playerUnit then
		local playerPosition = Unit.getPosition(playerUnit).p
		local landHeight = land.getHeight(mist.utils.makeVec2(playerPosition)) -- get altitude of ground
		if playerPosition.y-2 > landHeight + 7.5 then
			HS_stopHoverGuidance(playerName,hoverPointName)
		else
			mist.scheduleFunction(HS_cableTight,{playerName,hoverPointName},timer.getTime()+1)
		end
	end
end

HS_cargoHasBeenHooked = function(playerName,cargoName,position,dropOffPoint)
local dropOffPosition

	HS_stopHoverGuidance(playerName,'hover point ' .. cargoName)
	local groupId = Group.getID(Unit.getGroup(HS_getUnit(playerName)))
	-- trigger.action.outSoundForGroup(groupId,HS_cargoHookedAudio)
	-- mist.scheduleFunction(HS.addHoverGuidance,{playerName,{name = 'hover point ' .. cargoName,position = position,minD = 2,maxD = 50,minH = 6,maxH = 10, hoverDuration = 1E6, code = nil, arguments = {}}},timer.getTime()+1)
	-- mist.scheduleFunction(HS_cableTight,{playerName,'hover point ' .. cargoName},timer.getTime()+1)
	if dropOffPoint then
		if mist.DBs.zonesByName[dropOffPoint] then
			dropOffPosition = mist.utils.zoneToVec3(dropOffPoint)
		else
			dropOffPosition = dropOffPoint
		end
		if not HS_heightGuidanceOff[cargoName] then
			HS_addHoverGuidance(playerName,{name = 'hover point ' .. dropOffPoint,position = dropOffPosition,minD = 10,maxD = 50,minH = 6,maxH = 10, hoverDuration = 1E6, code = nil, arguments = {}}) -- initialize hover instructions
		else
			HS_addHoverGuidance(playerName,{name = 'hover point ' .. dropOffPoint,position = dropOffPosition,minD = 10,maxD = 50,minH = 0,maxH = 100, hoverDuration = 1E6, code = nil, arguments = {}}) -- initialize hover instructions
		end
		HS_outUnit(playerName,'Drop off ' .. cargoName .. ' at ' .. dropOffPoint,10)
	end
end

HS_cargoPosition = function(cargoName)
	HS_out('blue',cargoName .. ' is at a height of ' .. StaticObject.getPosition(StaticObject.getByName(cargoName)).p.y-land.getHeight(mist.utils.makeVec2(StaticObject.getPosition(StaticObject.getByName(cargoName)).p)),1)
	mist.scheduleFunction(HS_cargoPosition,{cargoName},timer.getTime()+1)
end

HS_addSlingLoad = function(playerName,cargoName,dropOffPoint,uponDelivery)
	HS_slingLoads[cargoName] = {playerName = playerName,cargoName = cargoName,dropOffPoint = dropOffPoint,uponDelivery = uponDelivery}
	-- mist.scheduleFunction(HS_cargoPosition,{cargoName},timer.getTime()+1)
	local coa = HS_getUnitCoalition(playerName)
	HS_onStaticTakeOffDo(cargoName,HS_cargoHasBeenHooked,{playerName,cargoName,StaticObject.getPosition(StaticObject.getByName(cargoName)).p,dropOffPoint}) -- give message when unit takes off
	HS_onStaticTouchDownDo(cargoName,uponDelivery,{playerName,cargoName,dropOffPoint})
	HS_addHoverGuidance(playerName,{name = 'hover point ' .. cargoName,position = StaticObject.getPosition(StaticObject.getByName(cargoName)).p,minD = 2,maxD = 25,minH = 3.5,maxH = 5.5, hoverDuration = 1E6, code = nil, arguments = {}}) -- initialize hover instructions
end

HS = {
	setIncomingAudio = HS_setIncomingAudio,
	setRadioStaticAudio = HS_setRadioStaticAudio,
	setHoverDirectionsAudio = HS_setHoverDirectionsAudio,
	setBeaconAudio = HS_setBeaconAudio,
	setSinkRateAudio = HS_setSinkRateAudio,
	setCargoHookedAudio = HS_setCargoHookedAudio,
	out = HS_out,
	outUnit = HS_outUnit,
	onBecomesActiveDo = HS_onBecomesActiveDo,
	onBecomesInactiveDo = HS_onBecomesInactiveDo,
	addRadioItem = HS_addRadioItem,
	removeRadioItems = HS_removeRadioItems,
	onTouchDownDo = HS_onTouchDownDo,
	onTakeOffDo = HS_onTakeOffDo,
	setBlueCountry = HS_setBlueCountry,
	setRedCountry = HS_setRedCountry,
	addInfantryGroup = HS_addInfantryGroup,
	addGroundGroup = HS_addGroundGroup,
	infantryBattle = HS_infantryBattle,
	tankBattle = HS_tankBattle,
	makeInfantryMove = HS_makeInfantryMove,
	makeInfantryGroupAttack = HS_makeInfantryGroupAttack,
	loadTroops = HS_loadTroops,
	offloadTroops = HS_offloadTroops,
	loadTroopsFromGroup = HS_loadTroopsFromGroup,
	offloadTroopsToGroup = HS_offloadTroopsToGroup,
	groupLoadTroops = HS_groupLoadTroops,
	groupOffloadTroops = HS_groupOffloadTroops,
	groupLoadTroopsFromGroup = HS_groupLoadTroopsFromGroup,
	groupOffloadTroopsToGroup = HS_groupOffloadTroopsToGroup,
	setNumberOfTroopsInCabin = HS_setNumberOfTroopsInCabin,
	getNumberOfTroopsInCabin = HS_getNumberOfTroopsInCabin,
	setNumberOfRescuedPilotsInCabin = HS_setNumberOfRescuedPilotsInCabin,
	getNumberOfRescuedPilotsInCabin = HS_getNumberOfRescuedPilotsInCabin,
	declareAsAI = HS_declareAsAI,
	getUnitCoalition = HS_getUnitCoalition,
	getGroupCoalition = HS_getGroupCoalition,
	getUnitPosition = HS_getUnitPosition,
	getUnit = HS_getUnit,
	getGroup = HS_getGroup,
	isGroupInfantry = HS_isGroupInfantry,
	estimatePresentPosition = HS_estimatePresentPosition,
	addCheckForSmoke = HS_addCheckForSmoke,
	addCheckForFlare = HS_addCheckForFlare,
	friendlyInfantryReleaseFlare = HS_friendlyInfantryReleaseFlare,
	friendlyInfantryReleaseSmoke = HS_friendlyInfantryReleaseSmoke,
	addCheckForIncoming = HS_addCheckForIncoming,
	addBogeyDope = HS_addBogeyDope,
	addCheckForSinkRate = HS_addCheckForSinkRate,
	addReportIAS = HS_addReportIAS,
	stopReportIAS = HS_stopReportIAS,
	generateAirDefence = HS_generateAirDefence,
	addHoverGuidance = HS_addHoverGuidance,
	stopHoverGuidance = HS_stopHoverGuidance,
	flyFighterMission = HS_flyFighterMission,
	flyTransportMission = HS_flyTransportMission,
	flyHelicopterSEADMission = HS_flyHelicopterSEADMission,
	initializeFARP = HS_initializeFARP,
	totalInfantrySize = HS_totalInfantrySize,
	clearADFlist = HS_clearADFlist,
	assignADF = HS_assignADF,
	scheduleMissionRestart = HS_scheduleMissionRestart,
	createNewConvoy = HS_createNewConvoy,
	spotConvoy = HS_spotConvoy,
	spotMechanized = HS_spotMechanized,
	initializeAirfieldList = HS_initializeAirfieldList,
	setAirBattleZone = HS_setAirBattleZone,
	setSEADZone = HS_setSEADZone,
	moveGroup = HS_moveGroup,
	moveGroupToGroup = HS_moveGroupToGroup,
	moveGroupToUnit = HS_moveGroupToUnit,
	addSlingLoad = HS_addSlingLoad,
	howManyGroupsInNeed = HS_howManyGroupsInNeed,
}
