-- initialize mission parameters

numberOfBattles = 5
numberOfTankGroups = 3
numberOfFighterJets = {blue = 12,red = 12}
numberOfTransports = {blue = 6,red = 6}

-- functions used by the mission

-- define sound files

-- HS.setIncomingAudio('incoming.ogg')
HS.setRadioStaticAudio('RadioClickAfter.ogg')
HS.setBeaconAudio('ResKey_advancedFile_178')
-- HS.setSinkRateAudio('sinkRate.ogg')
-- HS.setHoverDirectionsAudio('up.ogg','down.ogg','left.ogg','right.ogg','forward.ogg','back.ogg')
-- HS.setCargoHookedAudio('Hooked.ogg')

-- end define sound files

HS.out('blue','STAND BY WHILE MISSION SCRIPT EXECUTES',30)
-- end initialize ground battle

HS_numberOfBattles = numberOfBattles

local count

for count = 1,numberOfBattles do
	HS.tankBattle(numberOfTankGroups,3,'Tank Battle Zone #' .. count,{blue = 'US Zone #' .. count,red = 'Russian Zone #' .. count})
end

-- initialize air defences

-- HS.generateAirDefence('red',3,'Russian AAA Zone')
-- HS.generateAirDefence('blue',3,'US AAA Zone')

-- end initialize air defences

-- define what happens when units become active

-- initialize AI air superiority fighters

HS.setAirBattleZone('Air Battle Zone')

mist.scheduleFunction(HS.flyFighterMission,{'blue','blue fighter AI Group #1'},timer.getTime()+1)
-- mist.scheduleFunction(HS.flyFighterMission,{'blue','blue fighter AI Group #2'},timer.getTime()+5)
mist.scheduleFunction(HS.flyFighterMission,{'red','red fighter AI Group #1',true},timer.getTime()+10)
-- mist.scheduleFunction(HS.flyFighterMission,{'red','red fighter AI Group #2',true},timer.getTime()+15)

for count = 1,numberOfFighterJets.blue do
	HS.flyFighterMission('blue','blue fighter AI Group #' .. count)
end

for count = 1,numberOfFighterJets.red do
	HS.flyFighterMission('red','red fighter AI Group #' .. count,true)
end

-- initialize AI transport flights

-- for count = 1,numberOfTransports.blue do
	-- mist.scheduleFunction(HS.flyTransportMission,{'blue','Hercules Group #' .. count},timer.getTime()+mist.random(2*60*60))
-- end

-- for count = 1,numberOfTransports.red do
	-- mist.scheduleFunction(HS.flyTransportMission,{'red','Antonov Group #' .. count},timer.getTime()+mist.random(2*60*60))
-- end

-- end initialize AI air superiority fighters

HS.initializeFARP('FARP London')
HS.initializeFARP('FARP Dallas')
HS.initializeFARP('FARP Paris')


-- dump DBs

mist.scheduleFunction(mist.debug.dumpDBs,{},timer.getTime()+10)